<?php

	// CQPIM Admin Functions
	
	function cqpim_register_session(){
	
		if( !session_id() )
		
			session_start();
			
	}
	
	add_action('init','cqpim_register_session');
	
	function cqpim_admin_header() {
	
		$screen = get_current_screen();
		
		if(!empty($screen->post_type)) {
		
			$cpt = get_post_type_object( $screen->post_type );
			
		}
		
		if(strpos($screen->base,'cqpim') !== false || strpos($screen->post_type,'cqpim') !== false) {
	
			$user = wp_get_current_user(); 
			
			$roles = $user->roles;
			
			$roles = array_values($roles);
			
			$role = $roles[0];
			
			$role = str_replace('cqpim', 'CQPIM', $role);
			
			$role = str_replace('_',' ', $role);
			
			$role = ucwords($role);
			
			$user_name = $user->display_name;		
			
			// Gravatar
			
			$email = $user->user_email;
			
			$size = 40;
			
			$grav_url = "https://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "&s=" . $size; ?>
			
			<div class="cqpim_admin_head">
			
				<div class="cqpim_gravatar">
				
					<img src="<?php echo $grav_url; ?>" />
				
				</div>
				
				<div class="cqpim_welcome">

					<h1><?php _e('Welcome Back', 'cqpim'); ?>, <?php echo $user_name; ?></h1>
					
					<span class="cqpim_admin_role task_complete"><?php echo $role; ?></span>
					
				</div>
				
				<div class="clear"></div>
			
			</div>
			
			<div class="cqpim_admin_title">
			
				<?php if($screen->base == 'toplevel_page_cqpim-dashboard') {
				
					echo '<div style="float:left; padding:3px 15px 4px 0">';
				
					_e('Dashboard', 'cqpim');
					
					echo '</div>';
					
					echo '<div class="clear"></div>';
				
				} else {
				
					echo '<div style="float:left; padding:3px 15px 4px 0">';
				
					echo esc_html( get_admin_page_title() ) ;
					
					echo '</div>';
					
					$perm = str_replace('cqpim_', '', $screen->post_type);
					
					$perm = 'cqpim_create_new_' . $perm;
					
					if($perm == 'cqpim_create_new_teams') {
					
						$perm = 'cqpim_create_new_team';
					
					}
					
					if($perm == 'cqpim_create_new_forms') {
					
						$perm = 'cqpim_create_new_form';
					
					}
					
					if(!empty($cpt) && current_user_can($perm)) {
					
						echo '<a class="cqpim_add_post_link" href="' . admin_url() . 'post-new.php?post_type=' . $screen->post_type . '">' . sprintf(__('Add %1$s', 'cqpim'), $cpt->labels->singular_name) . '</a>';
					
					}
					
					if($screen->base == 'cqpim_page_tasks') {
					
						echo '<a class="cqpim_add_post_link" href="' . admin_url() . 'post-new.php?post_type=cqpim_tasks">' . __('Add Task', 'cqpim') . '</a>';					
					
					}
					
					if($screen->base == 'cqpim_page_support-tickets') {
					
						if(current_user_can('cqpim_create_new_supports')) {
					
							echo '<a class="cqpim_add_post_link" href="' . admin_url() . 'post-new.php?post_type=cqpim_support">' . __('Add Ticket', 'cqpim') . '</a>';					
					
						}
					
					}
					
					echo '<div class="clear"></div>';
					
				}?>
			
			</div>
			
	<?php }
	
	}
	
	//add_action( 'admin_menu', 'cqpim_add_admin_menu_separator' );
	function cqpim_add_admin_menu_separator()
	{
		add_submenu_page(
			'cqpim-dashboard',                //parent menu slug to attach to
			"",                          //page title (left blank)
										 //menu title (inserted span with inline CSS)
		   '<span style="display:block;  
			margin:1px 0 1px -5px; 
			padding:0; 
			height:1px; 
			line-height:1px; 
			background:#CCCCCC;"></span>',
			"create_users",              //capability (set to your requirement)
			"#"                          //slug (URL) shows Hash domain.com/# incase of mouse over
		 );
	}
	
	//add_filter( 'custom_menu_order', 'cqpim_submenu_order' );

	function cqpim_submenu_order( $menu_ord ) 
	{
		global $submenu;

		// Enable the next line to inspect the $submenu values
		//echo '<pre style="padding-left:400px">'.print_r($submenu['cqpim-dashboard'],true).'</pre>';

		$arr = array();
		if(!empty($submenu['cqpim-dashboard'][0])) {
			$arr[] = $submenu['cqpim-dashboard'][0];
		}
		if(!empty($submenu['cqpim-dashboard'][1])) {
			$arr[] = $submenu['cqpim-dashboard'][1];
		}
		if(!empty($submenu['cqpim-dashboard'][2])) {
			$arr[] = $submenu['cqpim-dashboard'][2];
		}
		if(!empty($submenu['cqpim-dashboard'][3])) {
			$arr[] = $submenu['cqpim-dashboard'][3];
		}
		if(!empty($submenu['cqpim-dashboard'][12])) {
			$arr[] = $submenu['cqpim-dashboard'][12];
		}
		if(!empty($submenu['cqpim-dashboard'][5])) {
			$arr[] = $submenu['cqpim-dashboard'][5];
		}
		if(!empty($submenu['cqpim-dashboard'][6])) {
			$arr[] = $submenu['cqpim-dashboard'][6];
		}	
		if(!empty($submenu['cqpim-dashboard'][10])) {
			$arr[] = $submenu['cqpim-dashboard'][10];
		}
		if(!empty($submenu['cqpim-dashboard'][8])) {
			$arr[] = $submenu['cqpim-dashboard'][8];
		}	
		if(!empty($submenu['cqpim-dashboard'][14])) {
			$arr[] = $submenu['cqpim-dashboard'][14];
		}
		if(!empty($submenu['cqpim-dashboard'][12])) {
			$arr[] = $submenu['cqpim-dashboard'][12];
		}
		if(!empty($submenu['cqpim-dashboard'][4])) {
			$arr[] = $submenu['cqpim-dashboard'][4];
		}
		if(!empty($submenu['cqpim-dashboard'][15])) {
			$arr[] = $submenu['cqpim-dashboard'][15];
		}
		if(!empty($submenu['cqpim-dashboard'][12])) {
			$arr[] = $submenu['cqpim-dashboard'][12];
		}
		if(!empty($submenu['cqpim-dashboard'][11])) {
			$arr[] = $submenu['cqpim-dashboard'][11];
		}
		if(!empty($submenu['cqpim-dashboard'][7])) {
			$arr[] = $submenu['cqpim-dashboard'][7];
		}
		if(!empty($submenu['cqpim-dashboard'][9])) {
			$arr[] = $submenu['cqpim-dashboard'][9];
		}
		if(!empty($submenu['cqpim-dashboard'][13])) {
			$arr[] = $submenu['cqpim-dashboard'][13];
		}
		if(!empty($submenu['cqpim-dashboard'][16])) {
			$arr[] = $submenu['cqpim-dashboard'][16];
		}
		if(!empty($submenu['cqpim-dashboard'][17])) {
			$arr[] = $submenu['cqpim-dashboard'][17];
		}
		$submenu['cqpim-dashboard'] = $arr;

		return $menu_ord;
	}
	
	add_action('in_admin_header', 'cqpim_admin_header', 10);
	
	function cqpim_admin_head() {
	
		$screen = get_current_screen();
		
		if(strpos($screen->base,'cqpim') !== false || strpos($screen->post_type,'cqpim') !== false) { ?>
		
			<style>			
				#wpcontent {
					margin-left: 140px;
				}
				#wpbody {
					padding-left:20px;
				}
				.wrap h1 {
					display:none;
				}
				.wrap {
					clear:both;
					padding-top:10px;
				}
				@media only screen and (max-width: 960px) {
					#wpbody {
						padding-left:0px;
					}
				}			
			</style>
		
		<?php }
		
	}
	
	add_action('admin_head', 'cqpim_admin_head', 10);
	
	// Allow Email Login
	
	add_filter('authenticate', 'cqpim_allow_email_login', 20, 3);

	function cqpim_allow_email_login( $user, $username, $password ) {
	
		if ( is_email( $username ) ) {
		
			$user = get_user_by('email',  $username );
			
			if ( $user ) $username = $user->user_login;
			
		}
		
		return wp_authenticate_username_password( null, $username, $password );
		
	}

	// Custom page template for cqpim client login & dash
	
	function custom_cqpim_template($page_template) {
		 
		$login_page = get_option('cqpim_login_page');
		
		$dash_page = get_option('cqpim_client_page');
		
		$reset_page = get_option('cqpim_reset_page');
		
		$dash_type = get_option('client_dashboard_type');
		
		if($dash_type == 'inc') {

			if (is_page($login_page)) {
			
				$page_template = dirname( __FILE__ ) . '/templates-inc/login.php';
				  
			}
			
			if (is_page($dash_page)) {
			
				$page_template = dirname( __FILE__ ) . '/templates-inc/client-dashboard.php';
				  
			}
			
			if (is_page($reset_page)) {
			
				$page_template = dirname( __FILE__ ) . '/templates-inc/reset.php';
				  
			}
		
		} else {
		
			if (is_page($login_page)) {
			
				$page_template = dirname( __FILE__ ) . '/templates-fe/login.php';
				  
			}
			
			if (is_page($dash_page)) {
			
				$page_template = dirname( __FILE__ ) . '/templates-fe/client-dashboard.php';
				  
			}	

			if (is_page($reset_page)) {
			
				$page_template = dirname( __FILE__ ) . '/templates-fe/reset.php';
				  
			}				
		
		}
		 
		return $page_template;
		 
	}
	
	add_filter( 'page_template', 'custom_cqpim_template' ); 
	
	add_action( "wp_ajax_nopriv_cqpim_ajax_login", 

			"cqpim_ajax_login");

	add_action( "wp_ajax_cqpim_ajax_login", 

		  	"cqpim_ajax_login");	
	
	function cqpim_ajax_login() {
	
		//check_ajax_referer( 'ajax-login-nonce', 'security' );
		
		$username = isset($_POST['username']) ? $_POST['username'] : '';
		
		$password = isset($_POST['password']) ? $_POST['password'] : '';
		
		$dash_page = get_option('cqpim_client_page');
		
		if(empty($username) || empty($password)) {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> __('Please enter a username and password', 'cqpim'),

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();			
		
		} else {
		
			$creds = array();
			
			$creds['user_login'] = $username;
			
			$creds['user_password'] = $password;
			
			$creds['remember'] = false;
		
			//$login = wp_authenticate($username, $password);
			
			$login = wp_signon( $creds, false );
			
			if(is_wp_error($login)) {
			
				$return =  array( 

					'error' 	=> true,

					'message' 	=> __('Login Failed. Please try again.', 'cqpim'),

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();			
			
			} else {
			
				$roles = $login->roles;
				
				if(in_array('cqpim_client', $roles)) {
				
					$redirect = get_the_permalink($dash_page);
					
				} else {
				
					$redirect = admin_url();
					
				}
			
				$return =  array( 

					'error' 	=> false,
					
					'message' => __('Login Successful. Redirecting to your dashboard.', 'cqpim'),

					'redirect' 	=> $redirect,

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();			
			
			}
		
		}	
	
	}
	
	add_action( "wp_ajax_nopriv_cqpim_ajax_reset", 

			"cqpim_ajax_reset");

	add_action( "wp_ajax_cqpim_ajax_reset", 

		  	"cqpim_ajax_reset");
	
	function cqpim_ajax_reset() {
	
		$username = isset($_POST['username']) ? $_POST['username'] : '';
		
		if(empty($username)) {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> __('You must enter an email address.', 'cqpim'),

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();			
		
		} else {
		
			$user = get_user_by('login', $username);
			
			if(empty($user)) {
			
				$return =  array( 

					'error' 	=> true,

					'message' 	=> __('User not found.', 'cqpim'),

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();				
			
			} else {
			
				$string = RandomString(10);
				
				$hash = md5($string);
				
				update_user_meta( $user->ID, 'reset_hash', $hash );
				
				$reset = get_option('cqpim_reset_page');
				
				$reset = get_the_permalink($reset);
				
				$reset = $reset . '?h=' . $hash;
				
				$to = $user->user_email;
				
				$telephone = get_option('company_telephone');
				
				$sender_name = get_option('company_name');
				
				$sender_email = get_option('company_sales_email');
				
				$subject = get_option('client_password_reset_subject');
				
				$content = get_option('client_password_reset_content');
				
				$content = str_replace('%%CLIENT_NAME%%', $user->display_name, $content);
				
				$content = str_replace('%%PASSWORD_RESET_LINK%%', $reset, $content);
				
				$content = str_replace('%%COMPANY_NAME%%', $sender_name, $content);
				
				$content = str_replace('%%COMPANY_TELEPHONE%%', $telephone, $content);
				
				$content = str_replace('%%COMPANY_SALES_EMAIL%%', $sender_email, $content);
				
				$subject = str_replace('%%COMPANY_NAME%%', $sender_name, $subject);
				
				$headers = array();
				
				$attachments = array();
				
				$headers[] = 'From: ' . $sender_name . ' <' . $sender_email . '>';
				
				$headers[] = 'X-Mailer: PHP/' . phpversion();

				$headers[] = 'X-Originating-IP: ' . $_SERVER['SERVER_ADDR'];
				
				if(wp_mail( $to, $subject, $content, $headers, $attachments )) {
			
					$return =  array( 

						'error' 	=> false,

						'message' 	=> __('Further instructions have been sent to your registered address.', 'cqpim'),

					);
					
					header('Content-type: application/json');
					
					echo json_encode($return);

					exit();	

				} else {
				
					$return =  array( 

						'error' 	=> true,

						'message' 	=> __('The email failed to send. Please try again.', 'cqpim'),

					);
					
					header('Content-type: application/json');
					
					echo json_encode($return);

					exit();					
				
				}
			
			}
		
		}	
	
	}
	
	add_action( "wp_ajax_nopriv_cqpim_ajax_reset_conf", 

			"cqpim_ajax_reset_conf");

	add_action( "wp_ajax_cqpim_ajax_reset_conf", 

		  	"cqpim_ajax_reset_conf");
	
	function cqpim_ajax_reset_conf() {
	
		$hash = isset($_POST['hash']) ? $_POST['hash'] : '';
		
		$pass = isset($_POST['pass']) ? $_POST['pass'] : '';
		
		$pass2 = isset($_POST['pass2']) ? $_POST['pass2'] : '';
		
		if(empty($pass) || empty($pass2)) {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> __('You must fill in both fields.', 'cqpim'),

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();			
		
		} else {
		
			if($pass != $pass2) {
			
				$return =  array( 

					'error' 	=> true,

					'message' 	=> __('Passwords do not match.', 'cqpim'),

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();			
			
			} else {
			
				if (strlen($pass) < 8 || !preg_match("#[0-9]+#", $pass) || !preg_match("#[a-zA-Z]+#", $pass)) {
				
					$return =  array( 

						'error' 	=> true,

						'message' 	=> __('Passwords should be at least 8 characters and should contain at least one letter and one number.', 'cqpim'),

					);
					
					header('Content-type: application/json');
					
					echo json_encode($return);

					exit();					
				
				} else {
				
					$args = array(
					
						'meta_key' => 'reset_hash',
						
						'meta_value' => $hash,
						
						'number' => 1,
					
					);
					
					$users = get_users($args);
					
					if(empty($users[0])) {
					
						$return =  array( 

							'error' 	=> true,

							'message' 	=> __('Invalid User or reset link', 'cqpim'),

						);
						
						header('Content-type: application/json');
						
						echo json_encode($return);

						exit();					
					
					} else {
					
						$user = $users[0];
						
						wp_set_password($pass, $user->ID);
						
						delete_user_meta($user->ID, 'reset_hash');

						$return =  array( 

							'error' 	=> false,

							'message' 	=> __('Your password has been reset, you can now log in with your email address and new password.', 'cqpim'),

						);
						
						header('Content-type: application/json');
						
						echo json_encode($return);

						exit();	
					
					}
				
				}

			}
		
		}	
	
	}
	
	// Do not allow Clients into WP-ADMIN

	! defined( 'ABSPATH' ) AND exit;

	function cqpim_client_no_admin_access() {
	
		$redirect = isset( $_SERVER['HTTP_REFERER'] ) ? $_SERVER['HTTP_REFERER'] : home_url( '/' );
		
		$user = wp_get_current_user();
		
		if ( in_array('cqpim_client', $user->roles) && strpos($_SERVER['PHP_SELF'], '/admin-ajax.php') === false )
			
			exit( wp_redirect( $redirect ) );
			
	}
	
	add_action( 'admin_init', 'cqpim_client_no_admin_access', 100 );

	
	// Hide Admi bar on CQPIM Login and Dash
	
	function cqpim_hide_admin_bar(){
	
		$client_login = get_option('cqpim_login_page');
		
		$client_dash = get_option('cqpim_client_page');
		
		$client_reset = get_option('cqpim_reset_page');
		
		$user = wp_get_current_user();
		
		$roles = $user->roles;
		
		if(is_page($client_login) || is_page($client_dash) || is_page($client_reset) || in_array('cqpim_client', $roles)) {
		
			return false;
		
		} else {
		
			if($user->ID > 0) {
			
				return true;
				
			}
		
		}
		
	}
	
	add_filter( 'show_admin_bar' , 'cqpim_hide_admin_bar');
	
	// Redirect Clients to Client Dashboard on Login
	
	function cqpim_client_login_redirect( $redirect_to, $request, $user ) {
		
		$client_dash = get_option('cqpim_client_page');
		
		if(strpos($request,'?redirect=') !== false) {
		
			$redirect = substr($request, strpos($request, "?redirect"));
		
			$client_dash_link = get_the_permalink($client_dash) . '' . $redirect;		
		
		} else {
		
			$client_dash_link = get_the_permalink($client_dash);
		
		}
		
		$user_dash_link = admin_url() . 'admin.php?page=cqpim-dashboard';
		
		$roles = $user->roles;
		
		if ( isset( $user->roles ) && is_array( $user->roles ) ) {
		
			//check for admins
			
			if ( in_array('administrator', $user->roles ) ) {
			
				// redirect them to the default place
				
				return $redirect_to;
				
			} else if ( in_array('cqpim_admin', $user->roles ) ) {
			
				return $user_dash_link;
				
			} else {
			
				return $redirect_to;
			
			}
			
		} else {
		
			return $redirect_to;
			
		}
		
	}

	add_filter( 'login_redirect', 'cqpim_client_login_redirect', 10, 3 );


	if( function_exists( 'add_image_size' ) ) { 

		// pages which list acts

		add_image_size( 'company-logo', 400, 100, true );
		add_image_size( 'cqpim-login-background', 2000, 1200, true );

	}
	
	// Remove View Link from CPTs
	
	add_filter( 'post_row_actions', 'cqpim_remove_row_actions', 10, 1 );
	

	function cqpim_remove_row_actions( $actions ) {
	
		if( get_post_type() === 'cqpim_teams' ) {
		
			unset( $actions['view'] );
			
			unset($actions['inline hide-if-no-js']);
			
		}
		
		if( get_post_type() === 'cqpim_client' ) {
		
			unset( $actions['view'] );
			
			unset($actions['inline hide-if-no-js']);
			
		}
		
		if( get_post_type() === 'cqpim_quote' ) {
		
			unset( $actions['view'] );
			
			unset($actions['inline hide-if-no-js']);
			
		}
		
		if( get_post_type() === 'cqpim_project' ) {
		
			unset( $actions['view'] );
			
			unset($actions['inline hide-if-no-js']);
			
		}
		
		if( get_post_type() === 'cqpim_project' ) {
		
			unset( $actions['view'] );
			
			unset($actions['inline hide-if-no-js']);
			
		}
		
		if( get_post_type() === 'cqpim_forms' ) {
		
			unset( $actions['view'] );
			
			unset($actions['inline hide-if-no-js']);
			
		}
			
		return $actions;
		
	}
	
	// Edit Team Member email if changed in WP
	
    add_action( 'profile_update', 'cqpim_user_update_profile', 10, 2 );

    function cqpim_user_update_profile( $user_id, $old_user_data ) {
	
		$user = get_userdata( $user_id );
	
		$args = array(
		
			'post_type' => 'cqpim_teams',
			
			'posts_per_page' => -1,
			
			'post_status' => 'private',
			
		);
		
		$team_members = get_posts($args);
		
		foreach($team_members as $member) {
		
			$team_details = get_post_meta($member->ID, 'team_details', true);
			
			if($team_details['user_id'] == $user_id) {
				
				$team_details['team_name'] = $user->display_name;
				
				$team_details['team_email'] = $user->user_email;
				
				$team_details['team_perms'] = $user->roles;
				
				update_post_meta($member->ID, 'team_details', $team_details);
			
			}
		
		}
		
		$args = array(
		
			'post_type' => 'cqpim_client',
			
			'posts_per_page' => -1,
			
			'post_status' => 'private',
			
		);
		
		$clients = get_posts($args);
		
		foreach($clients as $member) {
		
			$team_details = get_post_meta($member->ID, 'client_details', true);
			
			if($team_details['user_id'] == $user_id) {
				
				$team_details['client_contact'] = $user->display_name;
				
				$team_details['client_email'] = $user->user_email;
				
				update_post_meta($member->ID, 'client_details', $team_details);
			
			}
		
		}
        
		
    }	

	// Get client IP
	
	function cqpim_get_client_ip() {
	
		$ipaddress = '';
		
		if (!empty($_SERVER['HTTP_CLIENT_IP']))
		
			$ipaddress = $_SERVER['HTTP_CLIENT_IP'];
			
		else if(!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
		
			$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
			
		else if(!empty($_SERVER['HTTP_X_FORWARDED']))
		
			$ipaddress = $_SERVER['HTTP_X_FORWARDED'];
			
		else if(!empty($_SERVER['HTTP_FORWARDED_FOR']))
		
			$ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
			
		else if(!empty($_SERVER['HTTP_FORWARDED']))
		
			$ipaddress = $_SERVER['HTTP_FORWARDED'];
			
		else if(!empty($_SERVER['REMOTE_ADDR']))
		
			$ipaddress = $_SERVER['REMOTE_ADDR'];
			
		else
		
			$ipaddress = 'UNKNOWN';
			
		return $ipaddress;
		
	}

	// Generate a Random string for Quote / Invoice Passwords

	function RandomString( $length = 10 ) {

		$key = '';

		$keys = array_merge( range(0,9), range('a', 'z') );

		for( $i=0; $i < $length; $i++ ) {

			$key .= $keys[array_rand($keys)];

		}

		return $key;

	}	

	// Default Titles

	add_filter( 'default_title', 'cqpim_set_default_quote_post_title', 10, 2 );

	function cqpim_set_default_quote_post_title( $title, $post ){

		if( $post->post_type == 'cqpim_quote' ){

			$id = $post->ID;

			$title = "%%CLIENT_COMPANY%% - %%TYPE%%: %%QUOTE_REF%%";

			return $title;

		}
		
		if( $post->post_type == 'cqpim_client' ){

			$id = $post->ID;

			$title = '%%CLIENT_COMPANY%%';

			return $title;

		}
		
		if( $post->post_type == 'cqpim_invoice' ){

			$id = $post->ID;

			$title = cqpim_get_invoice_id();

			return $title;

		}
		
		if( $post->post_type == 'cqpim_teams' ){

			$id = $post->ID;

			$title = "%%NAME%%";

			return $title;

		}
		
		if( $post->post_type == 'cqpim_support' ){

			$id = $post->ID;

			$title = "$id";

			return $title;

		}

	}
	
	// No index for Quotes, Projects, Invoices
	
	function no_index_cqpim_types() {
	
		if(is_singular('cqpim_quote') || is_singular('cqpim_project') || is_singular('cqpim_invoice') || is_singular('cqpim_support')) {
		
			echo '<META NAME="ROBOTS" CONTENT="NOINDEX, NOFOLLOW">';
		
		}
	
	}
	
	add_action('wp_head', 'no_index_cqpim_types');
	
	// Replacement Patterns
	
	// Replaces Tags in content/titles/emails with values
	
	function cqpim_replacement_patterns($content, $post_id, $type) {
	
		// Current User
		
		$current_user_tag = '%%CURRENT_USER%%';
		
		$current_user = wp_get_current_user();
      	
		if ( !($current_user instanceof WP_User) )
          
			return;
		
		$current_user = $current_user->display_name;
		
		$content = str_replace($current_user_tag, $current_user, $content);
	
		// Company Tags
	
		$company_name_tag = '%%COMPANY_NAME%%';
		
		$company_number_tag = '%%COMPANY_NUMBER%%';
		
		$company_address_tag = '%%COMPANY_ADDRESS%%';
		
		$company_postcode_tag = '%%COMPANY_POSTCODE%%';
		
		$company_telephone_tag = '%%COMPANY_TELEPHONE%%';
		
		$company_sales_email_tag = '%%COMPANY_SALES_EMAIL%%';
		
		$company_accounts_email_tag = '%%COMPANY_ACCOUNTS_EMAIL%%';
		
		$account_name_tag = '%%ACCOUNT_NAME%%';
		
		$sort_code_tag = '%%SORT_CODE%%';
		
		$account_number_tag = '%%ACCOUNT_NUMBER%%';
		
		$iban_tag = '%%IBAN%%';
		
		// Company Data
		
		$company_name = get_option('company_name');
		
		$company_number = get_option('company_number');
		
		$company_address = get_option('company_address');
		
		$company_postcode = get_option('company_postcode');
		
		$company_telephone = get_option('company_telephone');
		
		$company_sales_email = get_option('company_sales_email');
		
		$company_accounts_email = get_option('company_accounts_email');

		$account_name = get_option('company_bank_name');
		
		$sort_code = get_option('company_bank_sc');
		
		$account_number = get_option('company_bank_ac');
		
		$iban = get_option('company_bank_iban');	

		// Company Replacements
		
		$content = str_replace($company_name_tag, $company_name, $content);
		
		$content = str_replace($company_number_tag, $company_number, $content);
		
		$content = str_replace($company_address_tag, $company_address, $content);
		
		$content = str_replace($company_postcode_tag, $company_postcode, $content);
		
		$content = str_replace($company_telephone_tag, $company_telephone, $content);
		
		$content = str_replace($company_sales_email_tag, $company_sales_email, $content);
		
		$content = str_replace($company_accounts_email_tag, $company_accounts_email, $content);
		
		$content = str_replace($account_name_tag, $account_name, $content);
		
		$content = str_replace($sort_code_tag, $sort_code, $content);
		
		$content = str_replace($account_number_tag, $account_number, $content);
		
		$content = str_replace($iban_tag, $iban, $content);
		
		// Client Tags
		
		$client_name_tag = '%%CLIENT_NAME%%';
		
		$client_company_tag = '%%CLIENT_COMPANY%%';
		
		$client_address_tag = '%%CLIENT_ADDRESS%%';
		
		$client_postcode_tag = '%%CLIENT_POSTCODE%%';
		
		$client_telephone_tag = '%%CLIENT_TELEPHONE%%';
		
		$client_email_tag = '%%CLIENT_EMAIL%%';
		
		$client_ref_tag = '%%CLIENT_REF%%';	
		
		// Client Data
		
		if($type == 'quote') {
		
			$quote_details = get_post_meta($post_id, 'quote_details', true);
			
			$client_id = $quote_details['client_id'];
		
		} elseif($type == 'project') {
		
			$project_details = get_post_meta($post_id, 'project_details', true);
			
			$client_id = $project_details['client_id'];		
		
		} elseif($type == 'invoice') {
		
			$invoice_details = get_post_meta($post_id, 'invoice_details', true);
			
			$client_id = $invoice_details['client_id'];		
		
		} else {
		
			$client_id = $post_id;
			
		}
		
		$client_details = get_post_meta($client_id, 'client_details', true);
			
		$client_ref = isset($client_details['client_ref']) ? $client_details['client_ref'] : '';
		
		$client_company = isset($client_details['client_company']) ? $client_details['client_company'] : '';
		
		$client_name = isset($client_details['client_contact']) ? $client_details['client_contact'] : '';
		
		$client_address = isset($client_details['client_address']) ? $client_details['client_address'] : '';
		
		$client_postcode = isset($client_details['client_postcode']) ? $client_details['client_postcode'] : '';
		
		$client_telephone = isset($client_details['client_telephone']) ? $client_details['client_telephone'] : '';
		
		$client_email = isset($client_details['client_email']) ? $client_details['client_email'] : '';

		// Client Replacements
		
		$content = str_replace($client_name_tag, $client_name, $content);
		
		$content = str_replace($client_company_tag, $client_company, $content);
		
		$content = str_replace($client_address_tag, $client_address, $content);
		
		$content = str_replace($client_postcode_tag, $client_postcode, $content);
		
		$content = str_replace($client_telephone_tag, $client_telephone, $content);
		
		$content = str_replace($client_email_tag, $client_email, $content);
		
		$content = str_replace($client_ref_tag, $client_ref, $content);
		
		if($type == 'task') {
		
			$task_title_tag = '%%TASK_TITLE%%';
			
			$task_status_tag = '%%TASK_STATUS%%';
			
			$task_priority_tag = '%%TASK_PRIORITY%%';
			
			$task_start_tag = '%%TASK_START%%';
			
			$task_end_tag = '%%TASK_DEADLINE%%';
			
			$task_est_tag = '%%TASK_EST%%';
			
			$task_pc_tag = '%%TASK_PC%%';
			
			$task_project_tag = '%%TASK_PROJECT%%';
			
			$task_milestone_tag = '%%TASK_MILESTONE%%';
			
			$task_owner_tag = '%%TASK_OWNER%%';
			
			$task_url_tag = '%%TASK_URL%%';
			
			$task_object = get_post($post_id);
			
			$task_title = $task_object->post_title;
			
			$task_details = get_post_meta($post_id, 'task_details', true);
			
			$task_status = isset($task_details['status']) ? $task_details['status'] : __('N/A', 'cqpim');
			
			$task_status = ucwords($task_status);
			
			$task_priority = isset($task_details['task_priority']) ? $task_details['task_priority'] : __('N/A', 'cqpim');
			
			$task_priority = ucwords($task_priority);
			
			$task_start = isset($task_details['task_start']) ? $task_details['task_start'] : __('N/A', 'cqpim');
			
			if(!empty($task_start)) {
			
				$task_start = date(get_option('cqpim_date_format'), $task_start);
			
			} else {
			
				$task_start = __('N/A', 'cqpim');
			
			}
			
			$deadline = isset($task_details['deadline']) ? $task_details['deadline'] : __('N/A', 'cqpim');
			
			if(!empty($deadline)) {
			
				$deadline = date(get_option('cqpim_date_format'), $deadline);
				
			} else {
			
				$deadline = __('N/A', 'cqpim');
			
			}
			
			$task_est = isset($task_details['task_est_time']) ? $task_details['task_est_time'] : __('N/A', 'cqpim');
			
			$task_pc = isset($task_details['task_pc']) ? $task_details['task_pc'] . '%' : __('N/A', 'cqpim');
			
			$task_owner = get_post_meta($post_id, 'owner', true);
			
			$task_owner = isset($task_owner) ? $task_owner : __('N/A', 'cqpim');
			
			$task_owner = get_post_meta($task_owner, 'team_details', true);
			
			$task_owner = isset($task_owner['team_name']) ? $task_owner['team_name'] : __('N/A', 'cqpim');
			
			$project_id = get_post_meta($post_id, 'project_id', true);
			
			$project_details = get_post_meta($project_id, 'project_details', true);
			
			$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
			
			$project_elements = get_post_meta($project_id, 'project_elements', true);
			
			$milestone_id = get_post_meta($post_id, 'milestone_id', true);
			
			$milestone_name = isset($project_elements[$milestone_id]['title']) ? $project_elements[$milestone_id]['title'] : __('N/A', 'cqpim');
			
			$task_url = get_edit_post_link($task_object);
			
			$content = str_replace($task_title_tag, $task_title, $content);
			
			$content = str_replace($task_status_tag, $task_status, $content);
			
			$content = str_replace($task_priority_tag, $task_priority, $content);
			
			$content = str_replace($task_start_tag, $task_start, $content);
			
			$content = str_replace($task_end_tag, $deadline, $content);
			
			$content = str_replace($task_est_tag, $task_est, $content);
			
			$content = str_replace($task_pc_tag, $task_pc, $content);
			
			$content = str_replace($task_owner_tag, $task_owner, $content);
			
			$content = str_replace($task_project_tag, $project_ref, $content);
			
			$content = str_replace($task_milestone_tag, $milestone_name, $content);
			
			$content = str_replace($task_url_tag, $task_url, $content);
			
			
		}

		// Support Tickets
		
		if($type == 'ticket') {
		
			$ticket_id_tag = '%%TICKET_ID%%';
			
			$ticket_title_tag = '%%TICKET_TITLE%%';
			
			$ticket_status_tag = '%%TICKET_STATUS%%';
			
			$ticket_priority_tag = '%%TICKET_PRIORITY%%';
			
			$ticket_owner_tag = '%%TICKET_OWNER%%';
			
			$ticket_update_tag = '%%TICKET_UPDATE%%';
			
			$ticket_id = $post_id;
			
			$ticket_title = get_the_title($post_id);
			
			$ticket_owner = get_post_meta($post_id, 'ticket_owner', true);
			
			$owner_details = get_post_meta($ticket_owner, 'team_details', true);
			
			$ticket_owner = isset($owner_details['team_name']) ? $owner_details['team_name'] : '';
			
			$ticket_status = get_post_meta($post_id, 'ticket_status', true);
			
			$ticket_status = ucfirst($ticket_status);
			
			$ticket_priority = get_post_meta($post_id, 'ticket_priority', true);
			
			$ticket_priority = ucfirst($ticket_priority);
			
			$content = str_replace($ticket_owner_tag, $ticket_owner, $content);
			
			$content = str_replace($ticket_title_tag, $ticket_title, $content);
			
			$content = str_replace($ticket_id_tag, $ticket_id, $content);
			
			$content = str_replace($ticket_status_tag, $ticket_status, $content);
			
			$content = str_replace($ticket_priority_tag, $ticket_priority, $content);
			
			$ticket_updates = get_post_meta($post_id, 'ticket_updates', true);
			
			$ticket_updates = array_reverse($ticket_updates);
			
			$ticket_update = $ticket_updates[0]['details'];
			
			$content = str_replace($ticket_update_tag, $ticket_update, $content);
		
		}
		
		if($type == 'team') {
		
			$team_name_tag = '%%TEAM_NAME%%';
			
			$team_email_tag = '%%TEAM_EMAIL%%';
			
			$team_telephone_tag = '%%TEAM_TELEPHONE%%';
			
			$team_job_tag = '%%TEAM_JOB%%';
			
			$team_details = get_post_meta($post_id, 'team_details', true);
			
			$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
			
			$team_email = isset($team_details['team_email']) ? $team_details['team_email'] : '';
			
			$team_telephone = isset($team_details['team_telephone']) ? $team_details['team_telephone'] : '';

			$team_job = isset($team_details['team_job']) ? $team_details['team_job'] : '';
			
			$content = str_replace($team_name_tag, $team_name, $content);
		
			$content = str_replace($team_email_tag, $team_email, $content);

			$content = str_replace($team_telephone_tag, $team_telephone, $content);
		
			$content = str_replace($team_job_tag, $team_job, $content);			
		
		}

		if($type == 'quote') {		
		
			// Quote Tags
			
			$quote_ref_tag = '%%QUOTE_REF%%';
			
			$quote_link_tag = '%%QUOTE_LINK%%';
			
			$quote_type_tag = '%%TYPE%%';
			
			$client_login_tag = '%%CQPIM_LOGIN%%';
			
			// Quote Data
			
			$quote_details = get_post_meta($post_id, 'quote_details', true);
			
			$quote_ref = $quote_details['quote_ref'];
			
			$quote_type = $quote_details['quote_type'];
			
			$quote_link = get_the_permalink($post_id);
			
			$quote_object = get_post($post_id);
			
			$quote_password = md5( $quote_object->post_password );
			
			$quote_link = $quote_link . '?pwd=' . $quote_password;
			
			$quote_link2 = get_the_permalink($post_id);
			
			// Quote Replacements
			
			//$content = str_replace($client_login_tag, $quote_link2, $content);
			
			$content = str_replace($quote_ref_tag, $quote_ref, $content);
			
			$content = str_replace($quote_link_tag, $quote_link, $content);
			
			$content = str_replace($quote_type_tag, $quote_type, $content);
		
		}
		
		if($type == 'project') {		
		
			// Project Tags
			
			$contract_link_tag = '%%CONTRACT_LINK%%';
			
			$summary_link_tag = '%%SUMMARY_LINK%%';
			
			$project_ref_tag = '%%PROJECT_REF%%';
			
			$project_type_tag = '%%TYPE%%';
			
			// Project Data
			
			$project_details = get_post_meta($post_id, 'project_details', true);
			
			$project_ref = $project_details['quote_ref'];
			
			$type = isset($project_details['quote_type']) ? $project_details['quote_type'] : '';
			
			$project_link = get_the_permalink($post_id);
			
			$project_object = get_post($post_id);
			
			$project_password = md5( $project_object->post_password );
			
			$contract_link = $project_link . '?pwd=' . $project_password . '&page=contract';
			
			$summary_link = $project_link . '?pwd=' . $project_password . '&page=summary';
			
			// Project Replacements
			
			$content = str_replace($contract_link_tag, $contract_link, $content);
			
			$content = str_replace($summary_link_tag, $summary_link, $content);
			
			$content = str_replace($project_ref_tag, $project_ref, $content);
			
			$content = str_replace($project_type_tag, $type, $content);
		
		}
		
		if($type == 'invoice') {		
		
			// Invoice Tags
			
			$invoice_id_tag = '%%INVOICE_ID%%';
			
			$invoice_link_tag = '%%INVOICE_LINK%%';
			
			// Invoice Data
			
			$invoice_object = get_post($post_id);
			
			$invoice_id = get_post_meta($post_id, 'invoice_id', true);
			
			$invoice_link = get_the_permalink($post_id);
			
			$invoice_password = md5( $invoice_object->post_password );
			
			$invoice_link = $invoice_link . '?pwd=' . $invoice_password;
			
			// Invoice Replacements
			
			$content = str_replace($invoice_id_tag, $invoice_id, $content);
			
			$content = str_replace($invoice_link_tag, $invoice_link, $content);
		
		}
		
		// CQPIM Login
		
		$client_login_tag = '%%CQPIM_LOGIN%%';
		
		$client_login = get_option('cqpim_login_page');
		
		$client_login = get_the_permalink($client_login);
		
		$content = str_replace($client_login_tag, $client_login, $content);
		
		// client Passwords
		
		$client_password_tag = '%%CLIENT_PASSWORD_LINK%%';
		
		$client_password = wp_lostpassword_url( $client_login );
		
		$content = str_replace($client_password_tag, $client_password, $content);
		
		return $content;
	
	}
	
	// Send client Welcome Email 
	
	function send_cqpim_welcome_email($client_id, $password) {
	
		$client_details = get_post_meta($client_id, 'client_details', true);
		
		$email_subject = get_option('auto_welcome_subject');
		
		$email_content = get_option('auto_welcome_content');
		
		$email_subject = cqpim_replacement_patterns($email_subject, $client_id, '');
		
		$email_content = cqpim_replacement_patterns($email_content, $client_id, '');
		
		$email_content = str_replace('%%CLIENT_PASSWORD%%', $password, $email_content);
		
		$to = $client_details['client_email'];
		
		$sender_name = get_option('company_name');
		
		$sender_email = get_option('company_sales_email');
		
		$headers = array();
		
		$attachments = array();
		
		$headers[] = 'From: ' . $sender_name . ' <' . $sender_email . '>';
		
		$headers[] = 'X-Mailer: PHP/' . phpversion();

		$headers[] = 'X-Originating-IP: ' . $_SERVER['SERVER_ADDR'];
		
		wp_mail( $to, $email_subject, $email_content, $headers, $attachments );
	
	}
	
	// Send Team Welcome Email 
	
	function send_cqpim_team_email($team_id, $password) {
	
		$team_details = get_post_meta($team_id, 'team_details', true);
		
		$email_subject = get_option('team_account_subject');
		
		$email_content = get_option('team_account_email');
		
		$email_subject = cqpim_replacement_patterns($email_subject, $team_id, 'team');
		
		$email_content = cqpim_replacement_patterns($email_content, $team_id, 'team');
		
		$email_content = str_replace('%%TEAM_PASSWORD%%', $password, $email_content);
		
		$to = $team_details['team_email'];
		
		$sender_name = get_option('company_name');
		
		$sender_email = get_option('company_sales_email');
		
		$headers = array();
		
		$attachments = array();
		
		$headers[] = 'From: ' . $sender_name . ' <' . $sender_email . '>';
		
		$headers[] = 'X-Mailer: PHP/' . phpversion();

		$headers[] = 'X-Originating-IP: ' . $_SERVER['SERVER_ADDR'];
		
		wp_mail( $to, $email_subject, $email_content, $headers, $attachments );
	
	}
	
	// Create team from ADMIN
	
	add_action( "wp_ajax_nopriv_cqpim_create_team_from_admin", 

			"cqpim_create_team_from_admin");

	add_action( "wp_ajax_cqpim_create_team_from_admin", 

		  	"cqpim_create_team_from_admin");
	
	function cqpim_create_team_from_admin() {
	
		$user_id = $_POST['user_id'];
		
		$user = get_user_by('id', $user_id);
		
		if($user->display_name) {
		
			$new_team_member = array(
			
				'post_type' => 'cqpim_teams',
				
				'post_status' => 'private',
				
				'post_content' => '',
				
				'post_title' => $user->display_name
			
			);
			
			$args = array(
			
				'post_type' => 'cqpim_teams',
				
				'post_status' => 'private',
				
				'posts_per_page' => -1,
				
				'meta_key' => 'admin',
				
				'meta_value' => $user->ID
				
			);
			
			$posts = get_posts($args);
			
			if (empty($posts)){ 
						
				$team_pid = wp_insert_post( $new_team_member );
				
			}
			
			if( ! is_wp_error( $team_pid ) ){	

				update_post_meta($team_pid, 'admin', $user->ID);

				$team_details = array(
				
					'team_name' => $user->display_name,
					
					'team_email' => $user->user_email,
					
					'team_perms' => 'administrator',
					
					'user_id' => $user->ID,
				
				);
				
				update_post_meta($team_pid, 'team_details', $team_details);
				
				$return =  array( 

					'error' 	=> false,

					'message' 	=> ''

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();	

			}
		
		} else {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> ''

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();			
		
		}
	
	}
	
	// Add enctype to forms
	
	add_action('post_edit_form_tag', 'enctype_form_tag');

	function enctype_form_tag(){  

		printf(' enctype="multipart/form-data" encoding="multipart/form-data" ');
		
	}
	
	// custom CPT Template
	
	function cqpim_custom_single_cpt_template($single_template) {
	
		global $post;
		
		$dash_type = get_option('client_dashboard_type');
		
		if($dash_type == 'inc') {

			if ($post->post_type == 'cqpim_support') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-inc/support.php';
				  
			}
			 
			if ($post->post_type == 'cqpim_tasks') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-inc/task.php';
				  
			}
			
			if ($post->post_type == 'cqpim_quote') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-inc/quote.php';
				  
			}
			
			if ($post->post_type == 'cqpim_project') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-inc/project.php';
				  
			}
			
			if ($post->post_type == 'cqpim_invoice') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-inc/invoice.php';
				  
			}
			
			if ($post->post_type == 'attachment') {
			
				$attachment = get_post_meta($post->ID, 'cqpim', true);
				
				if($attachment == true) {
			 
					$single_template = dirname( __FILE__ ) . '/templates-inc/file.php';
				
				}
				  
			}
		
		} else {
		
			if ($post->post_type == 'cqpim_support') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-fe/support.php';
				  
			}
			 
			if ($post->post_type == 'cqpim_tasks') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-fe/task.php';
				  
			}
			
			if ($post->post_type == 'cqpim_quote') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-fe/quote.php';
				  
			}
			
			if ($post->post_type == 'cqpim_project') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-fe/project.php';
				  
			}
			
			if ($post->post_type == 'cqpim_invoice') {
			 
				$single_template = dirname( __FILE__ ) . '/templates-fe/invoice.php';
				  
			}

			if ($post->post_type == 'attachment') {
			
				$attachment = get_post_meta($post->ID, 'cqpim', true);
				
				if($attachment == true) {
			 
					$single_template = dirname( __FILE__ ) . '/templates-fe/file.php';
				
				}
				  
			}			
		
		}
		 
		return $single_template;
		 
	}
	
	add_filter( 'single_template', 'cqpim_custom_single_cpt_template' );
	
	
	
	add_action( 'admin_footer-edit.php', 'cqpim_invoice_bulk_actions' );	
		
	function cqpim_invoice_bulk_actions() {
	
		$screen = get_current_screen();
		
		if($screen->post_type == 'cqpim_invoice') { ?>
		
			<script type="text/javascript">
			
				jQuery(document).ready(function() {
				
					jQuery('<option>').val('mark_paid').text('<?php _e('Mark as Paid', 'cqpim'); ?>')
					
						.appendTo("select[name='action'], select[name='action2']");
						
					jQuery('<option>').val('send_reminders').text('<?php _e('Send Invoice Reminders', 'cqpim'); ?>')
					
						.appendTo("select[name='action'], select[name='action2']");
						
				});
				
			</script>
		
		<?php }
		
		if($screen->post_type == 'cqpim_client') { ?>
		
			<script type="text/javascript">
			
				jQuery(document).ready(function() {
				
					jQuery('option[value="trash"]').remove();
						
				});
				
			</script>		
		
		<?php } 
		
	}
	
	add_action( 'admin_action_mark_paid', 'cqpim_bulk_mark_paid' );
	
	function cqpim_bulk_mark_paid() {
	
		$posts = isset($_REQUEST['post']) ? $_REQUEST['post'] : array();
	
		foreach($posts as $post) {
		
			$totals = get_post_meta($post, 'invoice_totals', true);
			
			$total = isset($totals['total']) ? $totals['total'] : '';
		
			cqpim_mark_invoice_paid($post, '', $total);
		
		}
	
	}
	
	add_action( 'admin_action_mark_unpaid', 'cqpim_bulk_mark_unpaid' );
	
	function cqpim_bulk_mark_unpaid() {
	
		$posts = isset($_REQUEST['post']) ? $_REQUEST['post'] : array();
	
		foreach($posts as $post) {
		
			$details = get_post_meta($post, 'invoice_details', true);
			
			if(!empty($details['paid'])) {
			
				unset($details['paid']);
			
			}
			
			if(!empty($details['paid_details'])) {
			
				unset($details['paid_details']);
				
			}
			
			update_post_meta($post, 'invoice_details', $details);
		
		}
	
	}
	
	add_action( 'admin_action_send_reminders', 'cqpim_bulk_send_reminders' );
	
	function cqpim_bulk_send_reminders() {
	
		$posts = isset($_REQUEST['post']) ? $_REQUEST['post'] : array();
	
		foreach($posts as $post) {
		
			cqpim_send_invoice_reminders($post);
		
		}
	
	}
	
	add_action( "wp_ajax_nopriv_cqpim_filter_calendar", 

			"cqpim_filter_calendar");

	add_action( "wp_ajax_cqpim_filter_calendar", 

		  	"cqpim_filter_calendar");
	
	function cqpim_filter_calendar() {
	
		$filters = isset($_POST['filters']) ? $_POST['filters'] : '';
		
		$_SESSION['cal_filters'] = $filters;	
	
		exit();
	
	}
	
	// Create CQPIM Client action
	
	function cqpim_create_client_from_user($actions, $user_object) {
	
		$actions['add_cqpim_client'] = "<a class='create_client' href='" . admin_url( "users.php?action=create_cqpim_client&amp;user=$user_object->ID") . "'>" . __( 'Convert to CQPIM Client', 'cqpim' ) . "</a>";
		
		return $actions;
		
	}
	
	add_filter('user_row_actions', 'cqpim_create_client_from_user', 10, 2);
	
	add_action('current_screen', 'cqpim_create_client_from_user_callback');
	
	function cqpim_create_client_from_user_callback() {
	
		$screen = get_current_screen();
		
		$base = isset($screen->base) ? $screen->base : '';
		
		$action = isset($_GET['action']) ? $_GET['action'] : '';
		
		if($base == 'users' && $action == 'create_cqpim_client') {
		
			$user_id = isset($_GET['user']) ? $_GET['user'] : '';
			
			$user = get_user_by('id', $user_id);
			
			$new_client = array(
			
				'post_type' => 'cqpim_client',
				
				'post_status' => 'private',
				
				'post_content' => '',
				
				'post_title' => $user->display_name,
			
			);
			
			$client_pid = wp_insert_post( $new_client, true );	

			if( ! is_wp_error( $client_pid ) ){
			
				$client_updated = array(
					
					'ID' => $client_pid,
						
					'post_name' => $client_pid,
						
				);						
			
				wp_update_post( $client_updated );
			
				$client_details = array(
					
					'client_ref' => $client_pid,

					'client_contact' => $user->display_name,
					
					'client_email' => $user->user_email,
				
				);
				
				$client_details['user_id'] = $user_id;
				
				$client_ids = array();
				
				$client_ids[] = $user_id;
				
				update_post_meta($client_pid, 'client_details', $client_details);
				
				update_post_meta($client_pid, 'client_ids', $client_ids);	

				$user_data = array(
				
					'ID' => $user_id,
					
					'role' => 'cqpim_client'
				
				);
				
				wp_update_user($user_data);	

			}
		
		}
	
	}
	
	add_filter( 'post_row_actions', 'cqpim_edit_client_trash_action', 10, 1 );

	function cqpim_edit_client_trash_action( $actions ) {

		if( get_post_type() === 'cqpim_client'  && current_user_can('delete_cqpim_clients')) {
		
			global $post;
		
			$actions['trash'] = '<a class="delete_client" data-id="' . $post->ID . '" href="#">Delete Client</a>'; ?>
			
				<div id="delete_client_warning_container_<?php echo $post->ID; ?>" style="display:none">
				
					<div id="delete_client_warning_<?php echo $post->ID; ?>" class="contact_edit">
					
						<div style="padding:12px">

							<h3><?php _e('Delete Client Warning', 'cqpim'); ?></h3>
							
							<p><?php _e('Deleting this client will also delete the associated user account. If this is not desired then you should first unlink the user account from the client.', 'cqpim'); ?></p>

							<button style="margin-left:0" class="metabox-add-button left uldc" data-id="<?php echo $post->ID; ?>"><?php _e('Unlink User and Delete Client', 'cqpim'); ?></button><button class="metabox-add-button left dcu" data-id="<?php echo $post->ID; ?>"><?php _e('Delete Client and User', 'cqpim'); ?></button>
						
							<div class="clear"></div>
							
							<br />
							
							<div id="client_messages_<?php echo $post->ID; ?>"></div>
							
							<div id="client_spinner_<?php echo $post->ID; ?>" class="ajax_spinner" style="display:none"></div>
						
						</div>
						
					</div>
					
				</div>
			
			<?php
			
		}
		
		return $actions;
		
	}

	add_action( "wp_ajax_cqpim_unlink_delete_client", 

		  	"cqpim_unlink_delete_client");
	
	function cqpim_unlink_delete_client() {
	
		$client_id = isset($_POST['id']) ? $_POST['id'] : '';
		
		if(empty($client_id)) {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> '<span class="task_over">' . __('The Client ID is missing. The client could not be deleted', 'cqpim') . '</span>'

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();
		
		
		} else {
		
			$client_details = get_post_meta($client_id, 'client_details', true);
			
			unset($client_details['user_id']);
			
			update_post_meta($client_id, 'client_details', $client_details);
			
			wp_delete_post($client_id, true);

			$return =  array( 

				'error' 	=> false,

				'message' 	=> '<span class="task_complete">' . __('The user was successfully unlinked and the client was deleted', 'cqpim') . '</span>'

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();
		
		}

	}

	add_action( "wp_ajax_cqpim_delete_client_user_confirm", 

		  	"cqpim_delete_client_user_confirm");
	
	function cqpim_delete_client_user_confirm() {
	
		$client_id = isset($_POST['id']) ? $_POST['id'] : '';
		
		if(empty($client_id)) {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> '<span class="task_over">' . __('The Client ID is missing. The client could not be deleted', 'cqpim') . '</span>'

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();
		
		
		} else {
		
			$client_details = get_post_meta($client_id, 'client_details', true);
			
			$user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
			
			wp_delete_user($user_id);
		
			wp_delete_post($client_id, true);

			$return =  array( 

				'error' 	=> false,

				'message' 	=> '<span class="task_complete">' . __('The user and the client was deleted successfully', 'cqpim') . '</span>'

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);			

			exit();	
			
		}

	}	
	
	function cqpim_get_image_id_by_url ( $url ) {
	
		global $wpdb;
		
		$img_id = 0;
		
			preg_match( '|' . get_site_url() . '|i', $url, $matches );
			
			if ( isset( $matches ) and 0 < count( $matches ) ) {
			
				$url = preg_replace( '/([^?]+).*/', '\1', $url ); 
				
				$guid = preg_replace( '/(.+)-\d+x\d+\.(\w+)/', '\1.\2', $url );
				
				$img_id = $wpdb->get_var( $wpdb->prepare( "SELECT `ID` FROM $wpdb->posts WHERE `guid` = '%s'", $guid ) );
				
			if ( $img_id ) {
			
				$img_id = intval( $img_id );
				
			}
			
		}
		
		return $img_id;
		
	}
	
	function cqpim_upload_dir( $dirs ) {
		$dirs['subdir'] = '/cqpim-uploads';
		$dirs['path'] = $dirs['basedir'] . '/cqpim-uploads';
		$dirs['url'] = $dirs['baseurl'] . '/cqpim-uploads';

		return $dirs;
	}


	function upload_user_file( $file = array(), $project_id ) {

		require_once( ABSPATH . 'wp-admin/includes/admin.php' );
		
		add_filter( 'upload_dir', 'cqpim_upload_dir' );	

		$file_return = wp_handle_upload( $file, array('test_form' => false ) );

		if( isset( $file_return['error'] ) || isset( $file_return['upload_error_handler'] ) ) {
		
			return false;
			
		} else {

			$filename = $file_return['file'];

			$attachment = array(
				'post_mime_type' => $file_return['type'],
				'post_title' => preg_replace( '/\.[^.]+$/', '', basename( $filename ) ),
				'post_content' => '',
				'post_parent' => $project_id,
				'post_status' => 'inherit',
				'guid' => $file_return['url']
			);

			$attachment_id = wp_insert_attachment( $attachment, $file_return['url'] );

			require_once(ABSPATH . 'wp-admin/includes/image.php');
			$attachment_data = wp_generate_attachment_metadata( $attachment_id, $filename );
			wp_update_attachment_metadata( $attachment_id, $attachment_data );

			if( 0 < intval( $attachment_id ) ) {
				return $attachment_id;
			}
		}
		
		remove_filter( 'upload_dir', 'cqpim_upload_dir' );	

		return false;
	}
	
	// Delete team user when member is deleted

	add_action( 'before_delete_post', 'cqpim_delete_team_user' );

	function cqpim_delete_team_user( $post_id ){
		
		global $post_type;   
		
		if ( $post_type != 'cqpim_teams' ) return;
		
		require_once(ABSPATH.'wp-admin/includes/user.php' );
		
		$team_details = get_post_meta($post_id, 'team_details', true);
		
		$wp_user_id = $team_details['user_id'];
		
		$user = get_user_by('id', $wp_user_id);
		
		if(!in_array('administrator', $user->roles)) {
		
			wp_delete_user($wp_user_id);
		
		}
		
	}
	
	function cqpim_is_edit_page($new_edit = null){
	
		global $pagenow;
		
		if (!is_admin()) return false;


		if($new_edit == "edit")
		
			return in_array( $pagenow, array( 'post.php',  ) );
			
		elseif($new_edit == "new")
		
			return in_array( $pagenow, array( 'post-new.php' ) );
			
		else
		
			return in_array( $pagenow, array( 'post.php', 'post-new.php' ) );
			
	}
	
	// Control post visibility on every save 
	
	add_action( 'edit_post', 'cqpim_assign_post_visibility' );

	function cqpim_assign_post_visibility( $post_id ){	
	
		$post = get_post($post_id);
		
		$password = isset($post->post_password) ? $post->post_password : '';
		
		if(empty($password)) {
		
			$password = RandomString(10);
			
		}
		
		if($post->post_status != 'trash' && $post->post_status != 'draft') {
		
			if($post->post_type == 'cqpim_invoice' || $post->post_type == 'cqpim_tasks') {
			
				$post_updated = array(
				
					'ID' => $post_id,
					
					'post_status' => 'publish',
					
					'post_password' => $password,
				
				);
			
				if ( ! wp_is_post_revision( $post_id ) ){
					
					remove_action('edit_post', 'cqpim_assign_post_visibility');
					
					wp_update_post( $post_updated );

					add_action('edit_post', 'cqpim_assign_post_visibility');
					
				}			
				
			}
			
			if($post->post_type == 'cqpim_templates' || $post->post_type == 'cqpim_quote' || $post->post_type == 'cqpim_terms' || $post->post_type == 'cqpim_forms' || $post->post_type == 'cqpim_project' || $post->post_type == 'cqpim_client' || $post->post_type == 'cqpim_teams' || $post->post_type == 'cqpim_support') {
			
				$post_updated = array(
				
					'ID' => $post_id,
					
					'post_status' => 'private',
				
				);
			
				if ( ! wp_is_post_revision( $post_id ) ){
					
					remove_action('edit_post', 'cqpim_assign_post_visibility');
					
					wp_update_post( $post_updated );

					add_action('edit_post', 'cqpim_assign_post_visibility');
					
				}			
			
			}

		}
	
	}
	

	add_action( "wp_ajax_nopriv_cqpim_verify_purchase_code", 

			"cqpim_verify_purchase_code");

	add_action( "wp_ajax_cqpim_verify_purchase_code", 

		  	"cqpim_verify_purchase_code");

	function cqpim_verify_purchase_code() {

		$post = isset($_POST) ? $_POST : '';
		
		$code = isset($post['code']) ? $post['code'] : '';
		
		$verify = isset($post['verify']) ? $post['verify'] : '';
		
		if(!empty($verify)) {
		
			$verify = '&verify=true';
			
		}
		
		$url = site_url();

		$url = "http://ec2-52-16-36-13.eu-west-1.compute.amazonaws.com/cqpim/activate.php?code=$code&url=$url$verify";	
		
		$ch = curl_init($url);
		
		curl_setopt($ch, CURLOPT_POST, 1);
		
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		
		curl_setopt($ch, CURLOPT_USERAGENT, 'ENVATO-PURCHASE-VERIFY');
		
//		$json_res = curl_exec($ch);	
$code = '2b35dec6-5674-314f-5d8d-9fe900dc03b8';
$details->buyer = "Nulled";
$details->licence = $code;
$details->created_at = date("F j, Y, g:i a"); ;
$details->supported_until = date('F j, Y, g:i a',strtotime(date("F j, Y, g:i a", mktime()) . " + 365 day"));
$json_res = json_encode($details); 		
		curl_close($ch);
		
		if(!empty($json_res)){
		
				if($json_res == 'DUPLICATE') {
				
				$return =  array( 

					'error' 	=> false,

					'message' 	=> 'Duplicate Activation. You can only activate on one WordPress site.',

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();					
				
				} else {
		
				$purchase_details = json_decode($json_res);
		
				update_option('cqpim_purchase_code', $code);
				
				update_option('wordpress_settings_48njgknjg6745hjdjhjshbhgjf', 'ACTIVE');
				
				update_option('cqpim_purchase_details', $purchase_details);
		
				$return =  array( 

					'error' 	=> false,

					'message' 	=> 'Purchase Code Confirmed',

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();	
				
				}
				
		}else{
				$return =  array( 

					'error' 	=> true,

					'message' 	=> 'INVALID PURCHASE CODE',

				);
				
				header('Content-type: application/json');
				
				echo json_encode($return);

				exit();	
				
		}

	}

	add_action( "wp_ajax_nopriv_cqpim_remove_purchase_code", 

			"cqpim_remove_purchase_code");

	add_action( "wp_ajax_cqpim_remove_purchase_code", 

		  	"cqpim_remove_purchase_code");

	function cqpim_remove_purchase_code() {
	
		$code = isset($_POST['code']) ? $_POST['code'] : '';
		
		$url = site_url();

		$url = "http://ec2-52-16-36-13.eu-west-1.compute.amazonaws.com/cqpim/deactivate.php?code=$code";	
		
		$ch = curl_init($url);
		
		curl_setopt($ch, CURLOPT_POST, 1);
		
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		
		curl_setopt($ch, CURLOPT_USERAGENT, 'ENVATO-PURCHASE-VERIFY');
		
		$json_res = curl_exec($ch);	
		
		curl_close($ch);
		
		if($json_res == 'DONE') {

			delete_option('cqpim_purchase_code');
			
			delete_option('wordpress_settings_48njgknjg6745hjdjhjshbhgjf');
			
			delete_option('cqpim_purchase_details');
			
			$return =  array( 

				'error' 	=> false,

				'message' 	=> 'Purchase Code Successfully Removed',

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();
		
		} else {
		
			$return =  array( 

				'error' 	=> false,

				'message' 	=> 'Deactivation was not successful, please try again.',

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();		
		
		}

	}
	
	function cqpim_admin_notice() {
		
		$settings = get_option('wordpress_settings_48njgknjg6745hjdjhjshbhgjf');
		
		if(empty($settings)) {
		
		?>
		<div class="updated">
			<p><?php _e( 'You need to add your Envato Purchase Code to use CQPIM. Please go to the CQPIM Plugin Activation Page. Settings are disabled.', 'cqpim' ); ?></p>
		</div>
		<br />
		<?php }
	}
	add_action( 'admin_notices', 'cqpim_admin_notice' );
	
	add_action('cqpim_check_email_pipe', 'cqpim_check_email_pipe_minute');
	
	function cqpim_check_email_pipe_minute() {
	
		$mail_server = '{' . get_option('cqpim_mail_server') . '}';
		$mailbox_name = get_option('cqpim_mailbox_name');
		$mailbox_pass = get_option('cqpim_mailbox_pass');

		require_once(realpath(dirname(__FILE__)) . '/assets/php-imap/src/PhpImap/IncomingMail.php');
		require_once(realpath(dirname(__FILE__)) . '/assets/php-imap/src/PhpImap/Mailbox.php');
		
		$dirs = wp_upload_dir();
		
		$mailbox = new PhpImap\Mailbox($mail_server, $mailbox_name, $mailbox_pass, $dirs['basedir'] . '/cqpim-uploads');
		
		$mailsIds = $mailbox->searchMailbox('UNSEEN');
		
		if(!$mailsIds) {
		
			die('Mailbox is empty');
			
		}
		
		$delete = get_option('cqpim_piping_delete');
		
		foreach($mailsIds as $key => $message) {
	
			$mail = $mailbox->getMail($message);
			
			$attached_media = $mail->getAttachments();
			
			$body = $mail->textPlain;
			$fromName = $mail->fromName;
			$toName = $mail->toString;
			$toEmail = $mail->to;
			$fromEmail = $mail->fromAddress;
			$subject = $mail->subject;	
			$subject_full = $mail->subject;
			
			// Remove the original message

			$body_array = explode("\n",$mail->textPlain);
			$content = "";
			foreach($body_array as $key => $value){
				if($value == "_________________________________________________________________"){
					break;
				} elseif(preg_match("/^-*(.*)Original Message(.*)-*/i",$value,$matches)){
					break;
				} elseif(preg_match("/^On(.*)wrote:(.*)/i",$value,$matches)) {
					break;
				} elseif(preg_match("/^On(.*)$fromName(.*)/i",$value,$matches)) {
					break;
				} elseif(preg_match("/^On(.*)$toName(.*)/i",$value,$matches)) {
					break;
				} elseif(preg_match("/^(.*)$toEmail(.*)wrote:(.*)/i",$value,$matches)) {
					break;
				} elseif(preg_match("/^(.*)$fromEmail(.*)wrote:(.*)/i",$value,$matches)) {
					break;
				} elseif(preg_match("/^>(.*)/i",$value,$matches)){
					break;
				} elseif(preg_match("/^---(.*)On(.*)wrote:(.*)/i",$value,$matches)){
					break;
				} else {
					$content .= "$value\n";
				}
						
			}

			// Get the ID of the item	
			
			preg_match("/\[(.*?)\]/", $subject, $subject);	
			
			$subject = $subject[1];
			
			$post_id = preg_replace('/[^0-9]/','', $subject);
			
			// Get the Item
			
			$attachments = array();
			
			if(empty($post_id)) {
			
				// This is where we create a new ticket, but only for registered
				
				$value = get_option('cqpim_create_support_on_email');
				
				if(!empty($value)) {
				
					$item_type = _e('support ticket', 'cqpim');
					
					$user = get_user_by('email', $fromEmail);
					
					if(empty($user)) {
					
						$value = get_option('cqpim_send_piping_reject');
						
						if(!empty($value)) {
					
							cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
						
						}
						
						$mailbox->markMailAsRead($message);
						
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
						break;
					
					}
					
					$args = array(
					
						'post_type' => 'cqpim_client',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private'
					
					);
					
					$members = get_posts($args);
					
					foreach($members as $member) {
					
						$team_details = get_post_meta($member->ID, 'client_details', true);
						
						if($team_details['user_id'] == $user->ID) {
						
							$assigned = $member->ID;
							
							$client_type = 'admin';
						
						}
						
						if($team_details['client_email'] == $fromEmail) {
						
							$valid = true;
						
						}
					
					} 
					
					if(empty($assigned)) {
					
						foreach($members as $member) {
						
							$team_ids = get_post_meta($member->ID, 'client_ids', true);
							
							$client_contacts = get_post_meta($post->ID, 'client_contacts', true);
							
							if(in_array($user->ID, $team_ids)) {
							
								$assigned = $member->ID;
								
								$client_type = 'contact';
							
							}
							
							if(empty($client_contacts)) {
							
								$client_contacts = array();
								
							}
							
							foreach($client_contacts as $contact) {
							
								if($contact['email'] == $fromEmail) {
								
									$valid = true;
								
								}
							
							}
						
						} 			
					
					}

					if(empty($valid)) {
					
						$value = get_option('cqpim_send_piping_reject');
						
						if(!empty($value)) {
					
							cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
						
						}
						
						$mailbox->markMailAsRead($message);
						
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
						break;					
					
					}	

					$title = isset($subject_full) ? $subject_full : __('Email ticket', 'cqpim');
					
					$priority = 'normal';
					
					$details = $content;
					
					$client_object_id = $assigned;
					
					$ticket_status = 'open';
					
					$client_details = get_post_meta($client_object_id, 'client_details', true);
				
					$new_ticket = array(
					
						'post_type' => 'cqpim_support',
						
						'post_status' => 'private',
						
						'post_content' => '',
						
						'post_title' => $title,
						
						'post_author' => $user->ID,				
					
					);
					
					$ticket_pid = wp_insert_post( $new_ticket, true );
					
					if( ! is_wp_error( $ticket_pid ) ){
					
						$ticket_updated = array(
							
							'ID' => $ticket_pid,
								
							'post_name' => $ticket_pid,
								
						);						
					
						wp_update_post( $ticket_updated );	
						
						if(!empty($attached_media)) {
						
							$allowed = get_option('cqpim_allowed_extensions');
							
							$allowed = explode(',', $allowed);
						
							$ticket_changes = array();
							
							$i = 0;
						
							foreach($attached_media as $file) {
							
								$extension = pathinfo($file->name, PATHINFO_EXTENSION);

								if(!in_array(strtolower($extension), $allowed)){
									break;
								}									
								
								$filename = $file->filePath;
								
								$filename = substr($filename, strrpos($filename, '/') + 1);

								$attachment = array(
									'post_mime_type' => $extension,
									'post_title' => $file->name,
									'post_content' => '',
									'post_parent' => $ticket_pid,
									'post_status' => 'publish',
									'guid' => $dirs['baseurl'] . '/cqpim-uploads/' . $filename,
									'post_owner' => $user->ID
								);

								$attachment_id = wp_insert_attachment( $attachment, $dirs['baseurl'] . '/cqpim-uploads/' . $filename );	

								require_once(ABSPATH . 'wp-admin/includes/image.php');
								
								$attachment_data = wp_generate_attachment_metadata( $attachment_id, $file->filePath );
								
								wp_update_attachment_metadata( $attachment_id, $attachment_data );			
																	
								$attachment_obj = wp_get_attachment_metadata( $attachment );
								
								update_post_meta($attachment_id, 'cqpim', true);
								
								$attachment = get_post($attachment_id);
								
								$filename = $attachment->post_title;
								
								$ticket_changes[] = sprintf(__('Uploaded file: %1$s', 'cqpim'), $filename);	
							
								$i++;
								
								$attachments[] = $file->filePath;
							
							}
						
						}

						update_post_meta($ticket_pid, 'ticket_client', $client_object_id);
						
						update_post_meta($ticket_pid, 'ticket_status', $ticket_status);
						
						$ticket_updates = array();
						
						$ticket_updates[] = array(
						
							'details' => $details,
							
							'time' => current_time('timestamp'),
							
							'name' => $user->display_name,
							
							'email' => $user->user_email,
							
							'user' => $client_object_id,
							
							'type' => 'client',
							
							'changes' => $ticket_changes
							
						);
						
						update_post_meta($ticket_pid, 'ticket_updates', $ticket_updates);
						
						update_post_meta($ticket_pid, 'ticket_priority', $priority);
						
						if(!empty($client_details['ticket_assignee'])) {
						
							update_post_meta($ticket_pid, 'ticket_owner', $client_details['ticket_assignee']);
							
						}
						
						$last_updated = current_time('timestamp');
						
						update_post_meta($ticket_pid, 'last_updated', $last_updated);

						$headers = array();
						
						$sender_name = get_option('company_name');
						
						$sender_name = $sender_name;
					
						$sender_email = get_option('company_support_email');
						
						$to = array();
						
						$to[] = $sender_email;
						
						if(!empty($client_details['ticket_assignee'])) {
						
							$assignee_details = get_post_meta($client_details['ticket_assignee'], 'team_details', true);
							
							if(!empty($assignee_details['team_email'])) {
							
								$to[] = $assignee_details['team_email'];
							
							}
							
						}				
					
						$headers[] = 'From: ' . $sender_name . ' <' . $sender_email . '>';
					
						$headers[] = 'X-Mailer: PHP/' . phpversion();

						$headers[] = 'X-Originating-IP: ' . $_SERVER['SERVER_ADDR'];
						
						$value = get_option('cqpim_piping_address');
						
						if(!empty($value)) {
						
							$headers[] = 'Reply-to: ' . $value;
						
						}
						
						if($priority == 'high' || $priority == 'immediate') {
						
							add_filter('phpmailer_init','update_priority_mailer');
						
						}

						$email_subject = get_option('client_create_ticket_subject');
						
						$email_content = get_option('client_create_ticket_email');
						
						$email_subject = str_replace('%%PIPING_ID%%', '[' . get_option('cqpim_string_prefix') . ':' . $ticket_pid . ']', $email_subject);
						
						$email_subject = str_replace('%%CLIENT_NAME%%', $user->display_name, $email_subject);
						
						$email_content = str_replace('%%CLIENT_NAME%%', $user->display_name, $email_content);				
						
						$email_subject = cqpim_replacement_patterns($email_subject, $client_object_id, 'client');
						
						$email_subject = cqpim_replacement_patterns($email_subject, $ticket_pid, 'ticket');
						
						$email_content = cqpim_replacement_patterns($email_content, $client_object_id, 'client');
						
						$email_content = cqpim_replacement_patterns($email_content, $ticket_pid, 'ticket');
						
						foreach($to as $recip) {
						
							wp_mail($recip, $email_subject, $email_content, $headers, $attachments);

						}
						
						$mailbox->markMailAsRead($message);
						
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}

						exit;					
					
					}
				
				} else {
				
					$mailbox->markMailAsRead($message);
					
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
				
					exit;
					
				}
					
			
			}
			
			$post = get_post($post_id);
			
			if(empty($post)) {
			
				die('No post');
				
			}
			
			$post_type = $post->post_type;
			
			if($post_type == 'cqpim_support') {
			
				$item_type = _e('support ticket', 'cqpim');
			
				$user = get_user_by('email', $fromEmail);
				
				if(empty($user)) {
				
					$value = get_option('cqpim_send_piping_reject');
					
					if(!empty($value)) {
				
						cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
					
					}
					
					$mailbox->markMailAsRead($message);
					
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
				
					exit;
				
				}
				
				foreach($user->roles as $role) {
				
					if($role == 'cqpim_client') {
					
						$type = 'client';
						
					} else {
					
						$type = 'team';
						
					}
				
				}

				if($type == 'client') {
				
					$args = array(
					
						'post_type' => 'cqpim_client',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private'
					
					);
					
					$members = get_posts($args);
					
					foreach($members as $member) {
					
						$team_details = get_post_meta($member->ID, 'client_details', true);
						
						if($team_details['user_id'] == $user->ID) {
						
							$assigned = $member->ID;
							
							$client_type = 'admin';
						
						}
						
						if($team_details['client_email'] == $fromEmail) {
						
							$valid = true;
						
						}
					
					} 
					
					if(empty($assigned)) {
					
						foreach($members as $member) {
						
							$team_ids = get_post_meta($member->ID, 'client_ids', true);
							
							$client_contacts = get_post_meta($post->ID, 'client_contacts', true);
							
							if(in_array($user->ID, $team_ids)) {
							
								$assigned = $member->ID;
								
								$client_type = 'contact';
							
							}
							
							if(empty($client_contacts)) {
							
								$client_contacts = array();
								
							}
							
							foreach($client_contacts as $contact) {
							
								if($contact['email'] == $fromEmail) {
								
									$valid = true;
								
								}
							
							}
						
						} 			
					
					}
					
					if(empty($valid)) {
					
						$value = get_option('cqpim_send_piping_reject');
						
						if(!empty($value)) {
					
							cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
						
						}
						
						$mailbox->markMailAsRead($message);
						
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
						exit;					
					
					}
					
					if(!empty($attached_media)) {
					
						$allowed = get_option('cqpim_allowed_extensions');
						
						$allowed = explode(',', $allowed);
					
						$ticket_changes = array();
						
						$i = 0;
					
						foreach($attached_media as $file) {
						
							$extension = pathinfo($file->name, PATHINFO_EXTENSION);

							if(!in_array(strtolower($extension), $allowed)){
								break;
							}									
							
							$filename = $file->filePath;
							
							$filename = substr($filename, strrpos($filename, '/') + 1);

							$attachment = array(
								'post_mime_type' => $extension,
								'post_title' => $file->name,
								'post_content' => '',
								'post_parent' => $post->ID,
								'post_status' => 'publish',
								'guid' => $dirs['baseurl'] . '/cqpim-uploads/' . $filename,
								'post_owner' => $user->ID
							);

							$attachment_id = wp_insert_attachment( $attachment, $dirs['baseurl'] . '/cqpim-uploads/' . $filename );	

							require_once(ABSPATH . 'wp-admin/includes/image.php');
							
							$attachment_data = wp_generate_attachment_metadata( $attachment_id, $file->filePath );
							
							wp_update_attachment_metadata( $attachment_id, $attachment_data );			
																
							$attachment_obj = wp_get_attachment_metadata( $attachment );
							
							update_post_meta($attachment_id, 'cqpim', true);
							
							$attachment = get_post($attachment_id);
							
							$filename = $attachment->post_title;
							
							$ticket_changes[] = sprintf(__('Uploaded file: %1$s', 'cqpim'), $filename);	
						
							$i++;
							
							$attachments[] = $file->filePath;
						
						}
					
					}
					
					$status = get_post_meta($post_id, 'ticket_status', true);	
					
					$priority = get_post_meta($post_id, 'ticket_priority', true);
					
					$owner = get_post_meta($post_id, 'ticket_owner', true);
					
					$watchers = get_post_meta($post_id, 'ticket_watchers', true);
					
					$data = array(
					
						'ticket_update_new' => $content,
						
						'ticket_priority_new' => $priority,
						
						'ticket_status_new' => $status,
						
						'ticket_owner' => $owner,
						
						'task_watchers' => $watchers,
						
						'ticket_changes' => $ticket_changes,
					
					);
					
					$files = array();
					
					cqpim_update_support_ticket($post_id, $data, $files, 'client', $user, $attachments);
					
					$mailbox->markMailAsRead($message);
					
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
				}				
				
				if($type == 'team') {
				
					$args = array(
					
						'post_type' => 'cqpim_teams',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private'
					
					);
					
					$members = get_posts($args);
					
					foreach($members as $member) {
					
						$team_details = get_post_meta($member->ID, 'team_details', true);
						
						if($team_details['user_id'] == $user->ID) {
						
							$assigned = $member->ID;
							
							$client_type = 'admin';
						
						}
						
						if($team_details['team_email'] == $fromEmail) {
						
							$valid = true;
						
						}
					
					} 
					
					if(empty($valid)) {
					
						$value = get_option('cqpim_send_piping_reject');
						
						if(!empty($value)) {
					
							cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
						
						}
						
						$mailbox->markMailAsRead($message);
						
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
						exit;					
					
					}
					
					if(!empty($attached_media)) {
					
						$allowed = get_option('cqpim_allowed_extensions');
						
						$allowed = explode(',', $allowed);
					
						$ticket_changes = array();
						
						$i = 0;
					
						foreach($attached_media as $file) {
						
							$extension = pathinfo($file->name, PATHINFO_EXTENSION);

							if(!in_array(strtolower($extension), $allowed)){
								break;
							}									
							
							$filename = $file->filePath;
							
							$filename = substr($filename, strrpos($filename, '/') + 1);

							$attachment = array(
								'post_mime_type' => $extension,
								'post_title' => $file->name,
								'post_content' => '',
								'post_parent' => $post->ID,
								'post_status' => 'publish',
								'guid' => $dirs['baseurl'] . '/cqpim-uploads/' . $filename,
								'post_owner' => $user->ID
							);

							$attachment_id = wp_insert_attachment( $attachment, $dirs['baseurl'] . '/cqpim-uploads/' . $filename );	

							require_once(ABSPATH . 'wp-admin/includes/image.php');
							
							$attachment_data = wp_generate_attachment_metadata( $attachment_id, $file->filePath );
							
							wp_update_attachment_metadata( $attachment_id, $attachment_data );			
																
							$attachment_obj = wp_get_attachment_metadata( $attachment );
							
							update_post_meta($attachment_id, 'cqpim', true);
							
							$attachment = get_post($attachment_id);
							
							$filename = $attachment->post_title;
							
							$ticket_changes[] = sprintf(__('Uploaded file: %1$s', 'cqpim'), $filename);	
						
							$i++;
							
							$attachments[] = $file->filePath;
						
						}
					
					}
					
					$status = get_post_meta($post_id, 'ticket_status', true);	
					
					$priority = get_post_meta($post_id, 'ticket_priority', true);
					
					$owner = get_post_meta($post_id, 'ticket_owner', true);
					
					$watchers = get_post_meta($post_id, 'ticket_watchers', true);
					
					$data = array(
					
						'ticket_update_new' => $content,
						
						'ticket_priority_new' => $priority,
						
						'ticket_status_new' => $status,
						
						'ticket_owner' => $owner,
						
						'task_watchers' => $watchers,
						
						'ticket_changes' => $ticket_changes
					
					);
					
					$files = array();
					
					cqpim_update_support_ticket($post_id, $data, $files, 'admin', $user, $attachments);
					
					$mailbox->markMailAsRead($message);
					
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
				}				
		
			}

			if($post_type == 'cqpim_tasks') {

				$item_type = _e('task', 'cqpim');
			
				$user = get_user_by('email', $fromEmail);
				
				if(empty($user)) {
				
					$value = get_option('cqpim_send_piping_reject');
					
					if(!empty($value)) {
				
						cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
					
					}
					
					$mailbox->markMailAsRead($message);
					
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
				
					exit;
				
				}
				
				foreach($user->roles as $role) {
				
					if($role == 'cqpim_client') {
					
						$type = 'client';
						
					} else {
					
						$type = 'team';
						
					}
				
				}

				if($type == 'client') {
				
					$args = array(
					
						'post_type' => 'cqpim_client',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private'
					
					);
					
					$members = get_posts($args);
					
					foreach($members as $member) {
					
						$team_details = get_post_meta($member->ID, 'client_details', true);
						
						if($team_details['user_id'] == $user->ID) {
						
							$assigned = $member->ID;
							
							$client_type = 'admin';
						
						}
						
						if($team_details['client_email'] == $fromEmail) {
						
							$valid = true;
						
						}
					
					} 
					
					if(empty($assigned)) {
					
						foreach($members as $member) {
						
							$team_ids = get_post_meta($member->ID, 'client_ids', true);
							
							$client_contacts = get_post_meta($post->ID, 'client_contacts', true);
							
							if(in_array($user->ID, $team_ids)) {
							
								$assigned = $member->ID;
								
								$client_type = 'contact';
							
							}
							
							if(empty($client_contacts)) {
							
								$client_contacts = array();
								
							}
							
							foreach($client_contacts as $contact) {
							
								if($contact['email'] == $fromEmail) {
								
									$valid = true;
								
								}
							
							}
						
						} 			
					
					}
					
					if(empty($valid)) {
					
						$value = get_option('cqpim_send_piping_reject');
						
						if(!empty($value)) {
					
							cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
						
						}
						
						$mailbox->markMailAsRead($message);
						
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
						exit;					
					
					}
					
					update_post_meta($post_id, 'client_updated', false);
					
					$project_id = get_post_meta($post_id, 'project_id', true);
					
					$task_watchers = get_post_meta($post_id, 'task_watchers', true);
					
					$task_owner = get_post_meta($post_id, 'owner', true);
					
					$project_progress = get_post_meta($project_id, 'project_progress', true);
					
					$task_object = get_post($post_id);
					
					$task_title = $task_object->post_title;
					
					$text = sprintf(__('Task Updated: %1$s'), $task_title );
									
					$project_progress[] = array(
									
						'update' => $text,
										
						'date' => current_time('timestamp'),
								
						'by' => $user->display_name
										
					);
									
					update_post_meta($project_id, 'project_progress', $project_progress );	

					// Add message
					
					$task_messages = get_post_meta($post_id, 'task_messages', true);
					
					$date = current_time('timestamp');
					
					$current_user = wp_get_current_user();
					
					$task_messages[] = array(
						
						'date' => $date,
						
						'message' => $content,
						
						'by' => $user->display_name,
						
						'author' => $user->ID
						
					);		
					
					update_post_meta($post_id, 'task_messages', $task_messages);
					
					if(!empty($attached_media)) {
					
						$allowed = get_option('cqpim_allowed_extensions');
						
						$allowed = explode(',', $allowed);
					
						$ticket_changes = array();
						
						$i = 0;
					
						foreach($attached_media as $file) {
						
							$extension = pathinfo($file->name, PATHINFO_EXTENSION);

							if(!in_array(strtolower($extension), $allowed)){
								break;
							}									
							
							$filename = $file->filePath;
							
							$filename = substr($filename, strrpos($filename, '/') + 1);

							$attachment = array(
								'post_mime_type' => $extension,
								'post_title' => $file->name,
								'post_content' => '',
								'post_parent' => $post_id,
								'post_status' => 'publish',
								'guid' => $dirs['baseurl'] . '/cqpim-uploads/' . $filename,
								'post_owner' => $user->ID
							);

							$attachment_id = wp_insert_attachment( $attachment, $dirs['baseurl'] . '/cqpim-uploads/' . $filename );	

							require_once(ABSPATH . 'wp-admin/includes/image.php');
							
							$attachment_data = wp_generate_attachment_metadata( $attachment_id, $file->filePath );
							
							wp_update_attachment_metadata( $attachment_id, $attachment_data );			
																
							$attachment_obj = wp_get_attachment_metadata( $attachment );
							
							update_post_meta($attachment_id, 'cqpim', true);
							
							$attachment = get_post($attachment_id);
							
							$filename = $attachment->post_title;
							
							$ticket_changes[] = sprintf(__('Uploaded file: %1$s', 'cqpim'), $filename);	
						
							$i++;
							
							$attachments[] = $file->filePath;
						
						}
					
					}
					
					cqpim_send_task_updates($post_id, $project_id, $task_owner, $task_watchers, $content, $user, $attachments);					

					$mailbox->markMailAsRead($message);
					
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
				}				
				
				if($type == 'team') {
				
					$args = array(
					
						'post_type' => 'cqpim_teams',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private'
					
					);
					
					$members = get_posts($args);
					
					foreach($members as $member) {
					
						$team_details = get_post_meta($member->ID, 'team_details', true);
						
						if($team_details['user_id'] == $user->ID) {
						
							$assigned = $member->ID;
							
							$client_type = 'admin';
						
						}
						
						if($team_details['team_email'] == $fromEmail) {
						
							$valid = true;
						
						}
					
					} 
					
					if(empty($valid)) {
					
						$value = get_option('cqpim_send_piping_reject');
						
						if(!empty($value)) {
					
							cqpim_send_unknown_account_email($fromEmail, $fromName, $item_type);
						
						}
						
						$mailbox->markMailAsRead($message);
						
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
						exit;					
					
					}
					
					update_post_meta($post_id, 'team_updated', true);
					
					$project_id = get_post_meta($post_id, 'project_id', true);
					
					$task_watchers = get_post_meta($post_id, 'task_watchers', true);
					
					$task_owner = get_post_meta($post_id, 'owner', true);
					
					$project_progress = get_post_meta($project_id, 'project_progress', true);
					
					$task_object = get_post($post_id);
					
					$task_title = $task_object->post_title;
					
					$text = sprintf(__('Task Updated: %1$s'), $task_title );
									
					$project_progress[] = array(
									
						'update' => $text,
										
						'date' => current_time('timestamp'),
								
						'by' => $user->display_name
										
					);
									
					update_post_meta($project_id, 'project_progress', $project_progress );	
					
					$task_messages = get_post_meta($post_id, 'task_messages', true);
					
					$date = current_time('timestamp');
					
					$current_user = wp_get_current_user();
					
					$task_messages[] = array(
						
						'date' => $date,
						
						'message' => $content,
						
						'by' => $user->display_name,
						
						'author' => $user->ID
						
					);		
					
					update_post_meta($post_id, 'task_messages', $task_messages);
					
					if(!empty($attached_media)) {
					
						$allowed = get_option('cqpim_allowed_extensions');
						
						$allowed = explode(',', $allowed);
					
						$ticket_changes = array();
						
						$i = 0;
					
						foreach($attached_media as $file) {
						
							$extension = pathinfo($file->name, PATHINFO_EXTENSION);

							if(!in_array(strtolower($extension), $allowed)){
								break;
							}									
							
							$filename = $file->filePath;
							
							$filename = substr($filename, strrpos($filename, '/') + 1);

							$attachment = array(
								'post_mime_type' => $extension,
								'post_title' => $file->name,
								'post_content' => '',
								'post_parent' => $post_id,
								'post_status' => 'publish',
								'guid' => $dirs['baseurl'] . '/cqpim-uploads/' . $filename,
								'post_owner' => $user->ID
							);

							$attachment_id = wp_insert_attachment( $attachment, $dirs['baseurl'] . '/cqpim-uploads/' . $filename );	

							require_once(ABSPATH . 'wp-admin/includes/image.php');
							
							$attachment_data = wp_generate_attachment_metadata( $attachment_id, $file->filePath );
							
							wp_update_attachment_metadata( $attachment_id, $attachment_data );			
																
							$attachment_obj = wp_get_attachment_metadata( $attachment );
							
							update_post_meta($attachment_id, 'cqpim', true);
							
							$attachment = get_post($attachment_id);
							
							$filename = $attachment->post_title;
							
							$ticket_changes[] = sprintf(__('Uploaded file: %1$s', 'cqpim'), $filename);	
						
							$i++;
							
							$attachments[] = $file->filePath;
						
						}
					
					}
					
					cqpim_send_task_updates($post_id, $project_id, $task_owner, $task_watchers, $content, $user, $attachments);
					
					$mailbox->markMailAsRead($message);
					
						if(!empty($delete)) {
						
							$mailbox->deleteMail($message);
						
						}
					
				}	

			}
		
		}
		
		exit;
	
	}
	
	function cqpim_send_unknown_account_email($fromEmail, $fromName, $type) {
	
		if(empty($type)) {
		
			$type = _e('item', 'cqpim');
			
		}
	
		$email_subject = get_option('cqpim_bounce_subject');
		
		$email_content = get_option('cqpim_bounce_content');
		
		$email_content = str_replace('%%SENDER_NAME%%', $fromName, $email_content);
		
		$email_content = str_replace('%%TYPE%%', $type, $email_content);
		
		$email_content = cqpim_replacement_patterns($email_content, 0, '');
		
		$headers = array();
		
		$attachments = array();
		
		$sender_name = get_option('company_name');
		
		$sender_name = $sender_name;
	
		$sender_email = get_option('company_support_email');
		
		$to = $fromEmail;				
	
		$headers[] = 'From: ' . $sender_name . ' <' . $sender_email . '>';
	
		$headers[] = 'X-Mailer: PHP/' . phpversion();

		$headers[] = 'X-Originating-IP: ' . $_SERVER['SERVER_ADDR'];

		wp_mail($to, $email_subject, $email_content, $headers, $attachments);
	
	}
	
	add_action( "wp_ajax_nopriv_cqpim_test_piping", 

			"cqpim_test_piping");

	add_action( "wp_ajax_cqpim_test_piping", 

		  	"cqpim_test_piping");

	function cqpim_test_piping() {

		$mail_server2 = isset($_POST['cqpim_mail_server']) ? $_POST['cqpim_mail_server']: '';
		$mail_server = '{' . $mail_server2 . '}';
		$mailbox_name = isset($_POST['cqpim_mailbox_name']) ? $_POST['cqpim_mailbox_name']: '';
		$mailbox_pass = isset($_POST['cqpim_mailbox_pass']) ? $_POST['cqpim_mailbox_pass']: '';
		
		if(empty($mail_server2) || empty($mailbox_name) || empty($mailbox_pass)) {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> __('You must complete all fields', 'cqpim'),

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();			
		
		}
		
		$mbox = imap_open($mail_server, $mailbox_name, $mailbox_pass);
		
		if(!empty($mbox)) {
		
			$return =  array( 

				'error' 	=> false,

				'message' 	=> __('Settings are correct.', 'cqpim'),

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();				
		
		} else {
		
			$return =  array( 

				'error' 	=> true,

				'message' 	=> __('Failed to connect to mailbox', 'cqpim'),

			);
			
			header('Content-type: application/json');
			
			echo json_encode($return);

			exit();		
		
		}
	
	}
	
	
	
