<?php

	/**
	 * 	TC+ Dashboard
	 *
	 */

	add_action( 'admin_menu' , 'register_cqpim_dashboard', 9 ); 

	function register_cqpim_dashboard() {

		$mypage = add_menu_page(	
					'Dashboard', 			
					'CQPIM', 			
					'cqpim_view_dashboard', 				
					'cqpim-dashboard', 		
					'cqpim_dashboard',
					'',
					28
		);

		add_action( 'load-' . $mypage, 'enqueue_cqpim_dash_option_scripts' );

	}


	function cqpim_dashboard() { 
	
		$user = wp_get_current_user(); 
		
		$roles = $user->roles;
		
		$args = array(
		
			'post_type' => 'cqpim_teams',
			
			'posts_per_page' => -1,
			
			'post_status' => 'private'
		
		);
		
		$members = get_posts($args);
		
		foreach($members as $member) {
		
			$team_details = get_post_meta($member->ID, 'team_details', true);
			
			if($team_details['user_id'] == $user->ID) {
			
				$assigned = $member->ID;
			
			}
		
		}
		
		if(empty($assigned)) {
		
			$assigned = '';
			
		}
		
		?>

		<div class="masonry-grid">
		
			<?php if(in_array('administrator', $user->roles)) { 
			
				$args = array(
				
					'post_type' => 'cqpim_teams',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private'
				
				);
				
				$members = get_posts($args);
				
				foreach($members as $member) {
				
					$team_details = get_post_meta($member->ID, 'team_details', true);
					
					if($team_details['user_id'] == $user->ID) {
					
						$assigned = $member->ID;
					
					}
				
				}
				
				if(empty($assigned)) { ?>
				
					<div class="cqpim-dash-item grid-item">
					
						<h3><?php _e('Hold up! We need to sort something out!', 'cqpim'); ?></h3>
						
						<div class="cqpim-dash-item-inside">

							<p><?php $text = __('It would appear that the Wordpress Administrator account that you are logged in with is not related to a CQPIM Team Member. In order for the plugin to work correctly, you need to add a Team Member that is linked to your WP User Account.', 'cqpim'); _e('It would appear that the Wordpress Administrator account that you are logged in with is not related to a CQPIM Team Member. In order for the plugin to work correctly, you need to add a Team Member that is linked to your WP User Account.', 'cqpim'); ?></p>
							
							<p><?php $text = __('We can do this for you though, just click Create Linked Team Member. You will then be able to add other team members or just work with this account.', 'cqpim'); _e('We can do this for you though, just click Create Linked Team Member. You will then be able to add other team members or just work with this account.', 'cqpim') ?></p>
							
							<button style="margin-left:0" id="create_linked_team" class="metabox-add-button left" data-uid="<?php echo $user->ID; ?>"><?php $text = __('Create Linked Team Member'); _e('Create Linked Team Member'); ?><div id="spinner_1" class="ajax_loader" style="display:none"></div></button>

							<div class="clear"></div>
						
						</div>
						
					</div>
				
				<?php }
			
			} ?>
		
			<div class="cqpim-dash-item grid-item tasks-box">
			
				<h3><?php _e('My Active Projects', 'cqpim'); ?> <?php if(current_user_can('cqpim_create_new_project') && current_user_can('publish_cqpim_projects')) { ?><a class="cqpim_add_post_link" href="<?php echo admin_url(); ?>post-new.php?post_type=cqpim_project">Add Project</a><?php } ?></h3>

			<?php
			
			$args = array(
			
				'post_type' => 'cqpim_project',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private'
				
			);
			
			$projects = get_posts($args);
			
			$index = 0;
			
			if(!empty($projects)) {
			
				echo '<ul id="dash-project-list">';
			
				foreach($projects as $project) {
				
					$edit_url = get_edit_post_link($project->ID);
					
					$title = get_the_title($project->ID); 
					
					$project_details = get_post_meta($project->ID, 'project_details', true);
					
					$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';

					$closed = isset($project_details['closed']) ? $project_details['closed'] : '';
					
					$sent = isset($project_details['sent']) ? $project_details['sent'] : '';
					
					$confirmed = isset($project_details['confirmed']) ? $project_details['confirmed'] : '';
					
					$signoff = isset($project_details['signoff']) ? $project_details['signoff'] : '';

					if(empty($closed)) {
					
						if(!empty($client_id)) {
					
							if(!empty($signoff)) {
							
								$status = '<span class="status"><strong>' . __('Status:', 'cqpim') . '</strong> ' . __('Signed Off', 'cqpim') . '</span>';
								
							} else {
							
								$checked = get_option('enable_project_contracts'); 
								
								if(!empty($checked)) {
							
									if(!empty($confirmed)) {
									
										$status = '<span class="status"><strong>' . __('Status:', 'cqpim') . '</strong> ' . __('In Progress', 'cqpim') . '</span>';
									
									} else {
									
										if(!empty($sent)) {
										
											$status = '<span class="status"><strong>' . __('Status:', 'cqpim') . '</strong> ' . __('Contract Sent', 'cqpim') . '</span>';
										
										} else {
										
											$status = '<span class="status"><strong>' . __('Status:', 'cqpim') . '</strong> ' . __('Contract Not Sent', 'cqpim') . '</span>';
										
										}
									
									}
								
								} else {
								
									$status = '<span class="status"><strong>' . __('Status:', 'cqpim') . '</strong> ' . __('In Progress', 'cqpim') . '</span>';
								
								}
							
							}
							
						} else {
						
							$status = '<span class="status"><strong>' . __('Status:', 'cqpim') . '</strong> ' . __('In Progress', 'cqpim') . '</span>';
						
						}
					
						$project_elements = get_post_meta($project->ID, 'project_elements', true);
						
						$project_contributors = get_post_meta($project->ID, 'project_contributors', true);

						$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';
						
						$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
						
						$client_details = get_post_meta($client_id, 'client_details', true);
						
						$client_contact_name = isset($client_details['client_contact']) ? $client_details['client_contact'] : '';
						
						$client_company_name = isset($client_details['client_company']) ? $client_details['client_company'] : '';
						
						if(!$client_company_name) {
						
							$client_company_name = $project->post_title;
							
						}
						
						$finish_date = isset($project_details['finish_date']) ? $project_details['finish_date'] : '';									
						
						$task_count = 0;
						
						$task_total_count = 0;
						
						$task_complete_count = 0;
						
						if(!empty($project_elements)) {
						
							foreach ($project_elements as $element) {
							
								$args = array(
								
									'post_type' => 'cqpim_tasks',
									
									'posts_per_page' => -1,
									
									'meta_key' => 'milestone_id',
									
									'meta_value' => $element['id'],
									
									'orderby' => 'date',
									
									'order' => 'ASC'
									
								);
								
								$tasks = get_posts($args);	
								
								foreach($tasks as $task) {
								
									$task_total_count++;
								
									$task_details = get_post_meta($task->ID, 'task_details', true);
									
									if($task_details['status'] != 'complete') {
									
										$task_count++;
									
									}
									
									if($task_details['status'] == 'complete') {
									
										$task_complete_count++;
									
									}
								
								}
							
							}
						
						}
						
						if($task_total_count !== 0) {
						
							$pc_per_task = 100 / $task_total_count;
							
							$pc_complete = $pc_per_task * $task_complete_count;
						
						} else {
						
							$pc_complete = 0;
							
						}
						
						if(current_user_can('cqpim_view_all_projects')) { $index++; ?>
						
							<li>
							
								<script>
									jQuery(document).ready(function() {
										jQuery( "#progressbar-<?php echo $project->ID; ?>" ).progressbar({
											value: <?php echo number_format((float)$pc_complete, 2, '.', ''); ?>
										});
									});
								</script>
							
								<div class="title">
								
									<a href="<?php echo $edit_url; ?>"><?php if(!empty($project->post_title)) { echo $project->post_title; } else { _e('Untitled', 'cqpim'); } ?></a>
								
									<?php echo $status; ?>
								
								</div>
								
								<div class="progress">
								
									<div id="progressbar-<?php echo $project->ID; ?>"></div>
								
								</div>
								
								<ul class="project_stats">
								
									<li><span class="project_stat_head">Open Tasks</span><span class="project_stat"><?php echo $task_count; ?></span></li>
								
									<li><span class="project_stat_head">Complete</span><span class="project_stat"><?php echo number_format((float)$pc_complete, 2, '.', ''); ?>%</span></li>
								
									<li><span class="project_stat_head">Deadline</span><span class="project_stat"><?php echo date(get_option('cqpim_date_format'), $finish_date); ?></span></li>
								
								</ul>
								
							</li>
						
						<?php
						
						} else {
							
							if(!is_array($project_contributors)) {
							
								$project_contributors = array($project_contributors);
							
							}
						
							if(in_array($assigned, $project_contributors)) { $index++; ?>
							
							<li>
							
								<script>
									jQuery(document).ready(function() {
										jQuery( "#progressbar-<?php echo $project->ID; ?>" ).progressbar({
											value: <?php echo number_format((float)$pc_complete, 2, '.', ''); ?>
										});
									});
								</script>
							
								<div class="title">
								
									<a href="<?php echo $edit_url; ?>"><?php if(!empty($project->post_title)) { echo $project->post_title; } else { _e('Untitled', 'cqpim'); } ?></a>
								
									<?php echo $status; ?>
									
								</div>
								
								<div class="progress">
								
									<div id="progressbar-<?php echo $project->ID; ?>"></div>
								
								</div>
								
								<ul class="project_stats">
								
									<li><span class="project_stat_head"><?php _e('Open Tasks', 'cqpim'); ?></span><span class="project_stat"><?php echo $task_count; ?></span></li>
								
									<li><span class="project_stat_head">Complete</span><span class="project_stat"><?php echo number_format((float)$pc_complete, 2, '.', ''); ?>%</span></li>
								
									<li><span class="project_stat_head">Deadline</span><span class="project_stat"><?php echo date(get_option('cqpim_date_format'), $finish_date); ?></span></li>
								
								</ul>
								
							</li>
							
							
								<?php
							
							}
						
						}
					
					} 
				
				}
			
			}
			
			echo '</ul>';
			
				if($index == 0) { ?>
				
					<div class="cqpim-dash-item-inside">
						
						<div style="padding:20px">

							<h4 style="margin:0"><?php _e('Nothing Here!', 'cqpim'); ?></h4>
						
							<span><?php _e('You have not been assigned to any open projects...', 'cqpim'); ?></span>	
							
						</div>	

					</div>
				
				<?php }
			
			?>
				
			</div>
			
			<div class="cqpim-dash-item-double grid-item tasks-box">
			
				<h3><?php _e('My Open Tasks (Assigned or Watching)', 'cqpim'); ?> <a class="cqpim_add_post_link" href="<?php echo admin_url(); ?>post-new.php?post_type=cqpim_tasks">Add Task</a></h3>
				
				<div class="cqpim-dash-item-inside">

				<?php 
				
				$sess_status = isset($_SESSION['task_status']) ? $_SESSION['task_status'] : array('pending', 'progress');
				
				$args = array(
				
					'post_type' => 'cqpim_tasks',
					
					'posts_per_page' => -1,
					
					'meta_query'        => array(
						'relation'  => 'OR',
						array(
							'key'       => 'owner',
							'value'     => $assigned,
							'compare'   => '='
						),
						array(
							'key'       => 'task_watchers',
							'value'     => $assigned,
							'compare'   => 'LIKE'
						)
					)
					
				);				
				
				$tasks = get_posts($args);

				$own_tasks = array();
				
				foreach($tasks as $task) {
				
					$active = get_post_meta($task->ID, 'active', true);
					
					$task_details = get_post_meta($task->ID, 'task_details', true);
					
					$owner = get_post_meta($task->ID, 'owner', true);
					
					$watchers = get_post_meta($task->ID, 'task_watchers', true);
					
					if(empty($watchers)) {
					
						$watchers = array();
					
					}

					$task_status = isset($task_details['status']) ? $task_details['status'] : '';					
				
					if(!empty($active) && $task_status != 'complete' && $owner == $assigned || !empty($active) && $task_status != 'complete' && in_array($assigned, $watchers)) {
					
						$own_tasks[] = $task;
					
					}
				
				}
			
				if(!empty($own_tasks)) { 
				
					$ordered = array();
					
					foreach($own_tasks as $task) {
					
						$task_details = get_post_meta($task->ID, 'task_details', true);

						$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
						
						if(!empty($task_deadline)) {
						
							$ordered[$task_deadline] = $task;
						
						}
					
					}
					
					ksort($ordered);
					
					foreach($own_tasks as $task) {
					
						$task_details = get_post_meta($task->ID, 'task_details', true);

						$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
						
						if(empty($task_deadline)) {
						
							$ordered[] = $task;
						
						}
					
					}
				
					?>
			
					<table class="milestones dt-tk">
					
						<thead>
						
							<th><?php _e('Task Title', 'cqpim'); ?></th>
							
							<th><?php _e('Assigned To', 'cqpim'); ?></th>
							
							<th><?php _e('Project', 'cqpim'); ?></th>
							
							<th><?php _e('Deadline', 'cqpim'); ?></th>
							
							<th><?php _e('Progress', 'cqpim'); ?></th>
						
						</thead>
						
						<tbody>
						
							<?php $styles = array(); foreach($ordered as $task) { 
							
								$task_details = get_post_meta($task->ID, 'task_details', true); 
								
								$owner = get_post_meta($task->ID, 'owner', true); 
								
								$watchers = get_post_meta($task->ID, 'task_watchers', true); 

								if(empty($watchers)) {
								
									$watchers = array();
								
								}								
											
								if(in_array($assigned, $watchers)) {
								
									$watching = '<img title="' . __('Watched Task', 'cqpim') . '" src="' . plugin_dir_url( __FILE__ ) . '/img/watching.png" />';
								
								} else {
								
									$watching = '';
									
								}
								
								$team_details = get_post_meta($owner, 'team_details', true);
								
								$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
								
								$project = get_post_meta($task->ID, 'project_id', true); 
								
								$active = get_post_meta($task->ID, 'active', true);
								
								$project_details = get_post_meta($project, 'project_details', true);
								
								$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
								
								$project_url = get_edit_post_link($project);
								
								$task_status = isset($task_details['status']) ? $task_details['status'] : '';
								
								$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
								
								$task_pc = isset($task_details['task_pc']) ? $task_details['task_pc'] : '0';
								
								if(!is_numeric($task_deadline)) {

									$str_deadline = str_replace('/','-', $task_deadline);
								
									$deadline_stamp = strtotime($str_deadline);
								
								} else {
								
									$deadline_stamp = $task_deadline;
									
								}
								
								$time_spent = get_post_meta($task->ID, 'task_time_spent', true);
								
								$total = (int) 0;
								
								if($time_spent) {
								
									foreach($time_spent as $key => $time) {
									
										$total = $total + $time['time'];
									
									}
									
									$total = str_replace(',','.', $total);
									
									$time_split = explode('.', $total);
									
									$minutes = '0.' . $time_split[1];
									
									$minutes = $minutes * 60;
									
									$minutes = number_format((float)$minutes, 0, '.', '');
									
									if($time_split[0] > 1) {
									
										$hours  = __('hours', 'cqpim');
										
									} else {
									
										$hours = __('hour', 'cqpim');
									
									}
									
									$time =  '<span><strong>' . number_format((float)$total, 2, '.', '') . ' ' . __('hours', 'cqpim') . '</strong> (' . $time_split[0] . ' ' . $hours . ' + ' . $minutes . ' ' . __('minutes', 'cqpim') . ')</span> <div id="ajax_spinner_remove_time_'. $task->ID .'" class="ajax_spinner" style="display:none"></div>';
								
								} else {
								
									$time =  '<span>0</span>';
								
								}
								
								$now = time();
					
								if($task_status != 'complete') {
								
									if($deadline_stamp && $now > $deadline_stamp) {
									
										$progress_class = 'red';
									
										$milestone_status_string = __('OVERDUE', 'cqpim') . ' - ' . $task_pc;
									
									} else {
									
										$milestone_status_string = isset($task_details['status']) ? $task_details['status'] : '';
										
										if(!$milestone_status_string || $milestone_status_string == 'pending') {
										
											$progress_class = 'amber';
										
											$milestone_status_string = __('Pending', 'cqpim') . ' - ' . $task_pc;
											
										} else if($milestone_status_string == 'on_hold') {
										
											$progress_class = 'green';
										
											$milestone_status_string = __('On Hold', 'cqpim') . ' - ' . $task_pc;
										
										} else if($milestone_status_string == 'progress') {
										
											$progress_class = 'green';
										
											$milestone_status_string = __('In Progress', 'cqpim') . ' - ' . $task_pc;
										
										}
									
									}
								
								} else {
								
									$milestone_status_string = __('Complete', 'cqpim') . ' - ' . $task_pc;
								
								}	
								
								if(empty($progress_class)) {
								
									$progress_class = 'green';
								
								}
								
								?>
								
								<script>
									jQuery(document).ready(function() {
										jQuery( "#progressbar-<?php echo $task->ID; ?>" ).progressbar({
											value: <?php echo number_format((float)$task_pc, 2, '.', ''); ?>
										});
									});
								</script>
						
								<tr>
								
									<td><a href="<?php echo get_edit_post_link($task->ID); ?>"><?php echo $task->post_title; ?></a></td>
									
									<td><?php echo $team_name; ?> <?php echo $watching; ?></td>
									
									<?php if(empty($project_ref)) { ?>
								
										<td><?php _e('N/A', 'cqpim'); ?></td>
								
									<?php } else { ?>
									
										<td><a href="<?php echo $project_url; ?>"><?php echo $project_ref; ?></td>
									
									<?php } ?>
									
									<td><?php if(is_numeric($task_deadline)) { echo date(get_option('cqpim_date_format'), $task_deadline); } else { echo $task_deadline; } ?></td>
									
									<td>
									
										<div class="progress <?php echo $progress_class; ?>">
										
											<div id="progressbar-<?php echo $task->ID; ?>" title="<?php echo $milestone_status_string; ?>%"></div>
										
										</div>									
									
									</td>
								
								</tr>
						
							<?php 
							
							} ?>
						
						</tbody>
					
					</table>
				
				<?php } else { ?> 
				
					<div style="padding:20px">						
						
							<h4 style="margin:0"><?php _e('Nothing Here!', 'cqpim'); ?></h4>
				
							<span><?php _e('No tasks to show...', 'cqpim'); ?></span>						
						
					</div>				
				
				<?php } ?>

				</div>
				
			</div>

			<?php if(current_user_can('edit_cqpim_supports')) { ?>
			
			<div class="cqpim-dash-item-double grid-item tasks-box">
			
				<h3><?php _e('My Open Support Tickets', 'cqpim'); ?> <a class="cqpim_add_post_link" href="<?php echo admin_url(); ?>post-new.php?post_type=cqpim_support">Add Ticket</a></h3>
				
				<div class="cqpim-dash-item-inside">
				
				<?php
				
				$user = wp_get_current_user();
							
				$args = array(
				
					'post_type' => 'cqpim_support',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private',
									
					'meta_query'        => array(
						'relation'  => 'OR',
						array(
							'key'       => 'ticket_owner',
							'value'     => $assigned,
							'compare'   => '='
						),
						array(
							'key'       => 'ticket_watchers',
							'value'     => $assigned,
							'compare'   => 'LIKE'
						)
					)
				
				); 
				
				$tickets = get_posts($args);
				
				$total_tickets = count($tickets);
				
				$open_tickets = array();
				
				foreach($tickets as $ticket) {
				
					$ticket_status = get_post_meta($ticket->ID, 'ticket_status', true);
					
					if($ticket_status != 'resolved') {
					
						$open_tickets[] = $ticket;
					
					}
				
				}
				
				$ordered = array();
				
				foreach($open_tickets as $ticket) {
				
					$ticket_updated = get_post_meta($ticket->ID, 'last_updated', true);
					
					if(!empty($ticket_updated)) {
					
						$ordered[$ticket_updated] = $ticket;
					
					}
				
				}
				
				krsort($ordered);

				if(!empty($ordered)) {
			
					echo '<table style="background:#fff" class="milestones files dt-st">';
					
					echo '<thead><tr><th>' . __('ID', 'cqpim') . '</th><th>' . __('Ticket Title', 'cqpim') . '</th><th>' . __('Assigned To', 'cqpim') . '</th><th>' . __('Priority', 'cqpim') . '</th><th>' . __('Last Updated', 'cqpim') . '</th></tr></thead>';
					
					echo '<tbody>';
				
					foreach($ordered as $ticket) {
					
						$ticket_author = $ticket->post_author;
						
						$author_details = get_user_by('id', $ticket_author);
						
						$ticket_owner = get_post_meta($ticket->ID, 'ticket_owner', true);
						
						$owner_details = get_post_meta($ticket_owner, 'team_details', true);
						
						$owner_name = isset($owner_details['team_name']) ? $owner_details['team_name'] : '';
						
						$ticket_client = get_post_meta($ticket->ID, 'ticket_client', true);
						
						$client_details = get_post_meta($ticket_client, 'client_details', true);
						
						$client_name = isset($client_details['client_company']) ? $client_details['client_company'] : '';
					
						$ticket_status = get_post_meta($ticket->ID, 'ticket_status', true);
						
						$ticket_watchers = get_post_meta($ticket->ID, 'ticket_watchers', true);
						
						if(empty($ticket_watchers)) {
						
							$ticket_watchers = array();
						
						}
						
						if(in_array($assigned, $ticket_watchers)) {
						
							$watching = '<img title="' . __('Watched Support Ticket', 'cqpim') . '" src="' . plugin_dir_url( __FILE__ ) . '/img/watching.png" />';
						
						} else {
						
							$watching = '';
							
						}
						
						if($ticket_status == 'open') {
						
							$tstatus = '<span class="low_priority">' . __('Open', 'cqpim') . '</span>';
						
						} else if($ticket_status == 'resolved') {
						
							$tstatus = '<span class="task_complete">' . __('Resolved', 'cqpim') . '</span>';
						
						} else if($ticket_status == 'hold') {
						
							$tstatus = '<span class="high_priority">' . __('On Hold', 'cqpim') . '</span>';
						
						}
						
						$ticket_priority = get_post_meta($ticket->ID, 'ticket_priority', true);
						
						$ticket_updated = get_post_meta($ticket->ID, 'last_updated', true);
						
						if(is_numeric($ticket_updated)) { $ticket_updated = date(get_option('cqpim_date_format') . ' H:i', $ticket_updated); } else { $ticket_updated = $ticket_updated; }
						
						if($ticket_priority == 'low') {
						
							$priority = '<span class="low_priority">' . __('Low', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'normal') {
						
							$priority = '<span class="normal_priority">' . __('Normal', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'high') {
						
							$priority = '<span class="high_priority">' . __('High', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'immediate') {
						
							$priority = '<span class="immediate_priority">' . __('Immediate', 'cqpim') . '</span>';
						
						}					
					
							echo '<tr>';
							
							echo '<td>' . $ticket->ID . '</td>';
						
							echo '<td><a href="' . get_edit_post_link($ticket->ID) . '">' . $ticket->post_title . '</a></td>';
							
							echo '<td>' . $owner_name . ' ' . $watching . '</td>';
							
							echo '<td>' . $priority . '</td>';
							
							echo '<td>' . $ticket_updated . '</td>';
							
							echo '</tr>';
						
						}
					
					echo '</tbody>';
					
					echo '</table>';
				
				} else { ?>

					<div style="padding:20px">						
						
							<h4 style="margin:0"><?php _e('Nothing Here!', 'cqpim'); ?></h4>
				
							<span><?php _e('No open tickets to show...', 'cqpim'); ?></span>						
						
					</div>	

				<?php }
				
				?>
				
				</div>
				
			</div>
			
			<?php } ?>			

			<div class="cqpim-dash-item grid-item tasks-box">
			
				<h3><?php _e('Project Updates', 'cqpim'); ?></h3>
				
				<div class="cqpim-dash-item-inside" style="background:#fff">
				
				<?php
						
				$args = array(
				
					'post_type' => 'cqpim_project',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private'
					
				);
				
				$projects = get_posts($args);
				
				$index = 0;
				
				$updates = array();
				
				if(!empty($projects)) {
				
					foreach($projects as $project) {
					
						$edit_url = get_edit_post_link($project->ID);
						
						$title = get_the_title($project->ID); 
						
						$project_details = get_post_meta($project->ID, 'project_details', true);
						
						$project_progress = get_post_meta($project->ID, 'project_progress', true);
						
						if(empty($project_progress)) {
						
							$project_progress = array();
						
						}
						
						$project_contributors = get_post_meta($project->ID, 'project_contributors', true);
							
						if(current_user_can('cqpim_view_all_projects')) { $index++;
						
							foreach($project_progress as $progress) {
							
								$date = isset($progress['date']) ? $progress['date'] : '';
							
								$updates[$date] = array(
										
									'pid' => $project->ID,
								
									'by' => $progress['by'],
									
									'date' => $progress['date'],
									
									'update' => $progress['update'],
								
								);
							
							}
						
						} else {
							
							if(!is_array($project_contributors)) {
							
								$project_contributors = array($project_contributors);
							
							}
						
							if(in_array($assigned, $project_contributors)) { $index++; 
							
								foreach($project_progress as $progress) {
								
									$date = isset($progress['date']) ? $progress['date'] : '';
								
									$updates[$date] = array(
											
										'pid' => $project->ID,
									
										'by' => $progress['by'],
										
										'date' => $progress['date'],
										
										'update' => $progress['update'],
									
									);
								
								}						
							
							}
						
						}
						
					}

					ksort($updates);
							
					$updates = array_reverse($updates);	
					
					echo '<div style="max-height:600px; overflow:auto">';

					echo '<ul class="project_summary_progress" style="margin:0">';
				
					foreach($updates as $pupdate) {
					
						$project_details = get_post_meta($pupdate['pid'], 'project_details', true);
						
						$url = get_edit_post_link($pupdate['pid']);
						
						$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
						
						if(is_numeric($pupdate['date'])) { $pupdate['date'] = date(get_option('cqpim_date_format') . ' H:i', $pupdate['date']); } else { $pupdate['date'] = $pupdate['date']; }
					
						echo '<li style="margin-bottom:0">';
						
						echo '<div class="timeline-entry">';
						
						echo '<span class="timeline-by">' . $pupdate['by'] . '</span>';
						
						echo '<span class="timeline-date">' . $pupdate['date'] . '</span>';
						
						echo '<span class="timeline-update"><a class="cqpim-link" href="' . $url . '">Project ' . $project_ref . '</a> - ' . $pupdate['update'] . '</span>';
						
						echo '</div>';
						
						echo '</li>';
					
					}
					
					echo '</ul>';	

					echo '</div>';
					
				}
					
				if($index == 0) { ?>
						
						<div style="padding:20px">

							<h4 style="margin:0"><?php _e('Nothing Here!', 'cqpim'); ?></h4>
						
							<span><?php _e('You have not been assigned to any open projects...', 'cqpim'); ?></span>	
							
						</div>					
				
				<?php } ?>				
				
				</div>
				
			</div>
			
			<?php if(current_user_can('edit_cqpim_invoices')) { 
			
			if(get_option('disable_invoices') != 1) { ?>
			
				<div class="cqpim-dash-item grid-item tasks-box">
				
					<h3><?php _e('Outstanding Invoices', 'cqpim'); ?> <a class="cqpim_add_post_link" href="<?php echo admin_url(); ?>post-new.php?post_type=cqpim_invoice">Add Invoice</a></h3>
					
					<div class="cqpim-dash-item-inside">

						<?php
						
						$args = array(
						
							'post_type' => 'cqpim_invoice',
							
							'posts_per_page' => -1,
							
							'post_status' => 'publish'
							
						);
						
						$invoices = get_posts($args);
						
						$this_client = array();
						
						foreach($invoices as $invoice) {
						
							$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
							
							$paid = isset($invoice_details['paid']) ? $invoice_details['paid']: '';
							
							if($paid != 1) {
							
								$this_client[] = $invoice;
							
							}
						
						}
						
						if(!empty($this_client)) {
						
							echo '<table style="background:#fff" class="milestones dt-in">';
							
							echo '<thead>';
							
							echo '<tr><th>ID</th><th>' . __('Due', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr>';
							
							echo '</thead>';
							
							foreach($this_client as $invoice) {
							
								$currency = get_option('currency_symbol');
							
								$invoice_link = get_edit_post_link($invoice->ID);
								
								$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);	
								
								$invoice_totals = get_post_meta($invoice->ID, 'invoice_totals', true);
								
								$invoice_date = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
								
								$total = isset($invoice_totals['total']) ? $invoice_totals['total'] : '';
								
								$project_id = isset($invoice_details['project_id']) ? $invoice_details['project_id'] : '';
								
								$invoice_id = get_post_meta($invoice->ID, 'invoice_id', true);
								
								$project_details = get_post_meta($project_id, 'project_details', true);
								
								$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
								
								$project_link = get_edit_post_link($project_id);
								
								$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
								
								$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';
								
								if(empty($on_receipt)) {
								
									$due_string = date(get_option('cqpim_date_format'), $due);
								
								} else {
								
									$due_string = __('Due on Receipt', 'cqpim');
									
								}
								
								$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
								
								$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
								
								$now = time();
								
								if(empty($paid)) {
							
									if(!empty($due)) {
								
										if($now > $due) {
										
											$class = 'overdue';
									
											$status = '<span class="task_over"><strong>' . __('OVERDUE', 'cqpim') . '</strong></span>';		
									
										} else {
										
											if(!empty($sent)) {
											
												$class = 'sent';
									
												$status = '<span class="task_pending">' . __('SENT', 'cqpim') . '</span>';							
											
											} else {
											
												$class = 'not-sent';
									
												$status = '<span class="task_over">' . __('NOT SENT', 'cqpim') . '</span>';							
											
											}
										
										}
								
									}
							
								} else {
								
									$class = 'paid';
								
									$status = '<span class="task_complete">' . __('PAID', 'cqpim') . '</span>';
									
								}
											
								echo '<tr>';
								
								echo '<td><a href="' . $invoice_link . '" >' . $invoice_id . '</a></td>';
								
								echo '<td>' . $due_string . '</td>';
								
								echo '<td class="' . $class . '">' . $status . '</td>';
								
								echo '</tr>';
							
							}
							
							echo '</table>';
							
						} else { ?>
						
							<div style="padding:20px">
									
								
								
									<h4 style="margin:0"><?php _e('Nothing Here!', 'cqpim'); ?></h4>
						
									<span><?php _e('No outstanding invoices to show...', 'cqpim'); ?></span>
									
								
								
							</div>
							
						<?php
							
						} ?>

					</div>
					
				</div>
			
			<?php } }?>	
			
		</div>

	<?php }
	