jQuery(document).ready(function() {
    jQuery( "#tabs" ).tabs();
	
	jQuery('.colorbox').on('click', function(e) {
	
		e.preventDefault();
	
		var anc = jQuery(this).attr('href');
		
		var id = anc.replace('#', '');
		
		var thediv = jQuery('#' + id);
		
		jQuery(thediv).parent('div').attr('id', id + '_container');
		
		jQuery.colorbox({
			
			'inline': true,
				
			'href': '#' + id,
			
			'opacity': '0.5',
			
		});	
	
	});
	
	jQuery('#create_linked_team').on('click', function(e) {
	
		e.preventDefault();
		
		var user_id = jQuery(this).data('uid');
		
		var spinner = jQuery('#spinner_1');
	
		var data = {
		
			'action' : 'cqpim_create_team_from_admin',
			
			'user_id' : user_id,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

				// disable form elements while awaiting data

				jQuery('#create_linked_team').prop('disabled', true);

			},

		}).done(function(response){
		
			if(response.error == true) {
			
				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#create_linked_team').prop('disabled', false);
				
				alert('Something went wrong, pleae check your WordPress account to make sure the Display Name field has been completed. Then try again.');
				
			} else {

				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#create_linked_team').prop('disabled', false);
				
				jQuery('#team_member_warning').fadeOut();
				
				jQuery('#team_member_sorted').fadeIn();
			
			}

		});	
	
	});
	
	jQuery('#verify_purchase').on('click', function(e) {
	
		e.preventDefault();
		
		var code = jQuery('#cqpim_purchase_code').val();
		
		var verify = jQuery(this).data('verify');
	
		var data = {
		
			'action' : 'cqpim_verify_purchase_code',
			
			'code' : code,
			
			'verify' : verify
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data

				jQuery('#verify_purchase').prop('disabled', true);

			},

		}).always(function(response){
		
			console.log(response);
		
		}).done(function(response){
		
			if(response.error == true) {

				// re-enable form elements so that new enquiry can be posted

				jQuery('#verify_purchase').prop('disabled', false);
				
				alert(response.message);
				
			} else {

				// re-enable form elements so that new enquiry can be posted

				alert(response.message);
				
				location.reload();
			
			}

		});	
	
	});
	
	jQuery('#remove_purchase').on('click', function(e) {
	
		e.preventDefault();
		
		var code = jQuery('#cqpim_purchase_code').val();
	
		var data = {
		
			'action' : 'cqpim_remove_purchase_code',
			
			'code' : code,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data

				jQuery('#remove_purchase').prop('disabled', true);

			},

		}).always(function(response) {
		
			console.log(response);
		
		}).done(function(response){
		
			if(response.error == true) {

				// re-enable form elements so that new enquiry can be posted

				jQuery('#remove_purchase').prop('disabled', false);
				
				alert(response.message);
				
			} else {

				// re-enable form elements so that new enquiry can be posted

				alert(response.message);
				
				location.reload();
			
			}

		});	
	
	});

});

