jQuery(document).ready(function() {

	var scrollTop = localStorage.getItem('scrollTop');
	
    if (scrollTop !== null) {
	
        jQuery(window).scrollTop(Number(scrollTop));
		
        localStorage.removeItem('scrollTop');
		
    }

	jQuery('#publish').click(function(event) {

		localStorage.setItem('scrollTop', jQuery(window).scrollTop());
		
		return true;

	});
	
	if( jQuery('.cqpim_roles').length ) {
	
	jQuery('.cqpim_roles table').dataTable({
	
		"ordering" : false,
	
	});
	
	}
	
	jQuery('button.s_button').on('click', function(e){
	
		e.preventDefault();
		
		setTimeout(function(){
	
			jQuery('#publish').trigger('click');
		
		}, 500);
	
	});
	
	jQuery(document).on('click', 'button.delete_file', function(e){		

		e.preventDefault();

		var attID = jQuery(this).data('id');
		
		var spinner = jQuery('#ajax_spinner_' + attID);

		var data = {
		
			'action' : 'cqpim_delete_file',
			
			'ID' : attID
		
		};	

		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

			},

		}).done(function(response){

			spinner.hide();
				
			location.reload();

		});			

	});

	// Save button
	
	jQuery('a.save').on('click', function(e) {
	
		e.preventDefault();
		
		jQuery('#support_spinner_1').show();
	
		jQuery('#publish').trigger('click');
	
	});
	
	// Switch Resolved
	
	jQuery('#switch_to_resolved').click(function(e) {
	
		e.preventDefault();
		
		var spinner = jQuery('#support_loader_2');
			
		var data = {
		
			'action' : 'cqpim_switch_resolved_tickets'
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

				// disable form elements while awaiting data

				jQuery('#switch_to_resolved').prop('disabled', true);

			},

		}).done(function(response){

			spinner.hide();

			// re-enable form elements so that new enquiry can be posted

			jQuery('#switch_to_resolved').prop('disabled', false);
				
			location.reload();

		});	
	
	});
	
	// Next Five Tickets
	
	jQuery('#next_five').click(function(e) {
	
		e.preventDefault();
		
		var spinner = jQuery('#support_loader_4');
			
		var data = {
		
			'action' : 'cqpim_increment_tickets_page',
			
			'admin' : true,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

				// disable form elements while awaiting data

				jQuery('#next_five').prop('disabled', true);

			},

		}).done(function(response){

			spinner.hide();

			// re-enable form elements so that new enquiry can be posted

			jQuery('#next_five').prop('disabled', false);
				
			location.reload();

		});	
	
	});
	
	// Previous Five Tickets
	
	jQuery('#previous_five').click(function(e) {
	
		e.preventDefault();
		
		var spinner = jQuery('#support_loader_3');
			
		var data = {
		
			'action' : 'cqpim_decrement_tickets_page',
			
			'admin' : true,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

				// disable form elements while awaiting data

				jQuery('#previous_five').prop('disabled', true);

			},

		}).done(function(response){

			spinner.hide();

			// re-enable form elements so that new enquiry can be posted

			jQuery('#previous_five').prop('disabled', false);
				
			location.reload();

		});	
	
	});
	
	jQuery('#delete_task').live('click', function(e) {
	
		e.preventDefault();
		
		var task_id = jQuery(this).data('id');
		
		var spinner = jQuery('#ajax_spinner_task');
		
		var data = {
		
			'action' : 'cqpim_delete_support_page',
			
			'task_id' : task_id,
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data
				
				spinner.show();

				jQuery('#delete_task').prop('disabled', true);

			},
			
		}).done(function(response){
					
			if(response.error == true) {
			
			spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#delete_task').prop('disabled', false);

				
			} else {
			
				spinner.hide();

				// re-enable form elements so that new enquiry can be posted

				jQuery('#delete_task').prop('disabled', false);
				
				window.location.href = response.redirect;				
			
			}				

		});
	
	});
	
	// Delete Message
	
	jQuery('button.delete_message').click(function(e) {
	
		e.preventDefault();
		
		var project_id = jQuery('#post_ID').val();
		
		var key = jQuery(this).data('id');
		
		var domain = document.domain;
		
		var spinner = jQuery('#ajax_spinner_' + key);
		
		var data = {
		
			'action' : 'cqpim_delete_support_message',
			
			'project_id' : project_id,
			
			'key' : key
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// disable form elements while awaiting data
				
				spinner.show();

				jQuery('#button.delete_message').prop('disabled', true);

			},
			
		}).done(function(){
					
				location.reload();

		});
	
	});

});