<?php


function form_builder_builder_metabox_callback( $post ) {


	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'form_builder_builder_metabox', 

 	 	'form_builder_builder_metabox_nonce' );
		
		$data = get_post_meta($post->ID, 'builder_data', true);	
		
		if(!empty($data)) {	
		
			$builder = $data;
		
			$data = json_decode($data);
			
			$data = $data->fields;
			
			$fields = json_encode($data);		
			
		} else {
		
			$fields = '';
			
		}
		
		?>
		
		<script>
		
			jQuery(document).ready(function() {
			
				// form Builder
				
				var pre = jQuery('#builder_data').val();
				
				if(pre != 'null') {
				
					var formbuilder = new Formbuilder({ 
					
						selector: '#form_builder_container',
						
						<?php if(!empty($fields)) { ?>
						
							bootstrapData: <?php echo $fields; ?>
						
						<?php } ?>
						
					});
				
				} else {
				
					var type = jQuery('#form_type').val();
					
					if(type == 'anonymous_frontend') {
					
						var formbuilder = new Formbuilder({ 
						
							selector: '#form_builder_container',
							
						});
								
					}	

					if(type == 'client_dashboard') {
					
						var formbuilder = new Formbuilder({ 
						
							selector: '#form_builder_container'
											
						});			
					
					}			
				
				}
				
				formbuilder.on('save', function(payload) {
				
					jQuery('#builder_data').val(payload);
				
				});			
			
			});
		
		</script>
		
		<div id="form_builder_container">
		

		
		</div>
		
		<input type="hidden" name="builder_data" id="builder_data" value='<?php if(!empty($builder)) { echo $builder; } else { echo ''; } ?>' />
		
		<?php
		
}

add_action( 'save_post', 'save_form_builder_builder_metabox_data' );

function save_form_builder_builder_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['form_builder_builder_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['form_builder_builder_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'form_builder_builder_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	
	$builder_data = get_post_meta($post_id, 'builder_data', true);
	
	if(empty($builder_data)) {
	
		$builder_data = array();
	
	}
	
	if(!empty($_POST['builder_data'])) {
	
		$builder_data = $_POST['builder_data'];
	
	}
	
	update_post_meta($post_id, 'builder_data', $builder_data);
	
}