<?php


// Project Details Metabox

function invoice_client_project_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.
	
	$meta = get_post_meta($post->ID, 'invoice_details', true);
	
	//print_r($meta);

 	wp_nonce_field( 

 	 	'invoice_client_project_metabox', 

 	 	'invoice_client_project_metabox_nonce' );
		
			$invoice_details = get_post_meta($post->ID, 'invoice_details', true);
			
			$invoice_id = get_post_meta($post->ID, 'invoice_id', true);
			
			$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
			
			$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';
			
			$invoice_date = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
			
			if(!$invoice_date) {
			
				$invoice_date = date(get_option('cqpim_date_format'));
				
			}
			
			if(!empty($invoice_id)) {
			
				echo '<label for="invoice_number">' . __('Invoice Number:', 'cqpim') . ' </label>';
				
				echo '<input type="text" name="invoice_number" id="invoice_number" value="' . $invoice_id . '" /><br />';				
			
			} else {
			
				$invoice_id = cqpim_get_invoice_id();
				
				echo '<label for="invoice_number">' . __('Invoice Number:', 'cqpim') . ' </label>';
				
				echo '<input type="text" name="invoice_number" id="invoice_number" value="' . $invoice_id . '" /><br />';
			
			}
			
			echo '<label for="invoice_date">' . __('Invoice Date:', 'cqpim') . ' </label><br />';
			
			if(is_numeric($invoice_date)) { $invoice_date = date(get_option('cqpim_date_format'), $invoice_date); } else { $invoice_date = $invoice_date; }
			
			echo '<input type="text" name="invoice_date" id="invoice_date" class="datepicker" value="' . $invoice_date . '" /><br />';
			
			$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
			
			$now = time();
			
			if(empty($on_receipt)) {
			
				if(!$paid) {
				
					if($due) {
					
						if($now > $due) {
						
							echo '<div class="unsent_quote">' . __('THIS INVOICE IS OVERDUE', 'cqpim') . '</div>';		
						
						}
					
					}
				
				}
			
			}
		
			$args = array(
			
				'post_type' => 'cqpim_client',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private',
			
			);
			
			$clients = get_posts($args);
			
			echo '<label for="invoice_client">' . __('Client:', 'cqpim') . '</label>';
			
			echo '<select id="invoice_client" name="invoice_client" required>';
			
			echo '<option value="">' . __('Select a Client:', 'cqpim') . '</option>';
			
			foreach($clients as $client) {
				
				$selected = '';
				
				$client_details = get_post_meta($client->ID, 'client_details', true);
				
				if($client->ID == $invoice_details['client_id']) {
				
					$selected = 'selected';
					
				}
			
				echo '<option value="' . $client->ID . '" ' . $selected . '>' . $client_details['client_company'] . '</option>';
			
			}
			
			echo '</select><div class="ajax_spinner_2" style="display:none"></div>';
			
			echo '<br />';
			
			$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
			
			$client_details = get_post_meta($client_id, 'client_details', true);
			
			$client_contacts = get_post_meta($client_id, 'client_contacts', true);
			
			$client_contact = get_post_meta($post->ID, 'client_contact', true);
			
			if(!empty($client_id)) { ?>
			
				<select name="client_contact" id="client_contact">
				
					<option value=""><?php _e('Choose a Contact', 'cqpim'); ?></option>
					
					<option value="<?php echo $client_details['user_id']; ?>" <?php if($client_contact == $client_details['user_id']) { echo 'selected="selected"'; } ?>><?php echo $client_details['client_contact']; ?> <?php _e('(Main Contact)', 'cqpim'); ?></option>
					
					<?php 
					
					foreach($client_contacts as $contact) { ?>
					
						<option value="<?php echo $contact['user_id']; ?>" <?php if($client_contact == $contact['user_id']) { echo 'selected="selected"'; } ?>><?php echo $contact['name']; ?></option>							
					
					<?php }
					
					?>
				
				</select>					
			
			<?php } else { ?>
			
				<select name="client_contact" id="client_contact" disabled >
				
					<option value=""><?php _e('Choose a Contact', 'cqpim'); ?></option>
				
				</select>
			
			<?php } ?>
		
			<div class="project_dd">
			
			<label for="invoice_project"><?php _e('Project:', 'cqpim'); ?></label>
			
				<select id="invoice_project" name="invoice_project">
				
				<?php if(!$invoice_details['project_id']) { ?>
				
					<option value=""><?php _e('Choose a Project', 'cqpim'); ?></option>
					
				<?php } else { 
				
					$args = array(
					
						'post_type' => 'cqpim_project',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private',					
					
					);
					
					$projects = get_posts($args);
					
					if($projects) {
					
						foreach($projects as $project) {
					
							$project_details = get_post_meta($project->ID, 'project_details', true); 
							
							$invoice_client_id = $invoice_details['client_id'];
							
							$project_client_id = $project_details['client_id'];
							
							if($project->ID == $invoice_details['project_id']) {
							
								$selected = 'selected';
								
							} else {
							
								$selected = '';
								
							}
							
							if($invoice_client_id == $project_client_id) {
							
								echo "<option value='" .  $project->ID . "' " . $selected . ">" . $project_details['quote_ref'] . " - " . $project->post_title . "</option>";
							
							}
						
						}
					
					}
				
				
				
				
				} ?>
							
				</select>
				
				<br /><br />
			
			</div>
		
		<?php 
		
		$invoice_paid = isset($invoice_details['paid_details']) ? $invoice_details['paid_details'] : '';
		
		$invoice_sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
		
		$client = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		
		$project = isset($invoice_details['project_id']) ? $invoice_details['project_id'] : '';
		
		$line_items = get_post_meta($post->ID, 'line_items', true);
		
		?>
		
		<table class="quote_status">
		
			<tr>
			
				<td class="title"><?php _e('Invoice Date', 'cqpim'); ?></td>
				
				<?php if(is_numeric($invoice_date)) { $invoice_date = date(get_option('cqpim_date_format'), $invoice_date); } else { $invoice_date = $invoice_date; } ;?>
				
				<td><?php echo $invoice_date; ?></td>
				
			</tr>
			
			<tr>
			
				<td class="title"><?php _e('Invoice Due', 'cqpim'); ?></td>
				
				<?php if(empty($on_receipt)) { ?>
				
					<?php if($due) { ?>
					
					<td><?php echo date(get_option('cqpim_date_format'), $due); ?></td>
					
					<?php } else { ?>
					
					<td></td>
					
					<?php } ?>
				
				<?php } else { ?>
				
					<td><?php _e('On Receipt', 'cqpim'); ?></td>
				
				<?php } ?>
				
			</tr>
		
			<tr>
			
				<?php $classes = ( !empty( $client ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Client', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $project ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Project', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $line_items ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Line Items', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $invoice_sent ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Invoice Sent', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $invoice_paid ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Invoice Paid', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
		</table>
		
		<?php
		
		$invoice_sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
		
		$invoice_paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
		
		if(!$invoice_paid) {
		
			if(empty($invoice_sent)) {
			
				echo '<div class="unsent_quote">' . __('The invoice has not yet been sent to the client.', 'cqpim') . '</div>';
				
				if(current_user_can('cqpim_send_invoices')) {

					echo '<button id="send_invoice" data-type="send" data-id="' . $post->ID . '">' . __('Send Invoice', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>';
				
				}
				
				if(current_user_can('cqpim_mark_invoice_paid')) {

					echo '<button id="mark_paid_trigger" data-id="' . $post->ID . '">' . __('Add Payment', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>'; ?>
					
					<div id="invoice_payment_container" style="display:none">
					
						<div id="invoice_payment">
						
							<div style="padding:12px">
							
								<h3><?php _e('Add Payment', 'cqpim'); ?></h3>
								
								<p><?php _e('Payment Amount:', 'cqpim'); ?></p>
								
								<input style="width:270px" type="text" id="payment_amount" value="<?php echo get_option('currency_symbol'); ?>" />
								
								<div class="clear"></div>
								
								<?php echo '<button class="metabox-add-button" id="mark_paid" data-id="' . $post->ID . '">' . __('Add Payment', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>'; ?>								
							
							</div>
							
						</div>
						
					</div>
					
					<?php
					
				}
				
			}
			
			if($invoice_sent) {
			
				$invoice_sent = $invoice_details['sent_details'];
				
				$to = isset($invoice_sent['to']) ? $invoice_sent['to'] : '';
				
				$by = isset($invoice_sent['by']) ? $invoice_sent['by'] : '';
				
				$at = isset($invoice_sent['date']) ? $invoice_sent['date'] : '';
				
				if(is_numeric($at)) { $at = date(get_option('cqpim_date_format') . ' H:i', $at); } else { $at = $at; }
			
				echo '<div class="sent_quote">';
				
				printf(__('The invoice was sent to %1$s on %2$s by %3$s', 'cqpim'), $to, $at, $by);
				
				echo '</div>';
				
				if(current_user_can('cqpim_send_invoices')) {

					echo '<button id="send_invoice" data-type="resend" data-id="' . $post->ID . '">' . __('Resend Invoice', 'cqpim') . '</button>';
					
				
					if(!$paid) {
					
						if($due) {
						
							if($now > $due) {
							
								echo '<button class="send_reminder" data-type="overdue" data-id="' . $post->ID . '">' . __('Send Overdue Email', 'cqpim') . '</button>';		
							
							} else {
						
								echo '<button class="send_reminder" data-type="reminder" data-id="' . $post->ID . '">' . __('Send Reminder Email', 'cqpim') . '</button>';							
						
							}
						
						} 
					
					}
				
				}
				
				if(current_user_can('cqpim_mark_invoice_paid')) {

					echo '<button id="mark_paid_trigger" data-id="' . $post->ID . '">' . __('Add Payment', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>'; ?>
					
					<div id="invoice_payment_container" style="display:none">
					
						<div id="invoice_payment">
						
							<div style="padding:12px">
							
								<h3><?php _e('Add Payment', 'cqpim'); ?></h3>
								
								<p><?php _e('Payment Amount:', 'cqpim'); ?></p>
								
								<input style="width:270px" type="text" id="payment_amount" value="<?php echo get_option('currency_symbol'); ?>" />
								
								<p><?php _e('Payment Notes:', 'cqpim'); ?></p>
								
								<textarea style="width:400px; height:100px" id="payment_notes" name="payment_notes"></textarea>
								
								<div class="clear"></div>
								
								<?php echo '<button class="metabox-add-button" id="mark_paid" data-id="' . $post->ID . '">' . __('Add Payment', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>'; ?>								
							
							</div>
							
						</div>
						
					</div>
					
					<?php
					
				}
				
			}
		
		} else {
		
			$invoice_paid = $invoice_details['paid_details'];
				
			$by = isset($invoice_paid['by']) ? $invoice_paid['by'] : '';
				
			$at = isset($invoice_paid['date']) ? $invoice_paid['date'] : '';
			
			if(is_numeric($at)) { $at = date(get_option('cqpim_date_format') . ' H:i', $at); } else { $at = $at; }
			
			echo '<div class="confirmed_quote">';
			
			printf(__('The invoice was marked as paid by %1$s at %2$s', 'cqpim'), $by, $at);
			
			echo '</div>';
			
		}
		
		if(current_user_can('publish_cqpim_invoices')) {
		
			echo '<a class="button-link save" href="#">' . __('Update Invoice', 'cqpim') . '</a>';
			
		}
		
		$url = get_the_permalink($post->ID);
		
		if($post->post_name) {
		
			echo '<a class="button-link" href="' . $url . '" target="_blank">' . __('View Printable Invoice', 'cqpim') . '</a>';
		
		}
		
		if(current_user_can('publish_cqpim_invoices')) {
		
			echo '<div id="messages"></div>';
		
		}
		
}

// Save Project Details

add_action( 'save_post', 'save_invoice_client_project_metabox_data' );

function save_invoice_client_project_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['invoice_client_project_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['invoice_client_project_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'invoice_client_project_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	
	if(isset($_POST['invoice_number'])) {
	
		$invoice_id = $_POST['invoice_number'];
		
		update_post_meta($post_id, 'invoice_id', $invoice_id);
	
	}
	
	if(isset($_POST['invoice_project'])) {
	
		$project_id = $_POST['invoice_project'];
		
		$invoice_details = get_post_meta($post_id, 'invoice_details', true);
		
		$invoice_details['project_id'] = $project_id;
		
		update_post_meta($post_id, 'invoice_details', $invoice_details);
		
		update_post_meta($post_id, 'invoice_project', $project_id);

	
	}
	
	if(isset($_POST['client_contact'])) {
	
		$client_contact = $_POST['client_contact'];
		
		update_post_meta($post_id, 'client_contact', $client_contact);
	
	}
	
	if(isset($_POST['invoice_client'])) {
	
		$client_id = $_POST['invoice_client'];
		
		$invoice_details = get_post_meta($post_id, 'invoice_details', true);
		
		$invoice_details['client_id'] = $client_id;
		
		update_post_meta($post_id, 'invoice_details', $invoice_details);
		
		update_post_meta($post_id, 'invoice_client', $client_id);	
	}
	
	if(isset($_POST['invoice_date'])) {
	
		$invoice_details = get_post_meta($post_id, 'invoice_details', true);
		
		$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
		
		$client_details = get_post_meta($client_id, 'client_details', true);
		
		$client_terms = isset($client_details['invoice_terms']) ? $client_details['invoice_terms'] : '';
		
		$submitted = cqpim_convert_date($_POST['invoice_date']);
		
		if($client_terms) {
			
			$terms = $client_terms;
				
		} else {
			
			$terms = get_option('company_invoice_terms');
				
		}
		
		if($terms == 1) {
		
			$invoice_details['on_receipt'] = true;
		
		}
		
		$invoice_details['invoice_date'] = $submitted;
		
		$invoice_details['terms_over'] = strtotime('+' . $terms . ' days', $submitted);
		
		update_post_meta($post_id, 'invoice_details', $invoice_details);
	
	}
	
	$tax_app = get_post_meta($post_id, 'tax_set', true);
	
	if(empty($tax_app)) {
	
		$client_details = get_post_meta($client_id, 'client_details', true);
		
		$client_tax = isset($client_details['tax_disabled']) ? $client_details['tax_disabled'] : '';
		
		$system_tax = get_option('sales_tax_rate');
		
		if(!empty($system_tax) && empty($client_tax)) {
		
			update_post_meta($post_id, 'tax_applicable', 1);
			
			update_post_meta($post_id, 'tax_set', 1);	

			update_post_meta($post_id, 'tax_rate', $system_tax);	
		
		} else {
		
			update_post_meta($post_id, 'tax_applicable', 0);
			
			update_post_meta($post_id, 'tax_set', 1);

			update_post_meta($post_id, 'tax_rate', 0);			
		
		}
	
	}


}