<?php


// Invoice Items Metabox

function invoice_items_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'invoice_items_metabox', 

 	 	'invoice_items_metabox_nonce' ); 
		
		$line_items = get_post_meta($post->ID, 'line_items', true); 
		
		$currency = get_option('currency_symbol') ;
		
		?>
		
		<table style="table-layout: fixed" class="milestones">
		
			<thead>
			
				<tr>
				
					<th style="width:10%"><?php _e('Qty', 'cqpim'); ?></th>
					
					<th style="width:50%"><?php _e('Description', 'cqpim'); ?></th>
					
					<th style="width:15%"><?php _e('Price', 'cqpim'); ?> (<?php echo $currency; ?>)</th>
					
					<th style="width:15%"><?php _e('Total', 'cqpim'); ?> (<?php echo $currency; ?>)</th>
					
					<th style="width:10%">&nbsp;</th>
					
				</tr>
			
			</thead>
			
			</table>
	
		<div class="repeater">	
		
			<div data-repeater-list="group-a">
			
				
			  
					<?php if($line_items) { 
					
						$i = 0;
					
						foreach($line_items as $item) { ?>
						
							<div class="line_item" data-repeater-item>
							
								<table style="table-layout: fixed" class="milestones invoice-items">
								
									<tbody>
								
										<tr>							
						
											<td style="width:10%"><input data-row="<?php echo $i; ?>" id="invoice_qty_<?php echo $i; ?>" class="invoice_qty" type="text" name="qty" value="<?php echo $item['qty']; ?>" placeholder="<?php _e('Quantity', 'cqpim'); ?>" required /></td>
								
											<td style="width:50%"><input data-row="<?php echo $i; ?>" id="invoice_desc_<?php echo $i; ?>" class="invoice_desc" type="text" name="desc" value="<?php echo $item['desc']; ?>" placeholder="<?php _e('Description', 'cqpim'); ?>" required /></td>
								
											<td style="width:15%"><input data-row="<?php echo $i; ?>" id="invoice_price_<?php echo $i; ?>" class="invoice_price" type="text" name="price" value="<?php echo $item['price']; ?>" placeholder="<?php _e('Price', 'cqpim'); ?> (<?php echo get_option('currency_symbol'); ?>)" required /></td>

											<td style="width:15%"><input data-row="<?php echo $i; ?>" id="invoice_line_total_<?php echo $i; ?>" class="invoice_line_total" type="text" name="line_total" value="<?php echo $item['sub']; ?>" placeholder="<?php _e('Subtotal', 'cqpim'); ?>" readonly /></td>
									
											<td style="width:10%"><input data-row="<?php echo $i; ?>" class="line_delete" data-repeater-delete type="button" value=""/></td>

										</tr>
								
									</tbody>
								
								</table>
							
							</div>
					
					<?php $i++;
					
						} 
					
					} else { ?>
					
						<div class="line_item" data-repeater-item>
							
							<table style="table-layout: fixed" class="milestones invoice-items">
								
								<tbody>
								
									<tr>
				  
										<td style="width:10%"><input data-row="0" id="invoice_qty" class="invoice_qty" type="text" name="qty" value="" placeholder="<?php _e('Quantity', 'cqpim'); ?>" required /></td>
						
										<td style="width:50%"><input data-row="0" id="invoice_desc" class="invoice_desc" type="text" name="desc" value="" placeholder="<?php _e('Description', 'cqpim'); ?>" required /></td>
						
										<td style="width:15%"><input data-row="0" id="invoice_price" class="invoice_price" type="text" name="price" value="" placeholder="<?php _e('Price', 'cqpim'); ?> (<?php echo get_option('currency_symbol'); ?>)" required /></td>

										<td style="width:15%"><input data-row="0" id="invoice_line_total" class="invoice_line_total" type="text" name="line_total" value="" placeholder="<?php _e('Subtotal', 'cqpim'); ?>" readonly required /></td>
							
										<td style="width:10%"><input data-row="0" class="line_delete" data-repeater-delete type="button" value=""/></td>
						
									</tr>
								
								</tbody>
								
							</table>
							
						</div>
					
					<?php } ?>
				
			  
			</div>
			
			<input class="add_line_item_row" data-repeater-create type="button" value=""/>
			
		</div>
		
		<div class="totals">
		
			<?php 
			
				$vat_rate = get_post_meta($post->ID, 'tax_rate', true);
				
				$vat_active = get_option('sales_tax_rate');
			
				if(!empty($vat_rate) || cqpim_is_edit_page('new') && !empty($vat_active)) {
				
					$subtotal = __('Subtotal', 'cqpim');
					
				} else {
				
					$subtotal = __('Total', 'cqpim');
					
				}
				
				$totals = get_post_meta($post->ID, 'invoice_totals', true);
				
				$sub = isset($totals['sub']) ? $totals['sub'] : '';
				
				$vat = isset($totals['tax']) ? $totals['tax'] : '';
				
				$total = isset($totals['total']) ? $totals['total'] : '';
				
			?>
		
			<span><strong><?php echo $subtotal; ?> (<?php echo $currency; ?>)</strong></span>
		
			<input class="total_fields" type="text" name="invoice_subtotal" id="invoice_subtotal" value="<?php echo $sub; ?>" />
			
			<?php if(!empty($vat_rate) || cqpim_is_edit_page('new') && !empty($vat_active)) { 
			
				$tax_name = get_option('sales_tax_name'); ?>
			
					<span><strong><?php echo $tax_name; ?> (<?php echo $currency; ?>)</strong></span>
					
					<input type="hidden" id="tax_rate" name="tax_rate" value="<?php echo $vat_active; ?>" />
					
					<input class="total_fields" type="text" name="invoice_vat" id="invoice_vat" value="<?php echo $vat; ?>" />
					
					<span><strong><?php _e('Total', 'cqpim'); ?> (<?php echo $currency; ?>)</strong></span>
					
					<input class="total_fields" type="text" name="invoice_total" id="invoice_total" value="<?php echo $total; ?>" />
			
			<?php } else {
			
				$total = $sub;
				
			}
			
			$received = 0;
			
			$payments = get_post_meta($post->ID, 'invoice_payments', true);
			
			if(empty($payments)) {
			
				$payments = array();
				
			}
			
			foreach($payments as $payment) {
			 
				$amount = isset($payment['amount']) ? $payment['amount'] : 0;
				
				$received = $received + $amount;
			 
			}
			
			$outstanding = $total - $received;
			
			?>
				
			<span><strong><?php _e('Payments / Deductions', 'cqpim'); ?> (<?php echo $currency; ?>)</strong></span>
			
			<input class="total_fields" type="text" name="payments_received" id="payments_received" value="<?php echo number_format((float)$received, 2, '.', ''); ?>" readonly />
			
			<span><strong><?php _e('Total Outstanding', 'cqpim'); ?> (<?php echo $currency; ?>)</strong></span>
			
			<input class="total_fields" type="text" name="total_outstanding" id="total_outstanding" value="<?php echo number_format((float)$outstanding, 2, '.', ''); ?>" readonly />
		
		</div>
		
		<div class="clear"></div>
		
		<?php
		
}

add_action( 'save_post', 'save_invoice_items_metabox_data' );

function save_invoice_items_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['invoice_items_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['invoice_items_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'invoice_items_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	
	$line_items = array();
	
	if(isset($_POST['group-a'])) {
	
		$items_to_add = $_POST['group-a'];
		
		$i = 0;
		
		foreach($items_to_add as $item) {
		
			$line_items[] = array(
			
				'qty' => $item['qty'],
				
				'desc' => $item['desc'],
				
				'price' => $item['price'],
				
				'sub' => $item['line_total'],
			
			);
		
			$i++;
		
		}
		
		update_post_meta($post_id, 'line_items', $line_items);
		
		$sub = isset($_POST['invoice_subtotal']) ? $_POST['invoice_subtotal'] : '';
		
		$tax_rate = get_option('sales_tax_rate');
		
		if(!empty($tax_rate)) {
		
			$tax = $sub / 100 * $tax_rate;
			
			$total = $sub + $tax;
			
		} else {
		
			$tax = 0;
			
			$total = $sub;
			
		}
		
		$invoice_totals = array(
		
			'sub' => number_format((float)$sub, 2, '.', ''),
			
			'tax' => number_format((float)$tax, 2, '.', ''),
			
			'total' => number_format((float)$total, 2, '.', '')
		
		);
		
		update_post_meta($post_id, 'invoice_totals', $invoice_totals);
	
	} else {
	
		delete_post_meta($post_id, 'line_items');
		
		delete_post_meta($post_id, 'invoice_totals');
		
	}

}