		
			if(empty($quote_elements)) {
			
				echo '<p>' . __('You have not added any milestones to this project, please do so below', 'cqpim') . '</p>';
				
				$milestone_counter = 0;
				
			} else {
			
				$milestone_counter = 0;
				
				$currency = get_option('currency_symbol');
				
				if($type == 'estimate') { 
				
					$cost_title = __('Estimated Cost', 'cqpim');
					
				} else {
				
					$cost_title = __('Cost', 'cqpim');
					
				}
				
				echo '<table class="milestones">';
				
				echo '<thead>';
				
				echo '<tr><th>' . __('Type', 'cqpim') . '</th><th>' . __('Title', 'cqpim') . '</th><th>' . __('Start Date', 'cqpim') . '</th><th>' . __('Deadline', 'cqpim') . '</th><th>' . __('Progress / Status', 'cqpim') . '</th><th>' . __('Priority', 'cqpim') . '</th><th>' . __('Actions', 'cqpim') . '</th>';
				
				echo '</thead>';
			
				foreach($quote_elements as $key => $element) { 
				
					$cost = preg_replace("/[^\\d.]+/","", $element['cost']); 
				
					$task_status = isset($element['status']) ? $element['status'] : '';
					
					$task_deadline = isset($element['deadline']) ? $element['deadline'] : '';
					
					if(!is_numeric($task_deadline)) {
					
						$str_deadline = str_replace('/','-', $task_deadline);
					
						$deadline_stamp = strtotime($str_deadline);
					
					} else {
					
						$deadline_stamp = $task_deadline;
						
					}
					
					$now = time();
					
					if($task_status != 'complete') {
					
						if(!empty($deadline_stamp) && $now > $deadline_stamp) {
						
							$milestone_status_string = '<span class="task_over">' . __('OVERDUE', 'cqpim') . '</span>';
						
						} else {
						
							$milestone_status_string = isset($element['status']) ? $element['status'] : '';
							
							if(!$milestone_status_string || $milestone_status_string == 'pending') {
							
								$milestone_status_string = '<span class="task_pending">' . __('Pending', 'cqpim') . '</span>';
								
							} else if($milestone_status_string == 'on_hold') {
							
								$milestone_status_string = '<span class="task_over">' . __('On Hold', 'cqpim') . '</span>';
							
							}
						
						}
					
					} else {
					
						$milestone_status_string = '<span class="task_complete">' . __('Complete', 'cqpim') . '</span>';
					
					}?>
				
					<tr class="milestone">
					
						<td><span class="table-milestone"><?php _e('Milestone', 'cqpim'); ?></span></td>
					
						<td><?php echo $element['title']; ?></td>
						
						<td><?php if(is_numeric($element['start'])) { echo date(get_option('cqpim_date_format'), $element['start']); } else { echo $element['start']; } ?></td>
						
						<td><?php if(is_numeric($element['deadline'])) { echo date(get_option('cqpim_date_format'), $element['deadline']); } else { echo $element['deadline']; } ?></td>
						
						<td><?php echo $milestone_status_string; ?></td>
						
						<td></td>
						
						<td>
						
						<?php if(current_user_can('cqpim_edit_project_milestones')) { ?>
						
							<button class="edit-milestone" value="<?php echo $key; ?>"><img title="Edit Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/edit.png'; ?>" /></button> <button class="delete_stage_conf" data-id="<?php echo $key; ?>" value="<?php echo $key; ?>"><img title="Delete Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button>
						
						<?php } ?>
						
						<button class="add_task" data-ms="<?php echo $key; ?>" data-project="<?php echo $post->ID; ?>" value="<?php echo $key; ?>"><img title="Add Task to Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/new.png'; ?>" /></button>
						
						</td>
					
					</tr>
										
					<div id="delete-milestone-div-<?php echo $key; ?>-container" style="display:none">
					
						<div id="delete-milestone-div-<?php echo $key; ?>" class="delete-milestone-div">
						
							<div style="padding:12px">
						
								<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
							
								<p><?php _e('Deleting this milestone will also delete related tasks. Are you sure you want to do this?', 'cqpim'); ?></p>
								
								<button class="cancel_delete_stage"><?php _e('Cancel', 'cqpim'); ?></button> <button class="delete_stage" data-id="<?php echo $key; ?>" value="<?php echo $key; ?>"><?php _e('Delete', 'cqpim'); ?></button>
						
							</div>
						
						</div>
						
					</div>

					
					<?php 
					
					$args = array(
					
						'post_type' => 'cqpim_tasks',
						
						'posts_per_page' => -1,
						
						'meta_key' => 'milestone_id',
						
						'meta_value' => $key,
						
						'orderby' => 'date',
						
						'order' => 'ASC'
						
					);
					
					$tasks = get_posts($args);
					
					foreach($tasks as $task) {
					
					$task_details = get_post_meta($task->ID, 'task_details', true);
					
					$task_owner = get_post_meta($task->ID, 'owner', true);
					
					if($task_owner) {
					
						$team_details = get_post_meta($task_owner, 'team_details', true);
						
						$team_name = isset($team_details['team_name']) ? $team_details['team_name']: '';
						
						if(!empty($team_name)) {
						
							$task_owner = sprintf(__('(Assigned to: %1$s)'), $team_name);
						
						}
						
					} else {
					
						$task_owner = '';
						
						}
					
					$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
					
					$task_pc = isset($task_details['task_pc']) ? $task_details['task_pc'] : '0';
					
					$task_status = isset($task_details['status']) ? $task_details['status'] : '';
					
					$task_time = isset($task_details['task_time']) ? $task_details['task_time'] : '';
					
					$task_priority = isset($task_details['task_priority']) ? $task_details['task_priority'] : '';
					
					if(!is_numeric($task_deadline)) {
					
						$str_deadline = str_replace('/','-', $task_deadline);
					
						$deadline_stamp = strtotime($str_deadline);
					
					} else {
					
						$deadline_stamp = $task_deadline;
						
					}
					
					$now = time();
					
					if($task_status != 'complete') {
					
						if(!empty($deadline_stamp) && $now > $deadline_stamp) {
						
							$task_status_string = '<span class="task_over">' . __('OVERDUE', 'cqpim') . ' - ' . $task_pc . '%</span>';
						
						} else {
						
							$task_status_string = isset($task_details['status']) ? $task_details['status'] : '';
							
							if(!$task_status_string || $task_status_string == 'pending') {
							
								$task_status_string = '<span class="task_pending">' . __('Pending', 'cqpim') . ' - ' . $task_pc . '%</span>';
								
							} else if($task_status_string == 'on_hold') {
							
								$task_status_string = '<span class="task_over">' . __('On Hold', 'cqpim') . ' - ' . $task_pc . '%</span>';
							
							} else if($task_status_string == 'progress') {
							
								$task_status_string = '<span class="task_complete">' . __('In Progress', 'cqpim') . ' - ' . $task_pc . '%</span>';
							
							}
						
						}
					
					} else {
					
						$task_status_string = '<span class="task_complete">' . __('Complete', 'cqpim') . ' - ' . $task_pc . '%</span>';
					
					}
					
					if($task_priority == 'low') {
					
						$priority_string = '<span class="task_complete">' . __('Low', 'cqpim') . '</span>';
					
					} elseif($task_priority == 'normal') {
					
						$priority_string = '<span class="task_complete">' . __('Normal', 'cqpim') . '</span>';
					
					} elseif($task_priority == 'high') {
					
						$priority_string = '<span class="task_pending">' . __('High', 'cqpim') . '</span>';
					
					} elseif($task_priority == 'immediate') {
					
						$priority_string = '<span class="task_over">' . __('Immediate', 'cqpim') . '</span>';
					
					} elseif(empty($task_priority)) {
					
						$priority_string = '';
					
					}
					
					?>						
					
					<tr>
					
						<td><span class="table-task"><?php _e('Task', 'cqpim'); ?></span></td>
					
						<td colspan="2"><a href="<?php echo get_edit_post_link($task->ID); ?>"><?php echo $task->post_title; ?></a><br /><?php echo $task_owner; ?></td>
						
						<td><?php if(is_numeric($task_deadline)) { echo date(get_option('cqpim_date_format'), $task_deadline); } else { echo $task_deadline; } ?></td>
						
						<td style="text-transform:capitalize"><?php echo $task_status_string; ?></td>
						
						<td><?php echo $priority_string; ?></td>
						
						<td colspan="2"><button class="delete_task" data-id="<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>"><img title="Delete Task" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button> <div id="ajax_spinner_<?php echo $task->ID; ?>" class="ajax_spinner" style="display:none"></div></td>
					
					
					</tr>
					
					<?php } ?>
					
					<div id="add-task-div-<?php echo $key; ?>-container" style="display:none">
					
						<div id="add-task-div-<?php echo $key; ?>" class="add-task-div">
						
							<div style="padding:12px">
						
								<h3><?php _e('Add Task', 'cqpim'); ?></h3>
								
								<input type="hidden" id="task_milestone_id_<?php echo $key; ?>" name="task_milestone_id_<?php echo $key; ?>" value="<?php echo $key; ?>" />
								
								<input type="hidden" id="task_project_id_<?php echo $key; ?>" name="task_project_id_<?php echo $key; ?>" value="<?php echo $post->ID; ?>" />
							
								<input style="width:100%" type="text" name="task_title_<?php echo $key; ?>" id="task_title_<?php echo $key; ?>" placeholder="<?php _e('Task title', 'cqpim'); ?>"/><br /><br />					

								<textarea style="width:100%;height:180px" name="task_description_<?php echo $key; ?>" id="task_description_<?php echo $key; ?>" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea><br /><br />
								
								<input style="float:left" class="datepicker" type="text" name="task_start_<?php echo $key; ?>" id="task_start_<?php echo $key; ?>" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>	
			
								<input style="float:right" class="datepicker" type="text" name="task_finish_<?php echo $key; ?>" id="task_finish_<?php echo $key; ?>" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>	
								
								<div class="clear"></div>
								
								<?php
								
								$project_contributors = get_post_meta($post->ID, 'project_contributors', true);
								
								?>
								
								<br />
								
								<p><?php _e('If you do not assign this task to a team member, then it will be assigned to you.', 'cqpim'); ?></p>
								
								<select name="task_owner_<?php echo $key; ?>" id="task_owner_<?php echo $key; ?>">
								
									<option value=""><?php _e('Assign to', 'cqpim'); ?></option>
									
									<?php
									
									foreach($project_contributors as $contributor) {
									
										$team_details = get_post_meta($contributor, 'team_details', true);
										
										$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
								
										$team_job = isset($team_details['team_job']) ? $team_details['team_job'] : '';
										
										echo '<option value="' . $contributor . '">' . $team_name . ' - ' . $team_job . '</option>';
									
									}
									
									?>
								
								</select>
								
								<br /><br />
								
								<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
								
								<button class="save-task metabox-add-button" value="<?php echo $key; ?>"><?php _e('Add Task', 'cqpim'); ?></button><div class="ajax_spinner" style="display:none"></div>
							
								<div class="clear"></div>
								
								<div id="task-messages-<?php echo $key; ?>"></div>
							
							</div>
						
						</div>	
						
					</div>
					
					<?php if(current_user_can('cqpim_edit_project_milestones')) { ?>
					
					<div id="edit-milestone-<?php echo $key; ?>-container" style="display:none">
				
						<div id="edit-milestone-<?php echo $key; ?>" class="edit_milestone <?php echo $key; ?>">
						
							<div style="padding:12px">
						
								<h3><?php _e('Edit Milestone', 'cqpim'); ?></h3>
							
								<input type="hidden" name="added_element_milestone_id[<?php echo $key; ?>]" id="added_element_milestone_id[<?php echo $key; ?>]" value="<?php echo $element['id']; ?>" />

								<input type="hidden" name="added_element_comp[<?php echo $key; ?>]" id="added_element_comp[<?php echo $key; ?>]" value="<?php echo $element['already_comp']; ?>" />

								
								<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
							
								<input type="text" name="added_element_title[<?php echo $key; ?>]" id="added_element_title[<?php echo $key; ?>]" value="<?php echo $element['title']; ?>" />
								
								<br /><br />
														
								<span class="label"><strong><?php _e('Start Date:', 'cqpim'); ?></strong></span>

								<input class="datepicker" type="text" name="added_element_start[<?php echo $key; ?>]" id="added_element_start[<?php echo $key; ?>]" value="<?php if(is_numeric($element['start'])) { echo date(get_option('cqpim_date_format'), $element['start']); } else { echo $element['start']; } ?>" />

								<br /><br />
								
								<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>

								<input class="datepicker" type="text" name="added_element_finish[<?php echo $key; ?>]" id="added_element_finish[<?php echo $key; ?>]" value="<?php if(is_numeric($element['deadline'])) { echo date(get_option('cqpim_date_format'), $element['deadline']); } else { echo $element['deadline']; } ?>" />
													
								<br /><br />
								
								<?php if($type == 'estimate') { ?>
								
									<span class="label"><strong><?php _e('Estimated Cost:', 'cqpim'); ?></strong></span>
									
								<?php } else { ?>
								
									<span class="label"><strong><?php _e('Cost:', 'cqpim'); ?></strong></span>
									
								<?php } ?>

								<input type="text" name="added_element_cost[<?php echo $key; ?>]" id="added_element_cost[<?php echo $key; ?>]" value="<?php echo $element['cost']; ?>" />
													
								<br /><br />
								
								<?php $acost = isset($element['acost']) ? $element['acost'] : ''; ?>
								
								<span class="label"><strong><?php _e('Finished Cost:', 'cqpim'); ?></strong></span>
								
								<input class="finished-<?php echo $key; ?>" type="text" name="added_element_acost[<?php echo $key; ?>]" id="added_element_acost[<?php echo $key; ?>]" value="<?php echo $acost; ?>" />
								
								<br /><br />							
								
								<span class="label"><strong><?php _e('Status:', 'cqpim'); ?></strong></span>
								
								<select class="status-<?php echo $key; ?>" name="added_element_status[<?php echo $key; ?>]" id="added_element_status[<?php echo $key; ?>]">
								
									<option value="pending" <?php if(!$element['status'] || $element['status'] == 'pending') { echo 'selected="selected"'; } ?>><?php _e('Pending', 'cqpim'); ?></option>
									
									<option value="on_hold" <?php if($element['status'] == 'on_hold') { echo 'selected="selected"'; } ?>><?php _e('On Hold', 'cqpim'); ?></option>
									
									<option value="complete" <?php if($element['status'] == 'complete') { echo 'selected="selected"'; } ?>><?php _e('Complete', 'cqpim'); ?></option>
								
								</select>
								
								<?php 
								
								$checked = get_option('invoice_workflow');
								
								if($checked == 1) {
								
									echo '<p>' . __('Marking this milestone as complete will generate an invoice for the Finished cost, <br />minus the deposit percentage (if set)', 'cqpim') . '</p>';
								
								}
								
								?>
								
								<br /><br />
								
								<div id="update-ms-message-<?php echo $key; ?>"></div>

								<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
								
								<button class="save-milestone metabox-add-button" value="<?php echo $key; ?>"><?php _e('Save', 'cqpim'); ?></button>
										
								<div class="clear"></div>
							
							</div>
							
						</div>
						
					</div>
					
					<?php } ?>
				
				<?php $milestone_counter++;
				
				} 
				
				echo '</table>';
				
				?>
			
			<?php }
		
		} else {
		
			_e('Please update this post before adding milestones', 'cqpim');
			
		} ?>
		
		<br /><br /><br /><br />