<?php


// Project Files Metabox

function project_files_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'project_files_metabox', 

 	 	'project_files_metabox_nonce' ); 
			
	$all_attached_files = get_attached_media( '', $post->ID );
	
	$args = array(
	
		'post_type' => 'cqpim_tasks',
		
		'posts_per_page' => -1,
		
		'meta_key' => 'project_id',
		
		'meta_value' => $post->ID
	
	);
	
	$tasks = get_posts($args);
	
	foreach($tasks as $task) {
	
		$args = array(
		
			'post_parent' => $task->ID,
			
			'post_type' => 'attachment',
			
			'numberposts' => -1
		
		);
		
		$children = get_children($args);
		
		foreach($children as $child) {
		
			$all_attached_files[] = $child;
			
		}
	
	}
	
	if(!$all_attached_files) {
	
		echo '<p style="padding:20px">' . __('There are no files uploaded to this project.', 'cqpim') . '</p>';
	
	} else {
	
		echo '<table class="milestones files"><thead><tr>';
		
		echo '<th>' . __('File Name', 'cqpim') . '</th><th>' . __('Related Task', 'cqpim') . '</th><th>' . __('File Type', 'cqpim') . '</th><th>' . __('Uploaded', 'cqpim') . '</th><th>' . __('Uploaded By', 'cqpim') . '</th><th>' . __('Actions', 'cqpim') . '</th>';
		
		echo '</tr></thead><tbody>';
	
		foreach($all_attached_files as $file) {
		
			$file_object = get_post($file->ID);
			
			$url = get_the_permalink($file->ID);
			
			$parent = $file->post_parent;
			
			$parent_title = get_the_title($parent);
			
			$parent_title = str_replace('Protected: ', '', $parent_title);
			
			$parent_url = get_the_permalink($parent);
		
			$user = get_user_by( 'id', $file->post_author );
			
			echo '<tr>';
			
			echo '<td><a class="cqpim-link" href="' . $url . '">' . $file->post_title . '</a></td>';
			
			echo '<td><a class="cqpim-link" href="' . $parent_url . '">' . $parent_title . '</a></td>';
			
			echo '<td>' . $file->post_mime_type . '</td>';
			
			echo '<td>' . $file->post_date . '</td>';
			
			echo '<td>' . $user->display_name . '</td>';
			
			echo '<td><a href="' . $file->guid . '" download="' . $file->post_title . '" class="download_file" value="' . $file->ID . '"><img title="Download File" src="' .  plugin_dir_url( 'cqpim' ) . 'cqpim/img/download.png' . '" /></a> <button class="delete_file" data-id="' . $file->ID . '" value=""><img title="Delete File" src="' . plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png' . '" /></button> <div id="ajax_spinner_' . $file->ID . '" class="ajax_spinner" style="display:none"></div></td>';
			
			echo '</tr>';
		
		}
		
		echo '</tbody></table>'; ?>
		
			<div style="clear: both;"></div>
			
			<br /><br />
			
			<!--

			<p>

			    <input style="width:600px" type="text" name="meta_image" id="meta_image" />

			    <input style="background:#333; color:#fff; border:0" type="button" id="meta-image-button" class="button" value="<?php _e( 'Choose Files', 'cqpim' )?>" />

			    <button style="background:#333; color:#fff; border:0;" class="button save"><?php _e( 'Upload Files', 'cqpim' )?></button>
				
			</p>		
		
		-->
			<div class="clear"></div>		
		
		<?php
	
	}	

}

// save project files Metabox

add_action( 'save_post', 'save_project_files_metabox_data' );

function save_project_files_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['project_files_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['project_files_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'project_files_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	
	$duplicate = get_post_meta($post_id, 'duplicate', true);
	
	$now = time();
	
	$diff = $now - $duplicate;
	
	if($diff > 3) {
	
		if( isset( $_POST['delete_file'] ) ){

			$att_to_delete = $_POST['delete_file'];

			foreach ( $att_to_delete as $key => $attID ) {
			
				$file = get_post($attID);
					
				$current_user = wp_get_current_user();
				
				$project_progress = get_post_meta($post_id, 'project_progress', true);
						
				$project_progress[] = array(
						
					'update' => 'File Deleted - ' . $file->post_title,
							
					'date' => current_time('timestamp'),
					
					'by' => $current_user->display_name
							
				);
						
				update_post_meta($post_id, 'project_progress', $project_progress );

				//wp_delete_attachment( $attID, TRUE );
				global $wpdb;
				
				$wpdb->query(
					
					"
					UPDATE $wpdb->posts 
					SET post_parent = ''
					WHERE ID = $attID
					AND post_type = 'attachment'
					"
					
				);

			}

		}
		
		$attachments_to_add = isset($_POST['meta_image']) ? $_POST['meta_image'] : '';
		
		if(!empty($attachments_to_add)) {
		
			$image_urls = explode(',', $attachments_to_add);
			
			$image_urls = array_filter($image_urls);
			
			foreach($image_urls as $image_url) {
			
				$image_id = cqpim_get_image_id_by_url ( $image_url );
				
				$file = get_post($image_id);
				
				$current_user = wp_get_current_user();
				
				$project_progress = get_post_meta($post_id, 'project_progress', true);
						
				$project_progress[] = array(
						
					'update' => 'File Uploaded - ' . $file->post_title,
							
					'date' => current_time('timestamp'),
					
					'by' => $current_user->display_name
							
				);
						
				update_post_meta($post_id, 'project_progress', $project_progress );
				
				global $wpdb;
				
				$wpdb->query(
					
					"
					UPDATE $wpdb->posts 
					SET post_parent = $post_id
					WHERE ID = $image_id
					AND post_type = 'attachment'
					"
					
				);
				

				$meta = wp_get_attachment_metadata($image_id);
				
				if (!$meta) {
				
					$file = get_attached_file($image_id);
				
					if (!empty($file)) {
				
						$info = getimagesize($file);
					
						$meta = array (
					
							'width' => $info[0],
						
							'height' => $info[1],
						
							'hwstring_small' => "height='{$info[1]}' width='{$info[0]}'",
						
							'file' => basename($file),
						
							'sizes' => array(),         // thumbnails etc.
						
							'image_meta' => array(),    // EXIF data
						
						);
					
						update_post_meta($id, '_wp_attachment_metadata', $meta);
						
					}
					
				}		
		
			}	
			
		}
	
		update_post_meta($post_id, 'duplicate', time());
	
	}
	
}