<?php


// project Financials Metabox

function project_financials_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'project_financials_metabox', 

 	 	'project_financials_metabox_nonce' ); 
		
		$args = array(
		
			'post_type' => 'cqpim_invoice',
			
			'posts_per_page' => -1,
			
			'post_status' => 'publish',
			
			'orderby' => 'date',
			
			'order' => 'DESC'
		
		);
		
		$invoices = get_posts($args);

		$total_paid = 0;
		
		foreach($invoices as $invoice) {
		
			$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
			
			$invoice_payments = get_post_meta($invoice->ID, 'invoice_payments', true);
			
			if(empty($invoice_payments)) {
			
				$invoice_payments = array();
				
			}
			
			if($invoice_details['project_id'] == $post->ID) {
			
				foreach($invoice_payments as $payment) {
				
					$amount = isset($payment['amount']) ? $payment['amount'] : 0;
					
					$total_paid = $total_paid + $amount;
				
				}

			}
			
		}
		
		$quote_elements = get_post_meta($post->ID, 'project_elements', true);
		
		$quote_extras = get_post_meta($post->ID, 'project_extras', true);
		
		$quote_details = get_post_meta($post->ID, 'project_details', true);
		
		$type = isset($quote_details['quote_type']) ? $quote_details['quote_type'] : '';
		
		if($quote_elements) {
			
			echo '<table class="quote_summary"><thead><tr>';
			
			echo '<th>' . __('Milestone', 'cqpim') . '</th>';
			
			if($type == 'estimate') {
				
				echo '<th>' . __('Estimated Cost', 'cqpim') . '</th>';
				
				echo '<th>' . __('Final Cost', 'cqpim') . '</th>';
			
			} else {
			
				echo '<th>' . __('Cost', 'cqpim') . '</th>';
				
				echo '<th>' . __('Final Cost', 'cqpim') . '</th>';
				
			}
			
			echo '</tr></thead>';
			
			echo '<tbody>';
			
			$subtotal = 0;
			
			$asubtotal = 0;
			
			$currency = get_option('currency_symbol');
			
			$ordered = array();
			
			$i = 0;
			
			$mi = 0;
			
			foreach($quote_elements as $key => $element) {
			
				$weight = isset($element['weight']) ? $element['weight'] : $mi;
			
				$ordered[$weight] = $element;
				
				$mi++;
			
			}
			
			ksort($ordered);
		
			foreach($ordered as $element) {
			
				$acost = isset($element['acost']) ? $element['acost'] : '';
			
				$cost = preg_replace("/[^\\d.]+/","", $element['cost']);
				
				$acost = preg_replace("/[^\\d.]+/","", $acost);
			
				$subtotal = $subtotal + $cost;
				
				$asubtotal = $asubtotal + $acost;
			
				echo '<tr><td>' . $element['title'] . '</td>';
				
				if(1) {
					
					echo '<td>' . $currency . '' . $cost . '</td>';
					
					if($acost) {
					
						if($acost > $cost) {
						
							$class = 'over';
							
						}
						
						if($acost < $cost) {
						
							$class = 'under';
							
						}
						
					if($acost == $cost) {
						
						$class = 'under';
							
					}
					
						echo '<td class="' . $class . '">' . $currency . '' . $acost . '</td>';
					
					} else {
					
						echo '<td><span style="color:#d9534f">' . __('PENDING', 'cqpim') . '</span></td>';
					
					}
				
				} else {
				
					echo '<td>' . $currency . '' . $cost . '</td></tr>';
					
				}
			
			}
			

						
				$span = '';
							
			if($asubtotal > $subtotal) {
				
				$class = 'over';
					
			}
				
			if($asubtotal < $subtotal) {
				
				$class = 'under';
					
			}
			
			if($asubtotal == $subtotal) {
				
				$class = 'under';
					
			}			
		
			$vat = get_post_meta($post->ID, 'tax_rate', true);
			
			if(!empty($vat)) {
			
				// Estimated
			
				$total_vat = $subtotal / 100 * $vat;
				
				$total = $subtotal + $total_vat;
				
				$tax_name = get_option('sales_tax_name');
				
				$outstanding = $total - $total_paid;
				
				// Actual
				
				$atotal_vat = $asubtotal / 100 * $vat;
				
				$atotal = $asubtotal + $atotal_vat;
				
				$aoutstanding = $atotal - $total_paid;
				
				echo '<tr><td ' . $span . ' align="right" class="quote-align-right">' . __('Subtotal:', 'cqpim') . '</td>';
				
				echo '<td class="subtotal">' . $currency . '' . $subtotal . '</td>';
					
				echo '<td class="subtotal ' . $class . '">' . $currency . '' . $asubtotal . '</td>';			
				
				
				
				echo '</tr>';
				
				echo '<tr><td ' . $span . ' align="right" class="quote-align-right">' . $tax_name . ': </td>';
				
				echo '<td class="subtotal">' . $currency . '' . number_format((float)$total_vat, 2, '.', '') . '</td>';
				
				
					
					echo '<td class="subtotal">' . $currency . '' . number_format((float)$atotal_vat, 2, '.', '') . '</td>';			
				
				
				
				echo '</tr>';

				echo '<tr><td ' . $span . ' align="right" class="quote-align-right">' . __('TOTAL:', 'cqpim') . '</td>';
				
				echo '<td class="subtotal">' . $currency . '' . number_format((float)$total, 2, '.', '') . '</td>';
				
				
					
					echo '<td class="subtotal">' . $currency . '' . number_format((float)$atotal, 2, '.', '') . '</td>';			
				
				
				
				echo '</tr>';
				

				
					echo '<tr><td colspan="2" align="right" class="quote-align-right">' . __('Received:', 'cqpim') . '</td>';
								
					
					echo '<td class="subtotal">' . $currency . '' . $total_paid . '</td>';			
				
			
				echo '</tr>';
				
					echo '<tr><td colspan="2" align="right" class="quote-align-right">' . __('Outstanding:', 'cqpim') . '</td>';
					
					echo '<td class="subtotal">' . $currency . '' . number_format((float)$aoutstanding, 2, '.', '') . '</td>';			
				
				echo '</tr>';
				
			} else {
			
				$atotal = $asubtotal;
				
				$aoutstanding = $atotal - $total_paid;
				
				$span = 'colspan="2"';
			
				echo '<tr><td align="right" class="quote-align-right">' . __('TOTAL:', 'cqpim') . '</td><td class="subtotal">' . $currency . '' . number_format((float)$subtotal, 2, '.', '') . '</td><td class="subtotal ' . $class . '">' . $currency . '' . number_format((float)$asubtotal, 2, '.', '') . '</td></tr>';

				echo '<tr><td ' . $span . ' align="right" class="quote-align-right">' . __('Received:', 'cqpim') . '</td><td class="subtotal">' . $currency . '' . number_format((float)$total_paid, 2, '.', '') . '</td></tr>';				

				echo '<tr><td ' . $span . ' align="right" class="quote-align-right">' . __('Outstanding:', 'cqpim') . '</td><td class="subtotal">' . $currency . '' . number_format((float)$aoutstanding, 2, '.', '') . '</td></tr>';
				
			}
			
			echo '</tbody></table>';
			
		
		} else {
		
			echo '<p>' . __('You have not added any milestones. Please add at least one milestone to enable this section', 'cqpim') . '</p>';
		
		} 
		
}