<?php


function project_messages_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'project_messages_metabox', 

 	 	'project_messages_metabox_nonce' );
		
		$project_messages = get_post_meta($post->ID, 'project_messages', true);
		
		if(!$project_messages) {
		
			echo '<p>No messages to show...</p>';
		
		} else {
		
			echo '<div class="project_messages">';
			
			$project_messages = array_reverse($project_messages);
			
			foreach($project_messages as $key => $message) { 
			
				$user = get_user_by('id', $message['author']);

				$email = $user->user_email;
				
				$size = 80;
				
				$grav_url = "https://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "&s=" . $size;			
				
				?>
			
				<div class="project_message">
				
					<div class="user_avatar">
					
						<img src="<?php echo $grav_url; ?>" />
					
					</div>
					
					<div class="message_details">
					
						<h4>
						
							<?php echo $message['by']; ?>
							
							<?php
							
								echo '<button style="float:right" class="delete_message" data-id="' . $key . '" value=""><img title="Delete File" src="' . plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png' . '" /></button> <div id="ajax_spinner_' . $key . '" class="ajax_spinner" style="display:none; float:right"></div>';
							
							 ?>							
							
						</h4>
						
						<span><?php echo date(get_option('cqpim_date_format') . ' H:i', $message['date']); ?></span>
						
						<div class="message">
						
							<?php echo wpautop($message['message']); ?>
						
						</div>
					
					</div>
					
					<div class="clear"></div>
				
				</div>
			
			<?php }
			
			echo '</div>';		
		
		} ?>
		
		<button id="add_message_trigger" class="metabox-add-button"><?php _e('Send Message', 'cqpim'); ?></button>
		
		<div class="clear"></div>
		
		<div id="add_message_container" style="display:none">
		
			<div id="add_message">
			
				<div style="padding:12px">
			
					<h3><?php _e('Send Message', 'cqpim'); ?></h3>
					
					<p><strong><?php _e('Message Visibility', 'cqpim'); ?></strong></p>
					
					<input type="hidden" id="message_who" value="admin" />
					
					<select id="add_message_visibility" name="add_message_visibility">
					
						<option value="all"><?php _e('Visible to All', 'cqpim'); ?></option>
						
						<option value="internal"><?php _e('Internal Message (Client cannot see this)', 'cqpim'); ?></option>
					
					</select>
					
					<br />
					
					<p><strong><?php _e('Message Notifications', 'cqpim'); ?></strong></p>
					
					<input type="checkbox" id="send_to_team" name="send_to_team" /> <?php _e('Send a notification to the Project Team', 'cqpim'); ?>
					
					<br /><br />
					
					<input type="checkbox" id="send_to_client" name="send_to_client" /> <?php _e('Send a notification to the client', 'cqpim'); ?>
					
					<br />
					
					<p><strong><?php _e('Message', 'cqpim'); ?></strong></p>
					
					<textarea style="width:100%; height:200px;min-width:400px" id="add_message_text" name="add_message_text"></textarea>
					
					<br />
					
					<div id="message_messages"></div>
					
					<div id="ajax_spinner_message" class="ajax_spinner" style="display:none"></div>
					
					<button id="add_message_ajax" class="metabox-add-button"><?php _e('Send Message', 'cqpim'); ?></button>
					
					<div class="clear"></div>
				
				</div>
			
			</div>
		
		</div>

	<?php
}