<?php

// Project Contributors Metabox

function project_contributors_metabox_callback( $post ) {

	$meta = get_post_meta($post->ID, 'project_details', true);
	
	//print_r($meta);

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'project_contributors_metabox', 

 	 	'project_contributors_metabox_nonce' );
		
		$project_contributors = get_post_meta($post->ID, 'project_contributors', true);
		
		if(!$project_contributors) {
		
			echo '<p>' . __('There are no team members assigned to this project', 'cqpim') . '</p>';
			
		} else {
		
			foreach($project_contributors as $key => $contributor) {
			
				$team_details = get_post_meta($contributor, 'team_details', true);
				
				$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
				
				if(current_user_can('edit_cqpim_teams')) {
				
					$team_url = get_edit_post_link($contributor);
					
					$team_name = '<a href="' . $team_url . '" target="_blank">' . $team_name . '</a>';
				
				}
							
				$team_job = isset($team_details['team_job']) ? $team_details['team_job'] : '';
				
				$team_email = isset($team_details['team_email']) ? $team_details['team_email'] : '';
							
				$team_telephone = isset($team_details['team_telephone']) ? $team_details['team_telephone'] : '';

				$size = 100;
	
				$grav_url = "http://www.gravatar.com/avatar/" . md5( strtolower( trim( $team_email ) ) ) . "&s=" . $size;
				
				echo '<div class="team_member">';
				
				if(current_user_can('cqpim_edit_project_members')) {
				
					echo '<div class="team_delete"><button class="delete_team" data-team="' . $contributor . '" value="' . $key . '"><img title="Remove Team Member" src="' . plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png"></button><div id="ajax_spinner_team_' . $key . '" class="ajax_spinner" style="display:none"></div></div>';
				
				}
				
				echo '<img style="float:left" src="' . $grav_url . '" />';
				
				echo '<div class="team_details">';
				
				echo '<strong>' . __('Name:', 'cqpim') . ' </strong>' . $team_name . "<br />";
				
				echo '<strong>' . __('Job Title:', 'cqpim') . ' </strong>' . $team_job . "<br />";
				
				echo '<strong>' . __('Email:', 'cqpim') . ' </strong>' . $team_email . "<br />";
				
				echo '<strong>' . __('Telephone:', 'cqpim') . ' </strong>' . $team_telephone . "<br />";
				
				echo '</div>';
				
				echo '<div class="clear"></div>';
				
				echo '</div>';
			
			}
			
			echo '<div class="clear"></div>';
		
		}
		
		if(current_user_can('cqpim_edit_project_members')) {
				
			echo '<button id="add_team_member" class="metabox-add-button" value="">' . __('Add Team Member', 'cqpim') . '</button>';
		
		}
		
		echo '<div class="clear"></div>';
		
		?>
		
		<div id="add_team_member_div_container" style="display:none">
		
			<div id="add_team_member_div">
			
				<div style="padding:12px">
			
					<h3><?php _e('Add Team Member', 'cqpim'); ?></h3>
					
					<p><?php _e('Adding a team member to this project will give them access <br />
					
					to the project tasks and allow them to edit, assign and complete tasks.', 'cqpim'); ?></p>
					
					<p><strong><?php _e('Choose team member to add:', 'cqpim'); ?></strong></p>
					
					<?php 
					
						$project_contributors = get_post_meta($post->ID, 'project_contributors', true);
					
						$args = array(
						
							'post_type' => 'cqpim_teams',
							
							'posts_per_page' => -1,
							
							'post_status' => 'private'
						
						);
						
						$team_members = get_posts($args);
						
						echo '<select id="team_members">';
						
						if($team_members) {
						
							echo '<option value="">' . __('Choose a Team Member', 'cqpim') . '</option>';
						
							foreach($team_members as $team_member) {
							
								$team_details = get_post_meta($team_member->ID, 'team_details', true);
								
								$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
								
								$team_job = isset($team_details['team_job']) ? $team_details['team_job'] : '';
								
								if(in_array($team_member->ID, $project_contributors)) {
								
									$added = 'style="display:none"';
									
								} else {
								
									$added = '';
									
								}
							
								echo '<option value="' . $team_member->ID . '" ' . $added . '>' . $team_name . ' - ' . $team_job . '</option>';
							
							}
						
						} else {
						
							echo '<option value="">' . __('No Team Members Available', 'cqpim') . '</option>';
						
						}
						
						echo '</select>';
						
					?>
					
					<br /><br />
					
					<div id="add_team_messages"></div>
				
					<button id="add_team_member_ajax" class="metabox-add-button" value=""><?php _e('Add Team Member', 'cqpim'); ?></button>
				
					<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
					
					<div style="display:none" id="add_team_ajax_spinner" class="ajax_spinner"></div>
					
					<div class="clear"></div>
				
				</div>
			
			</div>
		
		</div>
		
		<?php
		
}