<?php



// Quote Status Metabox

function quote_status_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'quote_status_metabox', 

 	 	'quote_status_metabox_nonce' );
		
		$quote_details = get_post_meta($post->ID, 'quote_details', true);
		
		$quote_elements = get_post_meta($post->ID, 'quote_elements', true);
		
		$quote_client = isset($quote_details['client_id']) ? $quote_details['client_id'] : '';

		$quote_ref = isset($quote_details['quote_ref']) ? $quote_details['quote_ref'] : '';

		$quote_summary = isset($quote_details['quote_summary']) ? $quote_details['quote_summary'] : '';
		
		$start_date = isset($quote_details['start_date']) ? $quote_details['start_date'] : '';

		$finish_date = isset($quote_details['finish_date']) ? $quote_details['finish_date'] : '';
		
		$quote_header = isset($quote_details['quote_header']) ? $quote_details['quote_footer'] : '';
		
		$quote_footer = isset($quote_details['quote_footer']) ? $quote_details['quote_footer'] : '';

		$quote_deposit = isset($quote_details['deposit_amount']) ? $quote_details['deposit_amount'] : '';
		
		// Status Table
		
		?>
		
		<table class="quote_status">
		
			<tr>
			
				<td class="title underline"><?php _e('Quote / Estimate Details', 'cqpim'); ?></td>
				
				<td></td>
				
			</tr>
		
			<tr>
			
				<?php $classes = ( !empty( $quote_client ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Client', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $quote_ref ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Quote / Estimate Ref', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $quote_summary ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Project Brief', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $start_date ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Start Date', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $finish_date ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Deadline', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $quote_header ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Quote / Estimate Header', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $quote_footer ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Quote / Estimate Footer', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
			<tr>
			
				<td class="title">&nbsp;</td>
				
				<td></td>
				
			</tr>
			
			<tr>
			
				<td class="title underline"><?php _e('Milestones', 'cqpim'); ?></td>
				
				<td></td>
				
			</tr>
			
			<?php if(!$quote_elements) { ?>
			
				<tr>
				
					<td class="title"><?php _e('No Milestones Added', 'cqpim'); ?></td>
					
					<td class="red"></td>
					
				</tr>

			<?php } else {
			
				$ordered = array();
				
				$i = 0;
				
				$mi = 0;
				
				foreach($quote_elements as $key => $element) {
				
					$weight = isset($element['weight']) ? $element['weight'] : $mi;
				
					$ordered[$weight] = $element;
					
					$mi++;
				
				}
				
				ksort($ordered);
			
				foreach($ordered as $element) { ?>
				
					<tr>
					
						<?php $classes = ( !empty( $element['title'] ) && !empty( $element['cost'] ) ) ? 'green' : 'red'; ?>
					
						<td class="title"><?php echo $element['title']; ?></td>
						
						<td class="<?php echo $classes; ?>"></td>
						
					</tr>				
				
				<?php $i++; }					
			
			}
			
			?>
			
			<tr>
			
				<td class="title">&nbsp;</td>
				
				<td></td>
				
			</tr>
			
			<tr>
			
				<td class="title underline"><?php _e('Deposit', 'cqpim'); ?></td>
				
				<td></td>
				
			</tr>
			
			<tr>
			
				<?php $classes = ( !empty( $quote_deposit ) ) ? 'green' : 'red'; ?>
			
				<td class="title"><?php _e('Initial Deposit', 'cqpim'); ?></td>
				
				<td class="<?php echo $classes; ?>"></td>
				
			</tr>
			
		</table>
		
		<?php
		
		$url = get_the_permalink($post->ID);
		
		$quote_sent = isset($quote_details['sent']) ? $quote_details['sent'] : '';
		
		$quote_accepted = isset($quote_details['confirmed']) ? $quote_details['confirmed'] : '';
		
		$quote_type = isset($quote_details['quote_type']) ? $quote_details['quote_type'] : '';
		
		if($quote_type == 'estimate') {
		
			$type = __('estimate', 'cqpim');
		
		} else {
		
			$type = __('quote', 'cqpim');
		
		}	
		
		if(!$quote_accepted) {
		
			if(empty($quote_sent)) {
			
				echo '<div class="unsent_quote">';
				
				printf(__('This %s has not yet been sent to the client.', 'cqpim'), $type);
				
				echo '</div>';
				
				if(current_user_can('cqpim_send_quotes')) { 
				
					echo '<button id="send_quote" data-id="' . $post->ID . '">' . __('Send Quote / Estimate', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>';
				
					echo '<a href="' . $url . '?page=print" target="_blank">' . __('Preview Quote / Estimate', 'cqpim') . '</a>';
					
				}
				
			}
			
			if($quote_sent) {
			
				$quote_sent = $quote_details['sent_details'];
				
				$to = isset($quote_sent['to']) ? $quote_sent['to'] : '';
				
				$by = isset($quote_sent['by']) ? $quote_sent['by'] : '';
				
				$at = isset($quote_sent['date']) ? $quote_sent['date'] : '';
				
				if(is_numeric($at)) { $at = date(get_option('cqpim_date_format') . ' H:i', $at); } else { $at = $start_date; }
			
				echo '<div class="sent_quote">';
				
				printf(__('This %1$s was sent to %2$s on %3$s by %4$s', 'cqpim'), $type, $to, $at, $by);
				
				echo '</div>';
					
				if(current_user_can('cqpim_send_quotes')) { 
				
					echo '<button id="send_quote" data-id="' . $post->ID . '">' . __('Resend Quote / Estimate', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>';
				
					echo '<a href="' . $url . '?page=print" target="_blank">' . __('Preview Quote / Estimate', 'cqpim') . '</a>';
					
				}
				
			}
		
		} else {
		
			$quote_accepted = $quote_details['confirmed_details'];
				
			$ip = isset($quote_accepted['ip']) ? $quote_accepted['ip'] : '';
				
			$by = isset($quote_accepted['by']) ? $quote_accepted['by'] : '';
				
			$at = isset($quote_accepted['date']) ? $quote_accepted['date'] : '';
			
			if(is_numeric($at)) { $at = date(get_option('cqpim_date_format') . ' H:i', $at); } else { $at = $at; }
			
			echo '<div class="confirmed_quote">';
			
			printf(__('This %1$s was accepted by %2$s on %3$s from IP Address %4$s', 'cqpim'), $type, $by, $at, $ip);
			
			echo '</div>';	
				
			if(current_user_can('cqpim_send_quotes')) { 
			
				echo '<button id="send_quote" data-id="' . $post->ID . '">' . __('Resend Quote / Estimate', 'cqpim') . '</button><div style="display:none" class="ajax_spinner"></div>';
			
				echo '<a href="' . $url . '?page=print" target="_blank">' . __('Preview Quote / Estimate', 'cqpim') . '</a>';
			}
			
		}
		
		if(current_user_can('publish_cqpim_quotes')) {
		
			echo '<button class="save" data-id="' . $post->ID . '">' . __('Update Quote / Estimate', 'cqpim') . '</button>';
			
			echo '<div id="messages"></div>';
		
		}
		
}