<?php



function support_details_metabox_callback( $post ) {

	$meta = get_post_meta($post->ID, 'ticket_updates', true);
	
	//print_r($meta);

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'support_details_metabox', 

 	 	'support_details_metabox_nonce' );
		
		$ticket_author = $post->post_author;
		
		$author_details = get_user_by('id', $ticket_author);
		
		$ticket_client = get_post_meta($post->ID, 'ticket_client', true);
		
		$ticket_owner = get_post_meta($post->ID, 'ticket_owner', true);
		
		$owner_details = get_post_meta($ticket_owner, 'team_details', true);
		
		$owner_name = isset($owner_details['team_name']) ? $owner_details['team_name'] : '';
		
		$client_details = get_post_meta($ticket_client, 'client_details', true);
		
		$client_name = isset($client_details['client_company']) ? $client_details['client_company'] : '';
	
		$ticket_status = get_post_meta($post->ID, 'ticket_status', true);
		
		$ticket_priority = get_post_meta($post->ID, 'ticket_priority', true);
		
		$ticket_updated = get_post_meta($post->ID, 'last_updated', true);
		
		if(is_numeric($ticket_updated)) { $ticket_updated = date(get_option('cqpim_date_format') . ' H:i', $ticket_updated); } else { $ticket_updated = $ticket_updated; }
		
		if(empty($ticket_status)) {
		
			$status = '<span class="low_priority">' . __('Unpublished', 'cqpim') . '</div>';
		
		}
		
		if($ticket_status == 'open') {
		
			$status = '<span class="low_priority">' . __('Open', 'cqpim') . '</div>';
		
		} else if($ticket_status == 'resolved') {
		
			$status = '<span class="task_complete">' . __('Resolved', 'cqpim') . '</div>';
		
		} else if($ticket_status == 'hold') {
		
			$status = '<span class="high_priority">' . __('On Hold', 'cqpim') . '</div>';
		
		}
		
		if(empty($ticket_priority)) {
		
			$priority = '<span class="low_priority">' . __('Unpublished', 'cqpim') . '</div>';
		
		}
		
		if($ticket_priority == 'low') {
		
			$priority = '<span class="low_priority">' . __('Low', 'cqpim') . '</div>';
		
		} else if($ticket_priority == 'normal') {
		
			$priority = '<span class="normal_priority">' . __('Normal', 'cqpim') . '</div>';
		
		} else if($ticket_priority == 'high') {
		
			$priority = '<span class="high_priority">' . __('High', 'cqpim') . '</div>';
		
		} else if($ticket_priority == 'immediate') {
		
			$priority = '<span class="immediate_priority">' . __('Immediate', 'cqpim') . '</div>';
		
		}
		
		?>
		
		<?php if(empty($ticket_client)) { ?>
		
			<div style="padding:10px 10px 10px; background:#d9534f">
		
			<p style="margin:0; color:#fff"><?php _e('Select a Client', 'cqpim'); ?>:</p>
			
			<select name="new_ticket_client" required="required">
			
				<option value=""><?php _e('Choose a Client', 'cqpim'); ?></option>
			
				<?php $args = array(
				
					'post_type' => 'cqpim_client',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private'
				
				); 
				
				$clients = get_posts($args);
				
				foreach($clients as $client) {
				
					$client_details = get_post_meta($client->ID, 'client_details', true);
					
					$client_contacts = get_post_meta($client->ID, 'client_contacts', true);
					
					$user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
					
					$client_name = isset($client_details['client_company']) ? $client_details['client_company'] : '';
					
					$contact_name = isset($client_details['client_contact']) ? $client_details['client_contact'] : '';
					
					echo '<option value="' . $user_id . '">' . $client_name . ' - ' . $contact_name . '</option>';
					
					if(!empty($client_contacts)) {
					
						foreach($client_contacts as $contact) {
						
							echo '<option value="' . $contact['user_id'] . '">' . $client_name . ' - ' . $contact['name'] . '</option>';
						
						}
					
					}
				
				}
				
				?>
			
			</select>
			
			</div>

			<br />
		
		<?php } ?>
		
		<table class="milestones">
		
			<tbody>
			
				<tr>
				
					<td><strong><?php _e('Ticket ID', 'cqpim'); ?></strong></td>
					
					<td><?php echo $post->ID; ?></td>
				
				</tr>
				
				<?php if(!empty($ticket_client)) { ?>
				
					<tr>
					
						<td><strong><?php _e('Client Name', 'cqpim'); ?></strong></td>
						
						<td><?php echo '<a href="' . get_edit_post_link($ticket_client) . '">' . $client_name . '</a>'; ?></td>					
					
					</tr>
				
				<?php } ?>
				
				<tr>
				
					<td><strong><?php _e('Ticket Created', 'cqpim'); ?></strong></td>
					
					<td><?php echo get_the_date(get_option('cqpim_date_format') . ' H:i'); ?></td>
				
				</tr>
				
				<tr>
				
					<td><strong><?php _e('Last Updated', 'cqpim'); ?></strong></td>
					
					<td><?php echo $ticket_updated; ?></td>
				
				</tr>
				
				<tr>
				
					<td><strong><?php _e('Ticket Priority', 'cqpim'); ?></strong></td>
					
					<td><?php echo $priority; ?></td>
				
				</tr>
				
				<tr>
				
					<td><strong><?php _e('Ticket Status', 'cqpim'); ?></strong></td>
					
					<td><?php echo $status; ?></td>
				
				</tr>
				
				<tr>
				
					<td><strong><?php _e('Assigned To', 'cqpim'); ?></strong></td>
					
					<td><?php echo $owner_name; ?></td>
				
				</tr>
			
			</tbody>
		
		</table>
		
		<?php if(current_user_can('delete_cqpim_supports')) { ?>
		
		<button style="background:#d9534f" class="s_button" data-id="<?php echo $post->ID; ?>" id="delete_task"><?php _e('DELETE TICKET', 'cqpim'); ?></button>
		
		<?php } ?>

		<button class="s_button" data-id="<?php echo $post->ID; ?>"><?php _e('Update Ticket', 'cqpim'); ?></button><div id="ajax_spinner_task" class="ajax_spinner_2" style="display:none"></div>

		
		<?php
}