<?php


function support_files_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'support_files_metabox', 

 	 	'support_files_metabox_nonce' );
		
	$meta = get_post_meta($post->ID, 'ticket_updates', true);

	//print_r($meta);
	
	$all_attached_files = get_attached_media( '', $post->ID );
	
	if(empty($all_attached_files)) {
	
		echo '<p>' . __('There are no files uploaded to this ticket.', 'cqpim') . '</p>';
	
	} else {
	
	
		echo '<h4>' . __('Attached Files', 'cqpim') . '</h4>';
	
		echo '<table class="milestones"><thead><tr>';
		
		echo '<th>' . __('File Name', 'cqpim') . '</th><th>' . __('File Type', 'cqpim') . '</th><th>' . __('Uploaded', 'cqpim') . '</th><th>' . __('Uploaded By', 'cqpim') . '</th><th>' . __('Actions', 'cqpim') . '</th>';
		
		echo '</tr></thead><tbody>';
	
		foreach($all_attached_files as $file) {
		
			$file_object = get_post($file->ID);
			
			$link = get_the_permalink($file->ID);
		
			$user = get_user_by( 'id', $file->post_author );
		
			echo '<tr>';
			
			echo '<td><a href="' . $file->guid . '" target="_blank">' . $file->post_title . '</a></td>';
			
			echo '<td>' . $file->post_mime_type . '</td>';
			
			echo '<td>' . $file->post_date . '</td>';
			
			echo '<td>' . $user->display_name . '</td>';
			
			echo '<td><a href="' . $file->guid . '" download="' . $file->post_title . '" class="download_file" value="' . $file->ID . '"><img title="Download File" src="' .  plugin_dir_url( 'cqpim' ) . 'cqpim/img/download.png' . '" /></a> <button class="delete_file" data-id="' . $file->ID . '" value=""><img title="Delete File" src="' . plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png' . '" /></button> <div id="ajax_spinner_' . $file->ID . '" class="ajax_spinner" style="display:none"></div></td>';
			
			echo '</tr>';
		
		}
		
		echo '</tbody></table>';
	
	}
		
}