<?php



function support_history_metabox_callback( $post ) {


	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'support_history_metabox', 

 	 	'support_history_metabox_nonce' );
		
		//$_SESSION['times'] = 0;
		
		//echo $_SESSION['times'];
		
		$ticket_client = get_post_meta($post->ID, 'ticket_client', true);
		
		$ticket_updates = get_post_meta($post->ID, 'ticket_updates', true);
		
		$ticket_status = get_post_meta($post->ID, 'ticket_status', true);
		
		$ticket_priority = get_post_meta($post->ID, 'ticket_priority', true);
		
		echo '<div class="project_messages">';
		
		if(empty($ticket_updates)) {
		
			$ticket_updates = array();
			
			echo '<p>' . __('No updates have been posted to this ticket', 'cqpim') . '</p>';
			
		}
		
		$ticket_updates = array_reverse($ticket_updates);
		
		foreach($ticket_updates as $key => $update) {
		
			if($update['type'] == 'client') {
			
				$user = get_post_meta($update['user'], 'client_details', true);
				
				$email = isset($user['client_email']) ? $user['client_email'] : '';
				
				$name = isset($user['client_contact']) ? $user['client_contact'] : '';
			
			} else {
			
				$user = get_post_meta($update['user'], 'team_details', true);
				
				$email = isset($user['team_email']) ? $user['team_email'] : '';
				
				$name = isset($user['team_name']) ? $user['team_name'] : '';
			
			}
			
			$changes = isset($update['changes']) ? $update['changes'] : '';
			
			$size = 80;
			
			if(isset($update['email'])) {
			
				$email = $update['email'];
				
			}
			
			$grav_url = "https://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "&s=" . $size;			
			
			?>
		
			<div class="project_message">
			
				<div class="user_avatar">
				
					<img src="<?php echo $grav_url; ?>" />
				
				</div>
				
				<div class="message_details">
				
					<h4>
					
						<?php 
						
						if(isset($update['name'])) {
						
							echo $update['name'];
							
						} else {
						
							echo $name; 
							
						}
						
						echo '<button style="float:right" class="delete_message" data-id="' . $key . '" value=""><img title="Delete File" src="' . plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png' . '" /></button> <div id="ajax_spinner_' . $key . '" class="ajax_spinner" style="display:none; float:right"></div>';
						
						?>							
						
					</h4>
					
					<span>
					
						<?php 
						
						if(is_numeric($update['time'])) { $time = date(get_option('cqpim_date_format') . ' H:i', $update['time']); } else { $time = $update['time']; }
						
						echo $time; 
					
						if($changes) {
						
							foreach($changes as $change) {
							
								echo ' | ' . $change;
							
							}
						
						}
						
						?>
					
					</span>
					
					<div class="message">
					
						<?php echo wpautop($update['details']); ?>
					
					</div>
				
				</div>
				
				<div class="clear"></div>
			
			</div>
			
			<?php			
		
		}

		echo '</div>';	
		
}