<?php



function task_time_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'task_time_metabox', 

 	 	'task_time_metabox_nonce' );
		
	$time_spent = get_post_meta($post->ID, 'task_time_spent', true);
	
	$task_details = get_post_meta($post->ID, 'project_id', true);
					
	if($time_spent) {
	
		$total = 0;
	
		echo '<ul class="time_spent">';
		
		foreach($time_spent as $key => $time) {
		
			$user = wp_get_current_user();
			
			$args = array(
			
				'post_type' => 'cqpim_teams',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private'
			
			);
			
			$members = get_posts($args);
			
			foreach($members as $member) {
			
				$team_details = get_post_meta($member->ID, 'team_details', true);
				
				if($team_details['user_id'] == $user->ID) {
				
					$assigned = $member->ID;
				
				}
			
			}
			
			if($assigned == $time['team_id'] || current_user_can('cqpim_dash_view_all_tasks')) {
			
				$delete = ' - <a class="time_remove" href="#" data-key="'. $key .'" data-task="'. $post->ID .'">' . __('REMOVE', 'cqpim') . '</a>';
			
			} else {
			
				$delete = '';
			
			}
		
			echo '<li>' . $time['team'] . ' <span style="float:right" class="right"><strong>' . number_format((float)$time['time'], 2, '.', '') . ' ' . __('HOURS', 'cqpim') . '</strong> ' . $delete . '</span></li>';
		
			$total = $total + $time['time'];
		}
		
		echo '</ul>';
		
		$total = str_replace(',','.', $total);
		
		$time_split = explode('.', $total);
		
		if(!empty($time_split[1])) {
		
			$minutes = '0.' . $time_split[1];
		
			$minutes = $minutes * 60;
			
			$minutes = number_format((float)$minutes, 0, '.', '');
		
		} else {
		
			$minutes = '0';
			
		}
		
		if($time_split[0] > 1) {
		
			$hours  = 'hours';
			
		} else {
		
			$hours = 'hour';
		
		}
		
		echo '<span><strong>TOTAL: ' . number_format((float)$total, 2, '.', '') . ' ' . __('hours', 'cqpim') . '</strong> (' . $time_split[0] . ' ' . $hours . ' + ' . $minutes . ' ' . __('minutes', 'cqpim') . ')</span> <div id="ajax_spinner_remove_time_'. $post->ID .'" class="ajax_spinner" style="display:none"></div>';
	
	} else {
	
		echo '<span style="display:block; padding:10px" class="task_over">' . __('This task does not have any time assigned to it', 'cqpim') . '</span>';
	
	}
	
	?>
	
	<p><strong><?php _e('Manually Add Time', 'cqpim'); ?></strong></p>
	
	<p><?php _e('(This should be in hours, eg. for 30 minutes enter 0.5)', 'cqpim'); ?></p>
	
	<input style="width:100%" type="text" name="task_add_time" id="task_add_time" value="" placeholder="0.5">
	
	<button class="s_button2" id="add_mtime_ajax"><?php _e('Add Time', 'cqpim'); ?></button>
	
	<p><strong><?php _e('Add Time Using Timer', 'cqpim'); ?></strong></p>
		
	<input style="width:60%; display:block; float:left; margin-right:10px;" id="task_time_value" type="text" name="timer" class="form-control timer" placeholder="0 sec" />
	
	<button class="btn btn-success start-timer-btn"><img title="Start Timer" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/play.png'; ?>"></button>
	
	<button class="btn btn-success resume-timer-btn hidden"><img title="Resume Timer" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/play.png'; ?>"></button>
	
	<button class="btn pause-timer-btn hidden"><img title="Pause Timer" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/pause.png'; ?>"></button>
	
	<button class="btn btn-danger remove-timer-btn hidden"><img title="Remove Timer" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>"></button>					

	<input type="hidden" id="task_time_task" value="<?php echo $post->ID; ?>" />
	
	<div class="clear"></div>
					
	<button class="s_button2" id="add_time_ajax"><?php _e('Add Time from Timer', 'cqpim'); ?></button><div id="ajax_spinner_timer" class="ajax_spinner_2" style="display:none"></div>
	
	<br />
	
	<button style="background:#d9534f" class="s_button" data-id="<?php echo $post->ID; ?>" id="delete_task"><?php _e('DELETE TASK', 'cqpim'); ?></button><div id="ajax_spinner_task" class="ajax_spinner_2" style="display:none"></div>

	<button class="s_button" data-id="<?php echo $post->ID; ?>"><?php _e('Update Task', 'cqpim'); ?></button><div id="ajax_spinner_task" class="ajax_spinner_2" style="display:none"></div>	
		
	<?php if(!empty($task_details)) { ?>
	
		<a class="button-link" href="<?php echo get_edit_post_link($task_details); ?>"><?php _e('Back to Project', 'cqpim'); ?></a>
	
	<?php } ?>
	
	<?php
				
}

add_action( 'save_post', 'save_task_time_metabox_data' );

function save_task_time_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['task_time_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['task_time_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'task_time_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	

	
	
}