<?php
 
 /**

 * Define and add the metaboxes

 */

add_action( 'add_meta_boxes', 'add_templates_cpt_metaboxes' );

function add_templates_cpt_metaboxes(){

	add_meta_box( 

		'templates_template', 

		__('Milestones & Tasks', 'cqpim'),

		'templates_metabox_callback', 

		'cqpim_templates', 

		'normal',
		
		'high'

	);
	
	if(!current_user_can('publish_cqpim_templates')) {
	
		remove_meta_box( 'submitdiv', 'cqpim_templates', 'side' );
		
	}

}

function templates_metabox_callback( $post ) {

	// Add an nonce field so we can check for it later.

 	wp_nonce_field( 

 	 	'templates_metabox', 

 	 	'templates_metabox_nonce' );
		
		$template = get_post_meta($post->ID, 'project_template', true);
		
		$i = 0;
		
		if(empty($template)) {
		
			echo '<p>' . __('You haven\'t added any milestones or tasks to this template.', 'cqpim') . '</p>';
		
		} else {
			
			$currency = get_option('currency_symbol');
			
			$cost_title = __('Cost', 'cqpim');
			
			$ordered = array();
			
			//echo '<pre>';
			
			//print_r($template);
			
			//echo '</pre>';
			
			$i = 0;
			
			$mi = 0;
			
			foreach($template as $key => $element) {
			
				$weight = isset($element['weight']) ? $element['weight'] : $mi;
			
				$ordered[$weight] = $element;
				
				$mi++;
			
			}
			
			ksort($ordered);
			
			// New Elements
			
			echo '<div id="dd-container">';
		
			foreach($ordered as $key => $element) { 
			
				$eweight = isset($element['weight']) ? $element['weight'] : '';
			
				$cost = preg_replace("/[^\\d.]+/","", $element['cost']); 
				
				$task_deadline = isset($element['deadline']) ? $element['deadline'] : '';
				
				?>
			
				<div class="dd-milestone">
				
					<input type="hidden" class="element_weight" name="element_weight[<?php echo $element['id']; ?>]" id="element_weight[<?php echo $element['id']; ?>]" value="<?php if(!empty($eweight)) { echo $eweight; } else { echo $i; } ?>" />
				
					<div class="dd-milestone-title">
					
						<span class="table-milestone" style="margin-right:10px;"><?php _e('Milestone', 'cqpim'); ?></span> <strong><?php echo $element['title']; ?></strong>
						
						<div class="dd-milestone-actions">
						
							<?php if(empty($quote_details['confirmed'])) { ?>
						
								<button class="edit-milestone" value="<?php echo $element['id']; ?>"><img title="Edit Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/edit.png'; ?>" /></button> <button class="delete_stage_conf" data-id="<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>"><img title="Delete Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button> <button class="add_task" data-ms="<?php echo $element['id']; ?>" data-project="<?php echo $post->ID; ?>" value="<?php echo $key; ?>"><img title="Add Task to Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/new.png'; ?>" /></button> <button class="dd-reorder" value="<?php echo $key; ?>"><img title="Reorder Milestone" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/reorder.png'; ?>" /></button>
					
							<?php } else { ?>
							
								<span class="task_over"><?php _e('LOCKED', 'cqpim'); ?></span>
							
							<?php } ?>							
						
						</div>
						
						<div class="clear"></div>
					
					</div>
					
					<div class="dd-tasks" data-ms="<?php echo $key; ?>">
					
						<?php 
						
						$tasks = isset($element['tasks']) ? $element['tasks'] : array();
						
						$ti = 0;
						
						$ordered = array();
						
						$wi = 0;
						
						foreach($tasks as $task) {
							
							$weight = isset($task['weight']) ? $task['weight'] : $wi;
							
							$ordered[$weight] = $task;
							
							$wi++;
						
						}
						
						ksort($ordered);
						
						foreach($ordered as $tkey => $task) { 
						
							$weight = isset($task['weight']) ? $task['weight'] : '';
							
							?>	

							<div class="dd-task">
							
								<input class="task_weight" type="hidden" value="<?php if(!empty($weight)) { echo $weight; } else { echo $ti; } ?>" />
							
								<input class="task_id" type="hidden" value="<?php echo $task['id']; ?>" />
								
								<input class="ms_id" type="hidden" value="<?php echo $element['id']; ?>" />
								
								<span class="table-task" style="margin-right:10px"><?php _e('Task', 'cqpim'); ?></span> <strong><?php echo $task['title']; ?></strong>
								
								<div class="dd-task-actions">
									
									<button class="edit-task" data-ms="<?php echo $element['id']; ?>" value="<?php echo $task['id']; ?>"><img title="Edit Task" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/edit.png'; ?>" /></button> <button class="delete_task" data-tid="<?php echo $post->ID; ?>" data-ms="<?php echo $element['id']; ?>" value="<?php echo $task['id']; ?>"><img title="Delete Task" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/delete.png'; ?>" /></button> <button class="dd-reorder" value="<?php echo $tkey; ?>"><img title="Reorder Task" src="<?php echo plugin_dir_url( 'cqpim' ) . 'cqpim/img/reorder.png'; ?>" /></button> <div id="ajax_spinner_<?php echo $element['id']; ?><?php echo $tkey; ?>" class="ajax_spinner" style="display:none"></div>
								
								</div>
								
								<div class="clear"></div>						
							
							</div>
							
							<div id="edit-task-div-<?php echo $element['id']; ?><?php echo $task['id'] ?>-container" style="display:none">
							
								<div id="edit-task-div-<?php echo $element['id']; ?><?php echo $task['id'] ?>" class="edit-task-div">
								
									<div style="padding:12px">
								
										<h3><?php _e('Edit Task', 'cqpim'); ?></h3>
										
										<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
										
										<input type="hidden" id="task_id_<?php echo $element['id']; ?><?php echo $task['id']; ?>" name="task_id_<?php echo $element['id']; ?><?php echo $task['id']; ?>" value="<?php echo $task['id']; ?>" />
										
										<input type="hidden" id="task_ms_<?php echo $element['id']; ?><?php echo $task['id']; ?>" name="task_ms_<?php echo $element['id']; ?><?php echo $task['id']; ?>" value="<?php echo $element['id']; ?>" />
									
										<input type="text" name="task_title_<?php echo $element['id']; ?><?php echo $task['id']; ?>" id="task_title_<?php echo $element['id']; ?><?php echo $task['id']; ?>" value="<?php echo $task['title']; ?>" placeholder="<?php _e('Task title', 'cqpim'); ?>"/>							

										<br /><br />
										
										<span class="label"><strong><?php _e('Description:', 'cqpim'); ?></strong></span>
										
										<textarea style="width:100%;height:180px" name="task_description_<?php echo $element['id']; ?><?php echo $task['id']; ?>" id="task_description_<?php echo $element['id']; ?><?php echo $task['id']; ?>" placeholder="<?php _e('Task description', 'cqpim'); ?>"><?php echo $task['description']; ?></textarea>
										
										<br /><br />
										
										<span class="label"><strong><?php _e('Start:', 'cqpim'); ?></strong></span>
										
										<input class="datepicker" type="text" name="task_start_<?php echo $element['id']; ?><?php echo $task['id']; ?>" id="task_start_<?php echo $element['id']; ?><?php echo $task['id']; ?>" value="<?php if(is_numeric($task['start'])) { echo date(get_option('cqpim_date_format'), $task['start']); } else { echo $task['start']; } ?>" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>														
										
										<br /><br />
										
										<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>
										
										<input class="datepicker" type="text" name="task_finish_<?php echo $element['id']; ?><?php echo $task['id']; ?>" id="task_finish_<?php echo $element['id']; ?><?php echo $task['id']; ?>" value="<?php if(is_numeric($task['deadline'])) { echo date(get_option('cqpim_date_format'), $task['deadline']); } else { echo $task['deadline']; } ?>" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>	
										
										<br /><br />
										
										<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
										
										<button class="update-task metabox-add-button" data-ms="<?php echo $element['id']; ?>" value="<?php echo $task['id']; ?>"><?php _e('Save', 'cqpim'); ?></button><div id="ajax_spinner_edit_<?php echo $element['id']; ?><?php echo $task['id']; ?>" class="ajax_spinner" style="display:none"></div>
									
										<div class="clear"></div>
										
										<div id="task-messages-<?php echo $key; ?><?php echo $task['id']; ?>"></div>
									
									</div>
								
								</div>	
								
							</div>
						
						<?php $ti++; } 
						
						if($ti == 0) {
						
							_e('You have not added any tasks to this milestone', 'cqpim');
						
						}
						
						?>
					
					</div>
				
				</div>
									
				<div id="delete-milestone-div-<?php echo $element['id']; ?>-container" style="display:none">
				
					<div id="delete-milestone-div-<?php echo $element['id']; ?>" class="delete-milestone-div">
					
						<div style="padding:12px">
					
							<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
						
							<p><?php _e('Deleting this milestone will also delete related tasks. Are you sure you want to do this?', 'cqpim'); ?></p>
							
							<button class="cancel_delete_stage"><?php _e('Cancel', 'cqpim'); ?></button> <button class="delete_stage" data-id="<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>"><?php _e('Delete', 'cqpim'); ?></button>
					
						</div>
					
					</div>
					
				</div>
				
				<div id="add-task-div-<?php echo $element['id']; ?>-container" style="display:none">
				
					<div id="add-task-div-<?php echo $element['id']; ?>" class="add-task-div">
					
						<div style="padding:12px">
					
							<h3><?php _e('Add Task', 'cqpim'); ?></h3>
							
							<input type="hidden" id="task_milestone_id_<?php echo $element['id']; ?>" name="task_milestone_id_<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>" />
							
							<input type="hidden" id="task_project_id_<?php echo $element['id']; ?>" name="task_project_id_<?php echo $element['id']; ?>" value="<?php echo $post->ID; ?>" />
						
							<input style="width:100%" type="text" name="task_title_<?php echo $element['id']; ?>" id="task_title_<?php echo $element['id']; ?>" placeholder="<?php _e('Task title', 'cqpim'); ?>"/><br /><br />					

							<textarea style="width:100%;height:180px" name="task_description_<?php echo $element['id']; ?>" id="task_description_<?php echo $element['id']; ?>" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea><br /><br />
							
							<input style="float:left" class="datepicker" type="text" name="task_start_<?php echo $element['id']; ?>" id="task_start_<?php echo $element['id']; ?>" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>	
		
							<input style="float:right" class="datepicker" type="text" name="task_finish_<?php echo $element['id']; ?>" id="task_finish_<?php echo $element['id']; ?>" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>	
							
							<div class="clear"></div>
							
							<br /><br />
							
							<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
							
							<button class="save-task metabox-add-button" value="<?php echo $element['id']; ?>"><?php _e('Add Task', 'cqpim'); ?></button><div class="ajax_spinner" style="display:none"></div>
						
							<div class="clear"></div>
							
							<div id="task-messages-<?php echo $key; ?>"></div>
						
						</div>
					
					</div>	
					
				</div>
				
				<div id="edit-milestone-<?php echo $element['id']; ?>-container" style="display:none">
			
					<div id="edit-milestone-<?php echo $element['id']; ?>" class="edit_milestone <?php echo $element['id']; ?>">
					
						<div style="padding:12px">
					
							<h3><?php _e('Edit Milestone', 'cqpim'); ?></h3>
						
							<input type="hidden" name="added_element_milestone_id[<?php echo $element['id']; ?>]" id="added_element_milestone_id[<?php echo $element['id']; ?>]" value="<?php echo $element['id']; ?>" />
							
							<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
						
							<input type="text" name="added_element_title[<?php echo $element['id']; ?>]" id="added_element_title[<?php echo $element['id']; ?>]" value="<?php echo $element['title']; ?>" />
							
							<br /><br />
													
							<span class="label"><strong><?php _e('Start Date:', 'cqpim'); ?></strong></span>

							<input class="datepicker" type="text" name="added_element_start[<?php echo $element['id']; ?>]" id="added_element_start[<?php echo $element['id']; ?>]" value="<?php if(is_numeric($element['start'])) { echo date(get_option('cqpim_date_format'), $element['start']); } else { echo $element['start']; } ?>" />

							<br /><br />
							
							<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>

							<input class="datepicker" type="text" name="added_element_finish[<?php echo $element['id']; ?>]" id="added_element_finish[<?php echo $element['id']; ?>]" value="<?php if(is_numeric($element['deadline'])) { echo date(get_option('cqpim_date_format'), $element['deadline']); } else { echo $element['deadline']; } ?>" />
												
							<br /><br />
							
							<span class="label"><strong><?php _e('Estimated Cost:', 'cqpim'); ?></strong></span>

							<input type="text" name="added_element_cost[<?php echo $element['id']; ?>]" id="added_element_cost[<?php echo $element['id']; ?>]" value="<?php echo $element['cost']; ?>" />
							
							<br /><br />
							
							<div id="update-ms-message-<?php echo $element['id']; ?>"></div>

							<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
							
							<button class="save metabox-add-button" value="<?php echo $element['id']; ?>"><?php _e('Save', 'cqpim'); ?></button>
									
							<div class="clear"></div>
						
						</div>
						
					</div>
					
				</div>
			
			<?php $i++;
			
			} 
			
			echo '</div>';		

		} ?>
		
		<a href="#add-milestone-div" id="add-milestone" class="metabox-add-button colorbox"><?php _e('Add Milestone', 'cqpim'); ?></a>
		
		<a href="#clear-all-div" id="clear-all" class="metabox-add-button colorbox"><?php _e('Clear All', 'cqpim'); ?></a>
		
		<div class="clear"></div>
		
		<div id="add-milestone-div-container" style="display:none">
		
			<div id="add-milestone-div">
			
				<div style="padding:12px">
			
					<h3><?php _e('Add Milestone', 'cqpim'); ?></h3>
				
					<input type="text" name="quote_element_title" id="quote_element_title" placeholder="<?php _e('Milestone title, eg. \'Design Phase\'', 'cqpim'); ?>"/>
				
					<input type="hidden" id="add_milestone_id" name="add_milestone_id" value="<?php echo $i; ?>" />
					
					<input type="hidden" id="add_milestone_order" name="add_milestone_order" value="<?php echo $i + 1; ?>" />
					
					<input class="datepicker" type="text" name="quote_element_start" id="quote_element_start" placeholder="<?php _e('Start', 'cqpim'); ?>"/>

					<input class="datepicker" type="text" name="quote_element_finish" id="quote_element_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>
					
					<input type="text" name="quote_element_cost" id="quote_element_cost" placeholder="<?php _e('Estimated Cost', 'cqpim'); ?>"/>
					
					<br /><br />
					
					<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
					
					<button id="add_quote_element" class="metabox-add-button"><?php _e('Add milestone to Project Template', 'cqpim'); ?></button> <div class="ajax_spinner" style="display:none"></div>
			
				</div>
			
			</div>	
			
		</div>
		
		<div id="clear-all-div-container" style="display:none">
		
			<div id="clear-all-div">
			
				<div style="padding:12px">
			
					<h3><?php _e('Clear All', 'cqpim'); ?></h3>
				
					<p><?php _e('Are you sure you want to clear all Milestones and Tasks? This cannot be undone.', 'cqpim'); ?></p>
					
					<br /><br />
					
					<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
					
					<button id="clear-all-action" class="metabox-add-button" value="<?php echo $post->ID; ?>"><?php _e('Clear All', 'cqpim'); ?></button> <div class="ajax_spinner" style="display:none"></div>
			
				</div>
			
			</div>	
			
		</div>
		
		<?php
		
}

add_action( 'save_post', 'save_templates_metabox_data' );

function save_templates_metabox_data( $post_id ){

	//  verify this came from the our screen and with proper authorization

	// Check if our nonce is set.

	if ( ! isset( $_POST['templates_metabox_nonce'] ) )

	    return $post_id;

	// Verify that the nonce is valid.

	$nonce = $_POST['templates_metabox_nonce'];

	if ( ! wp_verify_nonce( $nonce, 'templates_metabox' ) )

	    return $post_id;

	// If this is an autosave, our form has not been submitted, so we don't want to do anything.

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 

	    return $post_id;

	// Check the user's permissions.

	if ( 'page' == $_POST['post_type'] ) {

	    if ( ! current_user_can( 'edit_page', $post_id ) )

	        return $post_id;

	  	} else {

	    if ( ! current_user_can( 'edit_post', $post_id ) )

	        return $post_id;

	}
	
	if(isset($_POST['added_element_title'])) {
	
		$title_array = $_POST['added_element_title'];
		
		$quote_elements = get_post_meta($post_id, 'project_template', true);
		
		foreach($title_array as $key => $to_add) {
		
			$title = $to_add;
			
			$milestone_id = $_POST['added_element_milestone_id'][$key];
			
			$milestone_start = $_POST['added_element_start'][$key];	
			
			$milestone_start = cqpim_convert_date($milestone_start);
			
			$milestone_deadline = $_POST['added_element_finish'][$key];
			
			$milestone_weight = $_POST['element_weight'][$key];
			
			$milestone_deadline = cqpim_convert_date($milestone_deadline);
			
			$cost = $_POST['added_element_cost'][$key];
		
			$quote_elements[$key] = array(
			
				'deadline' => $milestone_deadline,
				
				'title' => $title,
				
				'start' => $milestone_start,
				
				'id' => $milestone_id,
				
				'cost' => $cost,
				
				'tasks' => $quote_elements[$key]['tasks'],
				
				'weight' => $milestone_weight
			
			);
		
		}
		
		update_post_meta($post_id, 'project_template', $quote_elements);
	
	}
	
	if(isset($_POST['delete_stage'])) {
	
		$stages_to_delete = $_POST['delete_stage'];
		
		$quote_elements = get_post_meta($post_id, 'project_template', true);
		
		foreach($stages_to_delete as $key => $delete) {
		
			unset($quote_elements[$delete]);
			
		}
		
		update_post_meta($post_id, 'project_template', $quote_elements);
	
	}

}
