<?php

	/**

	* Register all custom non admin scrips in one function and then call them

	* conditionally as and when required.

	*/

	// REGISTER ALL SCRIPTS TO BE LOADED ON BOTH FRONT AND BACKEND

	add_action( 'wp_loaded', 'cqpim_register_front_and_back_scripts' );

	function cqpim_register_front_and_back_scripts(){

		wp_register_script( 

			'jquery-min',

			'https://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js',

			array( 'jquery' ),

			FALSE,

			TRUE

		);

		wp_register_script( 

			'jquery-ui',

			'https://code.jquery.com/ui/1.11.4/jquery-ui.min.js',

			array( 'jquery' ),

			FALSE,

			TRUE

		);

		// JQUERY UI CSS

		wp_register_style( 

			'jquery-ui-styles', 

			'https://code.jquery.com/ui/1.10.3/themes/smoothness/jquery-ui.css',

			array(), 

			'1.10.3', 

			'all' 

		);	
		
		wp_register_script( 

			'colorbox',

			plugins_url()  . '/cqpim/assets/colorbox/jquery.colorbox-min.js', 

			array( 'jquery' ), 

			NULL, 

			TRUE 

		);	

		wp_register_style( 

			'colorbox-styles', 

			plugins_url()  . '/cqpim/assets/colorbox/colorbox.css',

			array(), 

			NULL, 

			'all'

		);
		
		// DataTables
		
		wp_register_script( 

			'datatables',

			plugins_url()  . '/cqpim/assets/jquery-datatables/js/jquery.dataTables.min.js', 

			array( 'jquery' ), 

			NULL, 

			TRUE 

		);	

		wp_register_style( 

			'datatables-styles', 

			plugins_url()  . '/cqpim/assets/jquery-datatables/css/jquery.dataTables.min.css',

			array(), 

			NULL, 

			'all'

		);
		
		wp_register_style( 

			'cqpim-upload-styles', 

			plugins_url()  . '/cqpim/assets/jquery-uploader/assets/css/style.css',

			array(), 

			NULL, 

			'all'

		);
		
		wp_register_script( 

			'cqpim-upload-knob',

			plugins_url()  . '/cqpim/assets/jquery-uploader/assets/js/jquery.knob.js', 

			array( 'jquery' ), 

			NULL, 

			TRUE 

		);
		
		wp_register_script( 

			'cqpim-upload-transport',

			plugins_url()  . '/cqpim/assets/jquery-uploader/assets/js/jquery.iframe-transport.js', 

			array( 'jquery' ), 

			NULL, 

			TRUE 

		);	
		
		wp_register_script( 

			'cqpim-upload-widget',

			plugins_url()  . '/cqpim/assets/jquery-uploader/assets/js/jquery.ui.widget.js', 

			array( 'jquery' ), 

			NULL, 

			TRUE 

		);
		
		wp_register_script( 

			'cqpim-upload-fileupload',

			plugins_url()  . '/cqpim/assets/jquery-uploader/assets/js/jquery.fileupload.js', 

			array( 'jquery' ), 

			NULL, 

			TRUE 

		);
		
		wp_register_script( 

			'cqpim-upload-main',

			plugins_url()  . '/cqpim/assets/jquery-uploader/assets/js/script.js', 

			array( 'jquery' ), 

			NULL, 

			TRUE 

		);

	}	

	// REGISTER ALL NON-ADMIN (FRONTEND) SCRIPTS

	add_action( 'wp_enqueue_scripts', 'cqpim_register_all_non_admin_scripts' );

	function cqpim_register_all_non_admin_scripts() {
	
		wp_register_style( 

			'masonry', 

			plugins_url()  . '/cqpim/assets/masonry/masonry.js',

			array('jquery'), 

			NULL,

			TRUE

		);

		wp_register_style( 

			'cqpim-frontend-styles', 

			plugins_url()  . '/cqpim/css/frontend-styles.css',

			array(), 

			'1.10.3', 

			'all' 

		);
		
		wp_register_style( 

			'print-styles', 

			plugins_url()  . '/cqpim/css/cqpim-print.css',

			array(), 

			'1.10.3', 

			'print' 

		);
		
		wp_register_style( 

			'raleway-font', 

			'https://fonts.googleapis.com/css?family=Raleway:400,600',

			array(), 

			'1.10.3', 
			
			'all'

		);
		
		wp_register_script( 

			'quote-frontend-ajax',

			plugins_url()  . '/cqpim/js/quote-frontend-ajax.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'project-frontend-ajax',

			plugins_url()  . '/cqpim/js/project-frontend-ajax.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'client-dashboard-custom',

			plugins_url()  . '/cqpim/js/client-dashboard-custom.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'support-tickets-frontend',

			plugins_url()  . '/cqpim/js/support-tickets-frontend.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'task-frontend-ajax',

			plugins_url()  . '/cqpim/js/task-frontend-ajax.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);

	}

	// REGISTER ALL ADMIN SCRIPTS

	add_action( 'admin_enqueue_scripts', 'cqpim_register_all_admin_scripts' );

	function cqpim_register_all_admin_scripts(){
	
		wp_register_script( 

			'tasks_admin_custom',

			plugins_url()  . '/cqpim/js/tasks-admin-custom.js',

			array( 'jquery', 'jquery-ui' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'tasks_admin_ajax',

			plugins_url()  . '/cqpim/js/tasks-admin-ajax.js',

			array( 'jquery', 'jquery-ui' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'templates_admin_ajax',

			plugins_url()  . '/cqpim/js/templates-admin-ajax.js',

			array( 'jquery', 'jquery-ui' ),

			NULL,

			TRUE

		);

		wp_register_script( 

			'plugin_options_pages_custom',

			plugins_url()  . '/cqpim/js/plugin-options-custom-js.js',

			array( 'jquery', 'jquery-ui' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'throughout_admin',

			plugins_url()  . '/cqpim/js/throughout-admin.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'plugin_dash_page_custom',

			plugins_url()  . '/cqpim/js/plugin-dash-custom-js.js',

			array( 'jquery', 'jquery-ui' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'permissions-custom',

			plugins_url()  . '/cqpim/js/permissions-custom.js',

			array( 'jquery', 'jquery-ui' ),

			NULL,

			TRUE

		);
		
		wp_register_style( 

			'cqpim-admin-styles', 

			plugins_url()  . '/cqpim/css/cqpim-admin-styles.css',

			array(), 

			'1.10.3', 

			'all' 

		);
		
		wp_register_script( 

			'quote-cpt-ajax',

			plugins_url()  . '/cqpim/js/quote-admin-ajax.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'quote-cpt-custom',

			plugins_url()  . '/cqpim/js/quote-admin-custom.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'forms-cpt-ajax',

			plugins_url()  . '/cqpim/js/forms-admin-ajax.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'client-cpt-custom',

			plugins_url()  . '/cqpim/js/client-admin-custom.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'project-cpt-ajax',

			plugins_url()  . '/cqpim/js/project-admin-ajax.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'project-cpt-custom',

			plugins_url()  . '/cqpim/js/project-admin-custom.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'invoice-cpt-custom',

			plugins_url()  . '/cqpim/js/invoice-admin-custom.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'invoice-cpt-ajax',

			plugins_url()  . '/cqpim/js/invoice-admin-ajax.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'jquery-repeater',

			plugins_url()  . '/cqpim/assets/jquery-repeater/jquery.repeater.min.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'form-builder-vendor',

			plugins_url()  . '/cqpim/assets/form-builder/vendor/js/vendor.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_style( 

			'form-builder-vendor-styles',

			plugins_url()  . '/cqpim/assets/form-builder/vendor/css/vendor.css',

			array(), 

			'1.10.3', 

			'all' 

		);
		
		wp_register_script( 

			'form-builder',

			plugins_url()  . '/cqpim/assets/form-builder/formbuilder.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_style( 

			'form-builder-styles', 

			plugins_url()  . '/cqpim/assets/form-builder/formbuilder.css',

			array(), 

			'1.10.3', 

			'all' 

		);
		
		wp_register_script( 

			'jquery-repeater-perms',

			plugins_url()  . '/cqpim/assets/jquery-repeater/jquery.repeater.perms.min.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'jquery-timer',

			plugins_url()  . '/cqpim/assets/jquery-timer/jquery.timer.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'support-tickets-custom',

			plugins_url()  . '/cqpim/js/support-tickets-custom.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'fullcal-moment',

			plugins_url()  . '/cqpim/assets/fullcalendar/lib/moment.min.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_script( 

			'fullcal',

			plugins_url()  . '/cqpim/assets/fullcalendar/fullcalendar.min.js',

			array( 'jquery' ),

			NULL,

			TRUE

		);
		
		wp_register_style( 

			'fullcal-styles', 

			plugins_url()  . '/cqpim/assets/fullcalendar/fullcalendar.min.css',

			array(), 

			'1.10.3', 

			'all' 

		);

	}

	// ENQUEUE NON-ADMIN SCRIPTS CONDITIONALLY

	add_action( 'wp_enqueue_scripts', 'cqpim_enqueue_scripts_where_required', 49 );

	function cqpim_enqueue_scripts_where_required() {
	
		if(is_singular('attachment')) {
		
			global $post;
			
			$attachment = get_post_meta($post->ID, 'cqpim', true);
			
			if($attachment == true) {
			
				wp_enqueue_style( 'raleway-font' );
				
				wp_enqueue_style( 'cqpim-frontend-styles' );
				
				wp_enqueue_script( 'task-frontend-ajax' );
			
				wp_localize_script( 'task-frontend-ajax', 'task_frontend', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
			
			}
		
		}

		if(is_singular('cqpim_quote')) {
		
			wp_enqueue_script( 'jquery' );
			
			wp_enqueue_script( 'jquery-ui' );
		
			$theme = get_option('client_dashboard_type');
			
			if($theme == 'inc') {
		
				global $wp_styles;
					
				foreach( $wp_styles->queue as $handle ) {
				
					wp_dequeue_style($handle);
					
				}
				
				global $wp_scripts;
					
				foreach( $wp_scripts->queue as $handle ) {
				
					wp_dequeue_script($handle);
					
				}
				
				wp_enqueue_style( 'raleway-font' );
			
			}
		
			wp_enqueue_style( 'cqpim-frontend-styles' );
			
			wp_enqueue_script( 'quote-frontend-ajax' );
			
			wp_localize_script( 'quote-frontend-ajax', 'quote_frontend', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
		
		}
		
		if(is_singular('cqpim_tasks')) {
		
			wp_enqueue_script( 'jquery' );
			
			wp_enqueue_script( 'jquery-ui' );
		
			$theme = get_option('client_dashboard_type');
			
			if($theme == 'inc') {
		
				global $wp_styles;
					
				foreach( $wp_styles->queue as $handle ) {
				
					wp_dequeue_style($handle);
					
				}
				
				global $wp_scripts;
					
				foreach( $wp_scripts->queue as $handle ) {
				
					wp_dequeue_script($handle);
					
				}
				
				wp_enqueue_style( 'raleway-font' );
			
			}
			
			wp_enqueue_script('masonry');
		
			wp_enqueue_style( 'cqpim-frontend-styles' );
			
			wp_enqueue_script( 'task-frontend-ajax' );
			
			wp_localize_script( 'task-frontend-ajax', 'task_frontend', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
			
			wp_enqueue_style( 'cqpim-upload-styles'  );

			wp_enqueue_script( 'cqpim-upload-knob');
			wp_enqueue_script( 'cqpim-upload-widget');
			wp_enqueue_script( 'cqpim-upload-transport');
			wp_enqueue_script( 'cqpim-upload-fileupload');
			wp_enqueue_script( 'cqpim-upload-main');
		
		}
		
		if(is_singular('cqpim_project')) {
		
			$theme = get_option('client_dashboard_type');
			
			if($theme == 'inc') {
		
				global $wp_styles;
					
				foreach( $wp_styles->queue as $handle ) {
				
					wp_dequeue_style($handle);
					
				}
				
				wp_enqueue_style( 'raleway-font' );
				
				global $wp_scripts;
					
				foreach( $wp_scripts->queue as $handle ) {
				
					wp_dequeue_script($handle);
					
				}
			
			}
			
			wp_enqueue_script( 'jquery' );
			
			wp_enqueue_script( 'jquery-ui' );
			
			wp_enqueue_script( 'gantt' );
			
			wp_enqueue_style( 'gantt-styles' );
		
			wp_enqueue_script( 'datatables' );
			
			wp_enqueue_style( 'datatables-styles' );
			
			wp_enqueue_script( 'colorbox' );
			
			wp_enqueue_style( 'colorbox-styles' );
		
			wp_enqueue_style( 'cqpim-frontend-styles' );
			
			wp_enqueue_script( 'project-frontend-ajax' );
			
			wp_localize_script( 'project-frontend-ajax', 'project_frontend', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
				
			wp_enqueue_script('masonry');
			
		}
		
		if(is_singular('cqpim_invoice') || is_singular('cqpim_support')) {
		
			$theme = get_option('client_dashboard_type');
			
			if($theme == 'inc') {
		
				global $wp_styles;
					
				foreach( $wp_styles->queue as $handle ) {
				
					wp_dequeue_style($handle);
					
				}
				
				global $wp_scripts;
					
				foreach( $wp_scripts->queue as $handle ) {
				
					wp_dequeue_script($handle);
					
				}
				
				wp_enqueue_style( 'raleway-font' );
			
			}
			
			wp_enqueue_script( 'jquery' );
			
			wp_enqueue_script( 'jquery-ui' );
		
			wp_enqueue_style( 'cqpim-frontend-styles' );
			
			wp_enqueue_script( 'support-tickets-custom' );
		
		}
		
		if(is_singular('cqpim_invoice')) {
		
			global $wp_scripts;
				
			foreach( $wp_scripts->queue as $handle ) {
			
				wp_dequeue_script($handle);
				
			}
			
			wp_enqueue_script( 'jquery' );
			
			wp_enqueue_script( 'jquery-ui' );
		
			wp_enqueue_script( 'datatables' );
			
			wp_enqueue_style( 'datatables-styles' );
		
			wp_enqueue_style( 'print-styles' );
			
			wp_enqueue_script('client-dashboard-custom');
			
			wp_enqueue_script('masonry');
		
		}
		
		if(is_singular('cqpim_support')) {
		
			wp_enqueue_script( 'jquery' );
			
			wp_enqueue_script( 'jquery-ui' );
		
			wp_enqueue_script( 'support-tickets-frontend' );
			
			wp_localize_script( 'support-tickets-frontend', 'support_frontend', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );
		
			wp_enqueue_script('masonry');
			
			wp_enqueue_style( 'cqpim-upload-styles'  );

			wp_enqueue_script( 'cqpim-upload-knob');
			wp_enqueue_script( 'cqpim-upload-widget');
			wp_enqueue_script( 'cqpim-upload-transport');
			wp_enqueue_script( 'cqpim-upload-fileupload');
			wp_enqueue_script( 'cqpim-upload-main');
			
		}
		
		$login_page = get_option('cqpim_login_page');
		
		$dash_page = get_option('cqpim_client_page');
		
		$reset_page = get_option('cqpim_reset_page');
		
		if(is_page($login_page) || is_page($dash_page) || is_page($reset_page)) {
		
			$theme = get_option('client_dashboard_type');
			
			if($theme == 'inc') {
		
				global $wp_styles;
					
				foreach( $wp_styles->queue as $handle ) {
				
					wp_dequeue_style($handle);
					
				}
				
				global $wp_scripts;
					
				foreach( $wp_scripts->queue as $handle ) {
				
					wp_dequeue_script($handle);
					
				}
				
				wp_enqueue_style( 'raleway-font' );
			
			}
			
			wp_enqueue_script( 'jquery' );
			
			wp_enqueue_script( 'jquery-ui' );
			
			wp_enqueue_style( 'cqpim-frontend-styles' );
			
			wp_enqueue_script('masonry');
		
			wp_enqueue_script('colorbox');
			
			wp_enqueue_style('colorbox-styles');
		
			wp_enqueue_script('client-dashboard-custom');
			
			wp_localize_script( 'client-dashboard-custom', 'client_frontend', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );

			wp_enqueue_script( 'datatables' );
			
			wp_enqueue_style( 'datatables-styles' );
			
			wp_enqueue_style( 'cqpim-upload-styles'  );

			wp_enqueue_script( 'cqpim-upload-knob');
			wp_enqueue_script( 'cqpim-upload-widget');
			wp_enqueue_script( 'cqpim-upload-transport');
			wp_enqueue_script( 'cqpim-upload-fileupload');
			wp_enqueue_script( 'cqpim-upload-main');			
		}

	}
	

	// ENQUEUE ADMIN SCRIPTS

	add_action( 'admin_enqueue_scripts', 'cqpim_enqueue_admin_js' );

	function cqpim_enqueue_admin_js() {
	
		global $wp_locale;
		
		$args = array(
			'closeText'         => __( 'Done', 'cqpim' ),
			'currentText'       => __( 'Today', 'cqpim' ),
			'monthNames'        => array_values( $wp_locale->month ),
			'monthNamesShort'   => array_values( $wp_locale->month_abbrev ),
			'monthStatus'       => __( 'Show a different month', 'cqpim' ),
			'dayNames'          => array_values( $wp_locale->weekday ),
			'dayNamesShort'     => array_values( $wp_locale->weekday_abbrev ),
			'dayNamesMin'       => array_values( $wp_locale->weekday_initial ),
			// set the date format to match the WP general date settings
			'dateFormat'        => date_format_php_to_js( get_option( 'cqpim_date_format' ) ),
			// get the start of week from WP general setting
			'firstDay'          => get_option( 'start_of_week' )
		);	

		global $post_type;

		$screen = get_current_screen();

		// ALL ADMIN PAGES
		
		wp_enqueue_script( 'throughout_admin' );
		
		wp_enqueue_script( 'jquery-ui' );
		
		wp_enqueue_style( 'cqpim-admin-styles' );
		
		wp_enqueue_style( 'jquery-ui-styles' );
		

		
		// SPECIFIC POST TYPES

		switch ( $post_type ) {
		
			case 'cqpim_tasks':
				
				wp_enqueue_script( 'tasks_admin_custom' );
				
				wp_enqueue_script( 'tasks_admin_ajax' );
				
				wp_enqueue_script( 'jquery-timer' );
				
				wp_localize_script( 'tasks_admin_custom', 'objectL10n', $args );
				
				wp_enqueue_script( 'cqpim-upload-knob');
				wp_enqueue_script( 'cqpim-upload-widget');
				wp_enqueue_script( 'cqpim-upload-transport');
				wp_enqueue_script( 'cqpim-upload-fileupload');
				wp_enqueue_script( 'cqpim-upload-main');
				
				wp_enqueue_style( 'cqpim-upload-styles'  );

				break;
		
			case 'cqpim_forms':  
			
				/*
				
				global $wp_scripts;
				
				echo '<pre style="padding-left:200px">';
				
				print_r($wp_scripts);
				
				echo '</pre>';
				
				*/
			
				wp_enqueue_script( 'form-builder-vendor' );
				
				wp_enqueue_style( 'form-builder-vendor-styles' );
				
				wp_enqueue_script( 'form-builder' );
				
				wp_enqueue_style( 'form-builder-styles' );
				
				wp_enqueue_script( 'colorbox' );
			
				wp_enqueue_style( 'colorbox-styles' );
				
				wp_enqueue_script( 'forms-cpt-ajax' );

				break;
		
			case 'cqpim_client':
				
				wp_enqueue_script( 'colorbox' );
			
				wp_enqueue_style( 'colorbox-styles' );
				
				wp_enqueue_script( 'client-cpt-custom' );
				
				wp_enqueue_script( 'password-strength-meter' );
				
				wp_enqueue_script( 'jquery-repeater' );
				
				wp_enqueue_script( 'datatables' );
			
				wp_enqueue_style( 'datatables-styles' );
				
				wp_localize_script( 'client-cpt-custom', 'objectL10n', $args );

				break;
				
			case 'cqpim_teams':
				
				wp_enqueue_script( 'colorbox' );
			
				wp_enqueue_style( 'colorbox-styles' );
				
				wp_enqueue_script( 'client-cpt-custom' );
				
				wp_enqueue_script( 'datatables' );
			
				wp_enqueue_style( 'datatables-styles' );
				
				wp_localize_script( 'client-cpt-custom', 'objectL10n', $args );

				break;

			case 'cqpim_quote':
				
				wp_enqueue_script( 'colorbox' );
			
				wp_enqueue_style( 'colorbox-styles' );

				wp_enqueue_script( 'quote-cpt-ajax' );
				
				wp_enqueue_script( 'quote-cpt-custom' );
				
				wp_enqueue_script( 'datatables' );
			
				wp_enqueue_style( 'datatables-styles' );
				
				wp_localize_script( 'quote-cpt-custom', 'objectL10n', $args );

				break;	
				
			case 'cqpim_templates':
				
				wp_enqueue_script( 'colorbox' );
			
				wp_enqueue_style( 'colorbox-styles' );

				wp_enqueue_script( 'templates_admin_ajax' );
				
				wp_localize_script( 'templates_admin_ajax', 'objectL10n', $args );

				break;	

			case 'cqpim_project':
				
				wp_enqueue_script( 'colorbox' );
			
				wp_enqueue_style( 'colorbox-styles' );

				wp_enqueue_script( 'project-cpt-ajax' );
				
				wp_enqueue_script( 'project-cpt-custom' );
				
				wp_enqueue_media();
				
				wp_enqueue_script( 'datatables' );
			
				wp_enqueue_style( 'datatables-styles' );
				
				wp_localize_script( 'project-cpt-custom', 'objectL10n', $args );

				break;	

			case 'cqpim_invoice':
			
				wp_enqueue_script( 'colorbox' );
			
				wp_enqueue_style( 'colorbox-styles' );

				wp_enqueue_script( 'invoice-cpt-custom' );
				
				wp_enqueue_script( 'invoice-cpt-ajax' );
				
				wp_enqueue_script( 'jquery-repeater' );
				
				wp_localize_script( 'invoice-cpt-custom', 'objectL10n', $args );

				break;

			case 'cqpim_support':

				wp_enqueue_script( 'support-tickets-custom' );
				
				wp_enqueue_script( 'cqpim-upload-knob');
				wp_enqueue_script( 'cqpim-upload-widget');
				wp_enqueue_script( 'cqpim-upload-transport');
				wp_enqueue_script( 'cqpim-upload-fileupload');
				wp_enqueue_script( 'cqpim-upload-main');
				
				wp_enqueue_style( 'cqpim-upload-styles'  );

				break;					

			default:

				break;

		}

	}
	
	function date_format_php_to_js( $sFormat ) {
		switch( $sFormat ) {
			//Predefined WP date formats
			case 'F j, Y':
				return( 'MM dd, yy' );
				break;
			case 'Y/m/d':
				return( 'yy/mm/dd' );
				break;
			case 'm/d/Y':
				return( 'mm/dd/yy' );
				break;
			case 'd/m/Y':
				return( 'dd/mm/yy' );
				break;
			case 'Y-m-d':
				return( 'yy-mm-dd' );
				break;
		}
	 
	}

	/**

	* FRAMEWORK AND THEME OPTION PAGES SCRIPTS

	*/

	function cqpim_enqueue_plugin_option_scripts() {

		add_action( 'admin_enqueue_scripts', 'cqpim_enqueue_plugin_option_scripts_now' );		

	}

	function cqpim_enqueue_plugin_option_scripts_now() {

			$scripts = array(
			
				'colorbox',

				'plugin_options_pages_custom'

			);

			cqpim_custom_enqueue_scripts( $scripts );
			
			$styles = array(
			
				'colorbox-styles'

			);

			cqpim_custom_enqueue_styles( $styles );

	}
	
	function enqueue_cqpim_dash_option_scripts() {

		add_action( 'admin_enqueue_scripts', 'enqueue_cqpim_dash_option_scripts_now' );		

	}

	function enqueue_cqpim_dash_option_scripts_now() {

			$scripts = array(
			
				'colorbox',

				'plugin_options_pages_custom',
				
				'plugin_dash_page_custom',
				
				'jquery-timer',
				
				'datatables',
				
				'masonry',
				
				'fullcal-moment',
				
				'fullcal'

			);

			cqpim_custom_enqueue_scripts( $scripts );
			
			$styles = array(
			
				'colorbox-styles',
				
				'datatables-styles',
				
				'fullcal-styles'

			);

			cqpim_custom_enqueue_styles( $styles );

	}
	
	function cqpim_enqueue_plugin_support_scripts() {

		add_action( 'admin_enqueue_scripts', 'cqpim_enqueue_plugin_support_scripts_now' );		

	}

	function cqpim_enqueue_plugin_support_scripts_now() {

		$scripts = array(

			'support-tickets-custom',
			
			'datatables'

		);

		cqpim_custom_enqueue_scripts( $scripts );
		
			$styles = array(
				
				'datatables-styles'

			);

			cqpim_custom_enqueue_styles( $styles );

	}
	
	function cqpim_enqueue_plugin_permissions_scripts() {

		add_action( 'admin_enqueue_scripts', 'cqpim_enqueue_plugin_permissions_scripts_now' );		

	}

	function cqpim_enqueue_plugin_permissions_scripts_now() {

		$scripts = array(

			'jquery-repeater-perms',
			
			'permissions-custom'

		);

		cqpim_custom_enqueue_scripts( $scripts );

	}

	/**

	 * HELPER FUNCTION

	 * To enqueue the above scripts

	 * @param 	array 	$scripts 

	 * @return 	null

	 * 

	 */

	function cqpim_custom_enqueue_scripts( $scripts ){

		if( ! is_array( $scripts ) ){ return; }

		foreach ( $scripts as $script ) {

				wp_enqueue_script( $script );

		}

	}
	
	function cqpim_custom_enqueue_styles( $styles ){

		if( ! is_array( $styles ) ){ return; }

		foreach ( $styles as $style ) {

				wp_enqueue_style( $style );

		}

	}