<?php

// Frontend Quote Form

function cqpim_frontend_quote_form() {

	$form = get_option('cqpim_frontend_form');
	
	$form_data = get_post_meta($form, 'builder_data', true);
	
	$form_data = json_decode($form_data);
	
	$fields = $form_data->fields;
	
	$code =  '<div id="cqpim_frontend_form_cont">';
	
	$code .= '<form id="cqpim_frontend_form">';
	
	$code .= '<div style="padding-bottom:12px" class="cqpim_form_item">';
	
	$code .= '<label style="display:block; padding-bottom:5px" for="full_name">' . __('Full Name', 'cqpim') . '<span style="color:#F00">*</span></label>';
	
	$code .= '<input style="width:100%" type="text" id="full_name" required />';
	
	$code .= '</div>';
	
	$code .= '<div style="padding-bottom:12px" class="cqpim_form_item">';
	
	$code .= '<label style="display:block; padding-bottom:5px" for="company_name">' . __('Company Name', 'cqpim') . '<span style="color:#F00">*</span></label>';
	
	$code .= '<input style="width:100%" type="text" id="company_name" required />';
	
	$code .= '</div>';
	
	$code .= '<div style="padding-bottom:12px" class="cqpim_form_item">';
	
	$code .= '<label style="display:block; padding-bottom:5px" for="address">' . __('Address', 'cqpim') . '<span style="color:#F00">*</span></label>';
	
	$code .= '<textarea style="width:100%; height:140px" id="address" required></textarea>';
	
	$code .= '</div>';
	
	$code .= '<div style="padding-bottom:12px" class="cqpim_form_item">';
	
	$code .= '<label style="display:block; padding-bottom:5px" for="postcode">' . __('Postcode', 'cqpim') . '<span style="color:#F00">*</span></label>';
	
	$code .= '<input style="width:100%" type="text" id="postcode" required />';
	
	$code .= '</div>';
	
	$code .= '<div style="padding-bottom:12px" class="cqpim_form_item">';
	
	$code .= '<label style="display:block; padding-bottom:5px" for="telephone">' . __('Telephone', 'cqpim') . '<span style="color:#F00">*</span></label>';
	
	$code .= '<input style="width:100%" type="text" id="telephone" required />';
	
	$code .= '</div>';
	
	$code .= '<div style="padding-bottom:12px" class="cqpim_form_item">';
	
	$code .= '<label style="display:block; padding-bottom:5px" for="email">' . __('Email Address', 'cqpim') . '<span style="color:#F00">*</span></label>';
	
	$code .= '<input style="width:100%" type="email" id="email" required />';
	
	$code .= '</div>';
	
	if(!empty($fields)) {
	
		foreach($fields as $field) {
		
			$id = strtolower($field->label);
			
			$field_options = $field->field_options;
			
			$id = str_replace(' ', '_', $id);
			
			$id = str_replace('-', '_', $id);
			
			$id = preg_replace('/[^\w-]/', '', $id);
			
			if($field->required == 1) {
			
				$required = 'required';
				
				$ast = '<span style="color:#F00">*</span>';
				
			} else {
			
				$required = '';
				
				$ast = '';
				
			}
			
			$code .= '<div style="padding-bottom:12px" class="cqpim_form_item">';
			
			$code .= '<label style="display:block; padding-bottom:5px" for="' . $id . '">' . $field->label . ' ' . $ast . '</label>';
		
			if($field->field_type == 'text') {
			
				$code .= '<input style="width:100%" type="text" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'website') {
			
				$code .= '<input style="width:100%" type="url" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'number') {
			
				$code .= '<input style="width:100%" type="number" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'paragraph') {
			
				$code .= '<textarea style="width:100%; height:140px" id="' . $id . '" ' . $required . '></textarea>';
			
			} elseif($field->field_type == 'date') {
			
				$code .= '<input style="width:100%" type="date" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'email') {
			
				$code .= '<input style="width:100%" type="email" id="' . $id . '" ' . $required . ' />';
			
			} elseif($field->field_type == 'checkboxes') {
			
				$options = $field->field_options;
				
				$options = $options->options;
				
				foreach($options as $option) {
				
					$value = strtolower($option->label);
					
					$value = str_replace(' ', '_', $value);
			
					$code .= '<input type="checkbox" value="' . $value . '" name="' . $id . '" /> ' . $option->label . '<br />';
					
				}
			
			} elseif($field->field_type == 'radio') {
			
				$options = $field->field_options;
				
				$options = $options->options;
				
				foreach($options as $option) {
				
					$value = strtolower($option->label);
					
					$value = str_replace(' ', '_', $value);
			
					$code .= '<input type="radio" value="' . $value . '" name="' . $id . '" ' . $required . ' /> ' . $option->label . '<br />';
					
				}
			
			} elseif($field->field_type == 'dropdown') {
			
				$options = $field->field_options;
				
				$options = $options->options;
				
				$code .= '<select id="' . $id . '" ' . $required . '>';
				
					foreach($options as $option) {
					
						$value = strtolower($option->label);
						
						$value = str_replace(' ', '_', $value);
				
						$code .= '<option value="' . $value . '">' . $option->label . '</option>';
						
					}
				
				$code .= '</select>';
			
			}
			
			if(!empty($field_options->description)) {
			
				$code .= '<p>' . $field_options->description . '</p>';
			
			}
			
			$code .= '</div>';
		
		}
		
	} else {
	
		$code .= '';
		
	}
	
	$code .= '<input type="submit" id="cqpim_submit_frontend" value="' . __('Submit Quote Request', 'cqpim') . '" /><br /><div id="form_spinner" style="clear:both; display:none; background:url(' . plugins_url() . '/cqpim/css/img/ajax-loader.gif) center center no-repeat; width:16px; height:16px; padding:10px 0 0 5px; margin-top:15px"></div>';

	$code .= '<div style="margin-top:20px" id="cqpim_submit_frontend_messages"></div>';
	
	$code .= '</form>';
	
	$code .= '</div>';
	
	return $code;

}

add_shortcode('cqpim_frontend_form', 'cqpim_frontend_quote_form');

add_action( 'wp_footer', 'cqpim_frontend_form_scripts' );

function cqpim_frontend_form_scripts() {

	$form = get_option('cqpim_frontend_form');
	
	$form_data = get_post_meta($form, 'builder_data', true);
	
	if(empty($form_data)) {
	
		$form_data = '';
		
	}
	
	$form_data = json_decode($form_data);
	
	$fields = isset($form_data->fields) ? $form_data->fields : array();
	
	if(empty($fields)) {
	
		$fields = array();
		
	}

	?>
	
	<script type="text/javascript">
	
		jQuery(document).ready(function() {
		
			jQuery('#cqpim_submit_frontend').before('<div style="padding-bottom:12px" class="cqpim_form_item"> <?php _e('I am a Human (SPAM check)', 'cqpim'); ?><span style="color:#F00">*</span> <input type="checkbox" id="human_conf" required /></div>');
		
			jQuery('#cqpim_frontend_form').on('submit', function(e) {
			
				e.preventDefault();
				
				var spinner = jQuery('#form_spinner');
				
				var name = jQuery('#full_name').val();
				
				var company = jQuery('#company_name').val();
				
				var address = jQuery('#address').val();
				
				var postcode = jQuery('#postcode').val();
				
				var telephone = jQuery('#telephone').val();
				
				var email = jQuery('#email').val();
				
				<?php
				
				foreach($fields as $field) {
				
					$id = strtolower($field->label);
					
					$id = str_replace(' ', '_', $id);
					
					$id = str_replace('-', '_', $id);
					
					$id = preg_replace('/[^\w-]/', '', $id);

					if($field->field_type == 'text' || 
					
						$field->field_type == 'number' || 
						
						$field->field_type == 'email' || 
						
						$field->field_type == 'paragraph' ||
						
						$field->field_type == 'website' || 
						
						$field->field_type == 'dropdown' || 
						
						$field->field_type == 'date' || 
						
						$field->field_type == 'number') {
					
						echo 'var ' . $id . ' = jQuery("#' . $id . '").val();';
						
						echo 'if(!' . $id . ') { ' . $id . ' = ""; };';
					
					} elseif($field->field_type == 'checkboxes') {

						echo 'var ' . $id . ' = jQuery("input[name=' . $id . ']:checked").map(function() { return jQuery(this).val(); }).get();';
						
						echo 'if(!' . $id . ') { ' . $id . ' = ""; };';

					} elseif($field->field_type == 'radio') {

						echo 'var ' . $id . ' = jQuery("input[name=' . $id . ']:checked").val();';
						
						echo 'if(!' . $id . ') { ' . $id . ' = ""; };';

					}
				
				}
				
				?>
				
				var data = {
				
					'action' : 'cqpim_frontend_quote_submission',
					
					'name' : name,
					
					'company' : company,
					
					'address' : address,
					
					'postcode' : postcode,
					
					'telephone' : telephone,
					
					'email' : email,
				
					<?php
					
					foreach($fields as $field) {
					
						$id = strtolower($field->label);
						
						$id = str_replace(' ', '_', $id);
						
						$id = str_replace('-', '_', $id);
						
						$id = preg_replace('/[^\w-]/', '', $id);

						echo "'" . $id . "' : " . $id . ",";
					
					}
					
					?>
				
				};
				
				jQuery.ajax({

					url: '<?php echo admin_url() . 'admin-ajax.php'; ?>',

					data: data,

					type: 'POST',

					dataType: 'json',

					beforeSend: function(){

						// show spinner

						spinner.show();

						// disable form elements while awaiting data

						jQuery('#cqpim_submit_frontend').prop('disabled', true);

					},

				}).always(function(response) {
				
					console.log(response);
				
				}).done(function(response){
				
					if(response.error == true) {
					
						spinner.hide();

						// re-enable form elements so that new enquiry can be posted

						jQuery('#cqpim_submit_frontend').prop('disabled', false);
					
						jQuery('#cqpim_submit_frontend_messages').html(response.message);
						
					} else {

						spinner.hide();

						// re-enable form elements so that new enquiry can be posted

						jQuery('#cqpim_submit_frontend').prop('disabled', false);
						
						jQuery('#cqpim_submit_frontend_messages').html(response.message);
					
					}

				});
			
			});
		
		});
	
	</script>	
	
	<?php

}