<?php
/**
 * 	TC+ Support Tickets
 *
 */
	
	// Add CQPIM Support Tickets page

	add_action( 'admin_menu' , 'register_cqpim_support_page', 10 ); 

	function register_cqpim_support_page() {

		$mypage = add_submenu_page(	
					'cqpim-dashboard',
					__('Support Tickets', 'cqpim'), 			
					__('Support Tickets', 'cqpim'),  			
					'cqpim_view_tickets', 			
					'support-tickets', 		
					'cqpim_support'
		);

		add_action( 'load-' . $mypage, 'cqpim_enqueue_plugin_support_scripts' );
		


	}


	function cqpim_support() { ?>
	
	<div class="tasks-box" style="padding-right:20px">
	
		<div class="cqpim-dash-item-inside cqpim_roles">
				
			<?php 
			
			$user = wp_get_current_user();
			
			$status = isset($_SESSION['ticket_status']) ? $_SESSION['ticket_status'] : array('open','hold');
			
			$args = array(
			
				'post_type' => 'cqpim_support',
				
				'posts_per_page' => -1,
				
				'post_status' => 'private',
				
				'meta_key' => 'ticket_status',
				
				'meta_value' => $status
			
			); 
			
			$tickets = get_posts($args);
			
			$total_tickets = count($tickets);
			
			$ordered = array();
			
			foreach($tickets as $ticket) {
			
				$ticket_updated = get_post_meta($ticket->ID, 'last_updated', true);
				
				if(!empty($ticket_updated)) {
				
					$ordered[$ticket_updated] = $ticket;
				
				}
			
			}
			
			krsort($ordered);

			if(!empty($tickets)) {
		
				echo '<table style="background:#fff" class="milestones files dataTable">';
				
				echo '<thead><tr><th>' . __('ID', 'cqpim') . '</th><th>' . __('Ticket Title', 'cqpim') . '</th><th>' . __('Assigned To', 'cqpim') . '</th><th>' . __('Client Name', 'cqpim') . '</th><th>' . __('Priority', 'cqpim') . '</th><th>' . __('Created', 'cqpim') . '</th><th>' . __('Last Updated', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr></thead>';
				
				echo '<tbody>';
			
				foreach($ordered as $ticket) {
				
					$ticket_author = $ticket->post_author;
					
					$author_details = get_user_by('id', $ticket_author);
					
					$ticket_owner = get_post_meta($ticket->ID, 'ticket_owner', true);
					
					$owner_details = get_post_meta($ticket_owner, 'team_details', true);
					
					$owner_name = isset($owner_details['team_name']) ? $owner_details['team_name'] : '';
					
					$ticket_client = get_post_meta($ticket->ID, 'ticket_client', true);
					
					$client_details = get_post_meta($ticket_client, 'client_details', true);
					
					$client_name = isset($client_details['client_company']) ? $client_details['client_company'] : '';
				
					$ticket_status = get_post_meta($ticket->ID, 'ticket_status', true);
					
					if($ticket_status == 'open') {
					
						$tstatus = '<span class="low_priority">' . __('Open', 'cqpim') . '</span>';
					
					} else if($ticket_status == 'resolved') {
					
						$tstatus = '<span class="task_complete">' . __('Resolved', 'cqpim') . '</span>';
					
					} else if($ticket_status == 'hold') {
					
						$tstatus = '<span class="high_priority">' . __('On Hold', 'cqpim') . '</span>';
					
					}
					
					$ticket_priority = get_post_meta($ticket->ID, 'ticket_priority', true);
					
					$ticket_updated = get_post_meta($ticket->ID, 'last_updated', true);
					
					if(is_numeric($ticket_updated)) { $ticket_updated = date(get_option('cqpim_date_format') . ' H:i', $ticket_updated); } else { $ticket_updated = $ticket_updated; }
					
					if($ticket_priority == 'low') {
					
						$priority = '<span class="low_priority">' . __('Low', 'cqpim') . '</span>';
					
					} else if($ticket_priority == 'normal') {
					
						$priority = '<span class="normal_priority">' . __('Normal', 'cqpim') . '</span>';
					
					} else if($ticket_priority == 'high') {
					
						$priority = '<span class="high_priority">' . __('High', 'cqpim') . '</span>';
					
					} else if($ticket_priority == 'immediate') {
					
						$priority = '<span class="immediate_priority">' . __('Immediate', 'cqpim') . '</span>';
					
					}
				
					echo '<tr>';
					
					echo '<td>' . $ticket->ID . '</td>';
				
					echo '<td><a href="' . get_edit_post_link($ticket->ID) . '">' . $ticket->post_title . '</a></td>';
					
					echo '<td>' . $owner_name . '</td>';
					
					echo '<td><a href="' . get_edit_post_link($ticket_client) . '">' . $client_name . '</a></td>';
					
					echo '<td>' . $priority . '</td>';
					
					echo '<td>' . get_the_date(get_option('cqpim_date_format') . ' H:i', $ticket->ID) . '</td>';
					
					echo '<td>' . $ticket_updated . '</td>';
					
					echo '<td>' . $tstatus . '</td>';
					
					echo '</tr>';
				
				}
				
				echo '</tbody>';
				
				echo '</table>';
			
			} else {
			
				if(is_array($status)) {
				
					echo '<table style="background:#fff" class="milestones files dataTable">';
					
					echo '<thead><tr><th>' . __('ID', 'cqpim') . '</th><th>' . __('Ticket Title', 'cqpim') . '</th><th>' . __('Client Name', 'cqpim') . '</th><th>' . __('Priority', 'cqpim') . '</th><th>' . __('Created', 'cqpim') . '</th><th>' . __('Last Updated', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr></thead>';
					
					echo '<tbody>';
					
					echo '</tbody>';
					
					echo '</table>';
					
				} else if($status == 'resolved') {
				
					echo '<table style="background:#fff" class="milestones files dataTable">';
					
					echo '<thead><tr><th>' . __('ID', 'cqpim') . '</th><th>' . __('Ticket Title', 'cqpim') . '</th><th>' . __('Client Name', 'cqpim') . '</th><th>' . __('Priority', 'cqpim') . '</th><th>' . __('Created', 'cqpim') . '</th><th>' . __('Last Updated', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr></thead>';
					
					echo '<tbody>';
					
					echo '</tbody>';
					
					echo '</table>';
					
				}
			
			}
			
			if($status == 'resolved') { ?>
			
			<button id="switch_to_resolved" class="metabox-add-button left"><?php _e('View Open Tickets', 'cqpim'); ?> <div id="support_loader_2" class="ajax_loader" style="display:none"></div></button>
		
			<?php } else { ?>
			
			<button id="switch_to_resolved" class="metabox-add-button left"><?php _e('View Resolved Tickets', 'cqpim'); ?> <div id="support_loader_2" class="ajax_loader" style="display:none"></div></button>
			
			<?php } ?>
			
			<div class="clear"></div>	

			</div>

		</div>

	<?php } 