<?php 

$user = wp_get_current_user();

if (!in_array('cqpim_client', $user->roles)) {

	$login_page = get_option('cqpim_login_page');
	
	$url = get_the_permalink($login_page);
	
	wp_redirect($url, 302);
	
	exit();

} else {

	include_once( realpath(dirname(__FILE__)) . '/upload.php' );

	$user = wp_get_current_user(); 	
	
	$login_page_id = get_option('cqpim_login_page');
	
	$login_url = get_the_permalink($login_page_id);
	
	$user_id = $user->ID;
	
	// Gravatar
	
	$email = $user->user_email;
	
	$size = 60;
	
	$grav_url = "https://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "&s=" . $size;
	
	$dash_type = get_option('client_dashboard_type');
	
	$theme = wp_get_theme();
	
	$quote_form = get_option('cqpim_backend_form');
	
	// Assignment
	
	$args = array(
	
		'post_type' => 'cqpim_client',
		
		'posts_per_page' => -1,
		
		'post_status' => 'private'
	
	);
	
	$members = get_posts($args);
	
	foreach($members as $member) {
	
		$team_details = get_post_meta($member->ID, 'client_details', true);
		
		if($team_details['user_id'] == $user->ID) {
		
			$assigned = $member->ID;
			
			$client_type = 'admin';
		
		}
	
	} 
	
	if(empty($assigned)) {
	
		foreach($members as $member) {
		
			$team_ids = get_post_meta($member->ID, 'client_ids', true);
			
			if(in_array($user->ID, $team_ids)) {
			
				$assigned = $member->ID;
				
				$client_type = 'contact';
			
			}
		
		} 			
	
	}
	
	$client_details = get_post_meta($assigned, 'client_details', true);
	
	$client_ids = get_post_meta($assigned, 'client_ids', true);
	
	$client_ids_untouched = $client_ids;
	
	if(empty($client_ids_untouched)) {
		
		$client_ids_untouched = array();
		
	}
	
	$login_url = get_option('cqpim_logout_url');
	
	if(empty($login_url)) {
	
		$login_url = get_the_permalink($login_page_id);
		
	}
	
}

get_header();
	
?>

	<div style="padding-left:0; margin:0 auto; max-width:1100px; padding:20px; background:#fff" class="cqpim-client-dash" role="main">	
	
		<div style="background:0; padding:0 0 30px 0" class="cqpim-dash-header">
		
			<img style="float:left; margin-right:10px" src="<?php echo $grav_url; ?>" />

			<h1><?php printf(__('Welcome back, %1$s', 'cqpim'), $user->display_name); ?><br /><span style="font-weight:700; font-size:12px; line-height:14px; padding:4px 8px" class="task_complete"><?php echo $email; ?></span> <span style="margin-left:10px;font-weight:700; font-size:12px; line-height:14px; padding:4px 8px" class="task_complete"><?php echo isset($client_details['client_company']) ? $client_details['client_company'] : ''; ?> <?php if($client_type == 'admin') { echo '&nbsp;&nbsp;(Main Contact)'; } ?></span></h1>
		
			<div class="clear"></div>
			
				<?php $client_dash = get_option('cqpim_client_page'); ?>
			
				<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash); ?>"><?php _e('Dashboard', 'cqpim'); ?></a>
		
				<?php if(!empty($quote_form) && get_option('enable_quotes') == 1) { ?>
				
					<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash) . '?page=quote_form'; ?>"><?php _e('Request a Quote', 'cqpim'); ?></a>
				
				<?php } 
			
				$client_settings = get_option('allow_client_settings');
				
				if($client_settings == 1) { ?>				
					
					<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash) . '?page=settings'; ?>"><?php _e('Settings', 'cqpim'); ?></a>

				<?php } 
				
				$client_settings = get_option('allow_client_users');
				
				if($client_settings == 1) { ?>	

					<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash) . '?page=contacts'; ?>"><?php _e('Users', 'cqpim'); ?></a>

				<?php } ?>
				
				<?php
				
				include_once(ABSPATH.'wp-admin/includes/plugin.php');
			
				if(is_plugin_active('cqpim-envato/cqpim-envato.php')) {				
				
				?>
				
				<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash) . '?page=add-envato-purchase'; ?>"><?php _e('My Envato Purchases', 'cqpim'); ?></a>
				
				<?php } ?>
				
				<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo wp_logout_url($login_url); ?>"><?php _e('Log Out', 'cqpim'); ?></a>
				
				<div class="clear"></div>

		</div>
		
		<div style="padding:0" class="cqpim-dash-content">
		
		<?php if(empty($_GET['page'])) { ?>
		
			<div style="width:100%; background:0" class="cqpim-dash-item">
			
				<h3><?php _e('Alerts', 'cqpim'); ?></h3>
				
				<div class="cqpim-dash-item-inside">
				
				<?php 
				
					$alerts = array();
				
					// Check Invoices
					
					if(get_option('disable_invoices') != 1) {
					
					$args = array(
					
						'post_type' => 'cqpim_invoice',
						
						'posts_per_page' => -1,
						
						'post_status' => 'publish',
					
					);
					
					$invoices = get_posts($args);
					
					$outstanding_invoices = 0;
					
					$overdue_invoices = 0;
					
					foreach($invoices as $invoice) {
					
						$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
						
						$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
						
						$client_details = get_post_meta($client_id, 'client_details', true);

						$client_ids = get_post_meta($client_id, 'client_ids', true);

							if(empty($client_ids)) {
							
								$client_ids = array();
								
							}						
			
						$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';

						$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
						
						$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';

						$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
						
						$now = time();
								
						$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';							

						if($client_user_id == $user->ID && empty($paid) && !empty($sent) || in_array($user->ID, $client_ids) && empty($paid) && !empty($sent)) {
						
							$outstanding_invoices++;
							
							if($due < $now) {
							
								$overdue_invoices++;
							
							}
						
						}							
					
					}
					
					if($overdue_invoices != 0) {
					
						$alerts[] = array(
						
							'type' => 'oinvoice',
							
							'data' => sprintf(_n('You have %s overdue invoice', 'You have %s overdue invoices', $overdue_invoices, 'cqpim'), $overdue_invoices),
							
						);
							
					}
					
					if($outstanding_invoices != 0) {
					
						$alerts[] = array(
						
							'type' => 'invoice',
							
							'data' => sprintf(_n('You have %s outstanding invoice', 'You have %s outstanding invoices', $outstanding_invoices, 'cqpim'), $outstanding_invoices),
							
						);
							
					}
					
					}
					
					if (get_option('enable_quotes') == 1) {
						
					// Check Quotes
					
					$args = array(
					
						'post_type' => 'cqpim_quote',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private',
					
					);
					
					$quotes = get_posts($args);
					
					$open_quotes = 0;
					
					foreach($quotes as $quote) {
					
						$quote_details = get_post_meta($quote->ID, 'quote_details', true); 
						
						$client_id = isset($quote_details['client_id']) ? $quote_details['client_id'] : '';
						
						$client_details = get_post_meta($client_id, 'client_details', true);

						$client_ids = get_post_meta($client_id, 'client_ids', true);							
						
						$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
						
						$sent = isset($quote_details['sent']) ? $quote_details['sent'] : ''; 
						
						$confirmed = isset($quote_details['confirmed']) ? $quote_details['confirmed'] : ''; 
						
						if(!is_array($client_ids)) {
						
							$client_ids = array();
							
						}
						
						if($client_user_id == $user->ID && empty($confirmed) && !empty($sent) || in_array($user->ID, $client_ids) && empty($confirmed) && !empty($sent) ) {
						
							$open_quotes++;
						
						}
					
					}
					
					if($open_quotes != 0) {
					
						$alerts[] = array(
						
							'type' => 'quote',
							
							'data' => sprintf(_n('You have %s new quote/estimate that requires your attention', 'You have %s new quotes/estimates that require your attention', $open_quotes, 'cqpim'), $open_quotes),
							
						);
						
					}
					
					}
					
					// Check Projects
					
					$args = array(
					
						'post_type' => 'cqpim_project',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private',
					
					);
					
					$projects = get_posts($args);
					
					$unsigned_contracts = 0;
					
					foreach($projects as $project) {
					
						$project_details = get_post_meta($project->ID, 'project_details', true); 
						
						$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';
						
						$client_details = get_post_meta($client_id, 'client_details', true);

						$client_ids = get_post_meta($client_id, 'client_ids', true);
						
						$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
						
						$sent = isset($project_details['sent']) ? $project_details['sent'] : ''; 
						
						$confirmed = isset($project_details['confirmed']) ? $project_details['confirmed'] : '';
						
						if(empty($client_ids)) {
						
							$client_ids = array();
							
						}

						if($client_user_id == $user->ID && empty($confirmed) && !empty($sent) || in_array($user->ID, $client_ids) && empty($confirmed) && !empty($sent)) {

							$unsigned_contracts++;
						
						}
					
					}
					
					if($unsigned_contracts != 0) {
					
						$alerts[] = array(
						
							'type' => 'contract',
							
							'data' => sprintf(_n('You have %s contract that requires your attention', 'You have %s contracts that require your attention', $unsigned_contracts, 'cqpim'), $unsigned_contracts),
							
						);
						
					}
					
					// Check Tickets
					
					$user = wp_get_current_user();
					
					$args = array(
					
						'post_type' => 'cqpim_support',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private',
						
						'author__in' => $client_ids_untouched
					
					); 
					
					$tickets = get_posts($args);
					
					$unread_tickets = 0;

					foreach($tickets as $ticket) {
					
						$ticket_updated = get_post_meta($ticket->ID, 'unread', true);
						
						$ticket_status = get_post_meta($ticket->ID, 'ticket_status', true);
						
						if($ticket_updated == 1 && $ticket_status != 'resolved') {
						
							$unread_tickets++;
							
						}
					
					}
					
					if($unread_tickets != 0) {
					
						$alerts[] = array(
						
							'type' => 'support',
							
							'data' => sprintf(_n('You have %s open support ticket that requires your attention', 'You have %s open support tickets that require your attention', $unread_tickets, 'cqpim'), $unread_tickets),
							
						);
						
					}
					
					// Show the Alerts
					
					if(!empty($alerts)) {
					
						echo '<ul class="cqpim_alerts">';
					
						foreach($alerts as $alert) {
						
							echo '<li class="' . $alert['type'] . '">' . $alert['data'] . '</li>';
						
						}
						
						echo '</ul>';
					
					} else {
					
						echo '<p>' . __('You have no active alerts.', 'cqpim') . '</p>';
					
					}
							
					
				?>
				
			</div>
			
			</div>
		
		<?php } ?>
		
			<?php

				if(empty($_GET['page'])) { ?>
				
					<?php if(get_option('enable_quotes') == 1) { ?>
				
					<div style="width:100%; background:0" class="cqpim-dash-item">
					
						<h3><?php _e('Quotes/Estimates', 'cqpim'); ?></h3>
						
						<div class="cqpim-dash-item-inside">

							<table class="milestones dataTable-CQ">

								<thead>
								
									<tr>
									
										<th><?php _e('Owner', 'cqpim'); ?></th>
									
										<th><?php _e('Title', 'cqpim'); ?></th>
										
										<th><?php _e('Created', 'cqpim'); ?></th>
										
										<th><?php _e('Status', 'cqpim'); ?></th>
									
									</tr>
									
								</thead>

								<tbody>
					
									<?php 
									
									$args = array(
									
										'post_type' => 'cqpim_quote',
										
										'posts_per_page' => -1,
										
										'post_status' => 'private',
									
									);
									
									$quotes = get_posts($args);
									
									$i = 0;
									
									foreach($quotes as $quote) { 
									
										$url = get_the_permalink($quote->ID); 
										
										$quote_details = get_post_meta($quote->ID, 'quote_details', true); 
										
										$client_contact = $quote_details['client_contact'];
										
										$client_id = isset($quote_details['client_id']) ? $quote_details['client_id'] : '';
										
										$client_details = get_post_meta($client_id, 'client_details', true);
										
										$client_contacts = get_post_meta($client_id, 'client_contacts', true);

										$client_ids = get_post_meta($client_id, 'client_ids', true);
										
										$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
										
										if($client_contact == $client_user_id) {
										
											$fao = $client_details['client_contact'];
										
										} else {
										
											$fao = isset($client_contacts[$client_contact]['name']) ? $client_contacts[$client_contact]['name'] : 'N/A';
										
										}
										
										if(empty($client_ids)) {
										
											$client_ids = array();
											
										}
										
										$sent = isset($quote_details['sent']) ? $quote_details['sent'] : ''; 
										
										$confirmed = isset($quote_details['confirmed']) ? $quote_details['confirmed'] : ''; 
										
										if(!$confirmed) {
										
											if(!$sent) {
											
												$status = '<span class="task_over">' . __('Not Sent', 'cqpim') . '</span>';
											
											} else {
											
												$status = '<span class="task_pending">' . __('New', 'cqpim') . '</span>';
											
											}
										
										} else {
										
											$status = '<span class="task_complete">' . __('Accepted', 'cqpim') . '</span>';
											
										}
										
										if($client_user_id == $user->ID && !empty($sent) || in_array($user->ID, $client_ids) && !empty($sent)) {
										
										?>						

											<tr>	
											
												<td><span class="nodesktop"><strong><?php _e('Owner', 'cqpim'); ?></strong>: </span> <?php echo $fao; ?></td>
											
												<td><span class="nodesktop"><strong><?php _e('Title', 'cqpim'); ?></strong>: </span> <a class="cqpim-link" href="<?php echo $url; ?>?page=quote"><?php echo $quote->post_title; ?></a></td>
												
												<td><span class="nodesktop"><strong><?php _e('Created', 'cqpim'); ?></strong>: </span> <?php echo get_the_date(get_option('cqpim_date_format') . ' H:i', $quote->ID); ?></td>
												
												<td><span class="nodesktop"><strong><?php _e('Status', 'cqpim'); ?></strong>: </span> <?php echo $status; ?></td>
											
											</tr>
										
										<?php 
										
											$i++;
										
										}
									
									} 
									
									if($i == 0) {
									
										echo '<tr><td>' . __('You do not have any current or past quotes', 'cqpim') . '</td><td></td><td></td><td></td></tr>';
									
									}
																
									?>
														
								</tbody>
							
							</table>	
				
						</div>
						
					</div>	

					<?php } ?>

				<?php } if(empty($_GET['page']) ) { ?>
				
					<div style="width:100%; background:0" class="cqpim-dash-item">
					
						<h3><?php _e('Projects', 'cqpim'); ?></h3>
						
						<div class="cqpim-dash-item-inside">
						

					<table class="milestones dataTable-CP">

						<thead>
						
							<tr>
							
								<th><?php _e('Owner', 'cqpim'); ?></th>
							
								<th><?php _e('Title', 'cqpim'); ?></th>
															
								<?php $checked = get_option('enable_project_contracts'); 
								
								if(!empty($checked)) { ?>
								
									<th><?php _e('View', 'cqpim'); ?></th>
									
								<?php } ?>
								
								<th><?php _e('Progress', 'cqpim'); ?></th>
								
								<th><?php _e('Open Tasks', 'cqpim'); ?></th>
								
								<th><?php _e('Days Until Launch', 'cqpim'); ?></th>
								
								<th><?php _e('Status', 'cqpim'); ?></th>
							
							</tr>
							
						</thead>

						<tbody>
			
							<?php 
							
							$args = array(
							
								'post_type' => 'cqpim_project',
								
								'posts_per_page' => -1,
								
								'post_status' => 'private',
							
							);
							
							$projects = get_posts($args);
							
							$i = 0;
							
							foreach($projects as $project) { 
							
								$url = get_the_permalink($project->ID); 
								
								$contract = $url . '?page=contract';
								
								$summary = $url . '?page=summary&sub=updates';
								
								$project_details = get_post_meta($project->ID, 'project_details', true); 
								
								$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';
								
								$client_contact = isset($project_details['client_contact']) ? $project_details['client_contact'] : '';
								
								$owner = get_user_by('id', $client_contact);
								
								$client_details = get_post_meta($client_id, 'client_details', true);

								$client_ids = get_post_meta($client_id, 'client_ids', true);
								
								if(empty($client_ids)) {
								
									$client_ids = array();
									
								}
								
								$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
								
								$sent = isset($project_details['sent']) ? $project_details['sent'] : ''; 
								
								$confirmed = isset($project_details['confirmed']) ? $project_details['confirmed'] : ''; 
								
								$signoff = isset($project_details['signoff']) ? $project_details['signoff'] : ''; 
								
								$closed = isset($project_details['closed']) ? $project_details['closed'] : ''; 
								
								$finish_date = isset($project_details['finish_date']) ? $project_details['finish_date'] : '';
								
								if(!is_numeric($finish_date)) {
														
									$str_finish_date = str_replace('/','-', $finish_date);
								
									$unix_finish_date = strtotime($str_finish_date);
								
								} else {
								
									$unix_finish_date = $finish_date;
									
								}
								
								$current_date = time();
								
								$days_to_due = round(abs($current_date - $unix_finish_date) / 86400);
								
								$project_elements = get_post_meta($project->ID, 'project_elements', true); 
								
								if(empty($project_elements)) {
								
									$project_elements = array();
									
								}
								
								$task_count = 0;
								
								$task_total_count = 0;
								
								$task_complete_count = 0;
								
								foreach ($project_elements as $element) {
								
									$args = array(
									
										'post_type' => 'cqpim_tasks',
										
										'posts_per_page' => -1,
										
										'meta_key' => 'milestone_id',
										
										'meta_value' => $element['id'],
										
										'orderby' => 'date',
										
										'order' => 'ASC'
										
									);
									
									$tasks = get_posts($args);	
									
									foreach($tasks as $task) {
									
										$task_total_count++;
									
										$task_details = get_post_meta($task->ID, 'task_details', true);
										
										if($task_details['status'] != 'complete') {
										
											$task_count++;
										
										}
										
										if($task_details['status'] == 'complete') {
										
											$task_complete_count++;
										
										}
									
									}
								
								}
								
								if($task_total_count != 0) {
								
									$pc_per_task = 100 / $task_total_count;
								
									$pc_complete = $pc_per_task * $task_complete_count;
								
								} else {
								
									$pc_complete = 0;
								
								}
								
								if(!$closed) {
								
									if(!$signoff) {
									
										if(!$confirmed) {
										
											if(!$sent) {
											
												$status = '<span class="task_over">' . __('New', 'cqpim') . '</span>';
											
											} else {
											
												$checked = get_option('enable_project_contracts'); 
										
												if(!empty($checked)) {
											
													$status = '<span class="task_pending">' . __('Awaiting Contracts', 'cqpim') . '</span>';
													
												} else {
												
													$status = '<span class="task_complete">' . __('In Progress', 'cqpim') . '</span>';
												
												}
											
											}
										
										} else {
										
											$status = '<span class="task_complete">' . __('In Progress', 'cqpim') . '</span>';
											
										}
										
									} else {
									
										$status = '<span class="task_complete">' . __('Signed Off', 'cqpim') . '</span>';
									
									}
								
								} else {
								
									$status = '<span style="background:#333" class="task_complete">' . __('Closed', 'cqpim') . '</span>';
								
								}
								
								if($client_user_id == $user->ID || in_array($user->ID, $client_ids)) {
								
								?>						

									<tr>

										<td><span class="nodesktop"><strong><?php _e('Owner', 'cqpim'); ?></strong>: </span> <?php echo isset($owner->display_name) ? $owner->display_name : ''; ?></td>									
									
										<td><span class="nodesktop"><strong><?php _e('Title', 'cqpim'); ?></strong>: </span> <a class="cqpim-link" href="<?php echo $summary; ?>"><?php echo $project->post_title; ?></a></td>
										
										<?php $checked = get_option('enable_project_contracts'); 
										
										if(!empty($checked)) { ?>									
												
											<td><span class="nodesktop"><strong><?php _e('View', 'cqpim'); ?></strong>: </span> <a class="cqpim-link" href="<?php echo $contract; ?>"><?php _e('Contract', 'cqpim'); ?></a></td>
												
										<?php } ?>

										<td><span class="nodesktop"><strong><?php _e('Progress', 'cqpim'); ?></strong>: </span> <?php echo number_format((float)$pc_complete, 2, '.', ''); ?>%</td>
										
										<td><span class="nodesktop"><strong><?php _e('Open Tasks', 'cqpim'); ?></strong>: </span> <?php echo $task_count; ?></td>
										
										<td><span class="nodesktop"><strong><?php _e('Days to Launch', 'cqpim'); ?></strong>: </span> <?php echo $days_to_due; ?></td>
										
										<td><span class="nodesktop"><strong><?php _e('Status', 'cqpim'); ?></strong>: </span> <?php echo $status; ?></td>
									
									</tr>
								
								<?php 
								
									$i++;
								
								}
							
							} 
							
							if($i == 0) {
							
								echo '<tr><td>' . __('You do not have any current or past Projects', 'cqpim') . '</td><td></td><td></td><td></td><td></td><td></td><td></td></tr>';
							
							}
														
							?>
												
						</tbody>
					
					</table>
				
						</div>
						
					</div>

				<?php } if(empty($_GET['page'])) { ?>
				
					<div style="width:100%; background:0" class="cqpim-dash-item">
					
						<h3><?php _e('Support Tickets', 'cqpim'); ?></h3>
						
						<div class="cqpim-dash-item-inside">

				<div id="ticket_container" class="content">
			
				<?php 
				
				$user = wp_get_current_user();
				
				$status = isset($_SESSION['ticket_status']) ? $_SESSION['ticket_status'] : array('open','hold');
				
				$args = array(
				
					'post_type' => 'cqpim_support',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private',
					
					'author__in' => $client_ids_untouched,
					
					'meta_key' => 'ticket_status',
					
					'meta_value' => $status
				
				); 
				
				$tickets = get_posts($args);
				
				$total_tickets = count($tickets);
				
				if($tickets) {
				
					echo '<table class="milestones files dataTable-CST">';
					
					echo '<thead><tr><th>' . __('ID', 'cqpim') . '</th><th>' . __('Ticket Title', 'cqpim') . '</th><th>' . __('Priority', 'cqpim') . '</th><th>' . __('Created', 'cqpim') . '</th><th>' . __('Last Updated', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr></thead>';
					
					echo '<tbody>';
				
					foreach($tickets as $ticket) {
					
						$ticket_status = get_post_meta($ticket->ID, 'ticket_status', true);
						
						if($ticket_status == 'open') {
						
							$tstatus = '<span class="low_priority">' . __('Open', 'cqpim') . '</span>';
						
						} else if($ticket_status == 'resolved') {
						
							$tstatus = '<span class="task_complete">' . __('Resolved', 'cqpim') . '</span>';
						
						} else if($ticket_status == 'hold') {
						
							$tstatus = '<span class="high_priority">' . __('On Hold', 'cqpim') . '</span>';
						
						}
						
						$ticket_priority = get_post_meta($ticket->ID, 'ticket_priority', true);
						
						$ticket_updated = get_post_meta($ticket->ID, 'last_updated', true);
						
						if(is_numeric($ticket_updated)) { $ticket_updated = date(get_option('cqpim_date_format') . ' H:i', $ticket_updated); } else { $ticket_updated = $ticket_updated; }
						
						if($ticket_priority == 'low') {
						
							$priority = '<span class="low_priority">' . __('Low', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'normal') {
						
							$priority = '<span class="normal_priority">' . __('Normal', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'high') {
						
							$priority = '<span class="high_priority">' . __('High', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'immediate') {
						
							$priority = '<span class="immediate_priority">' . __('Immediate', 'cqpim') . '</span>';
						
						}
					
						echo '<tr>';
						
						echo '<td><span class="nodesktop"><strong>' . __('Ticket ID', 'cqpim') . '</strong>: </span> ' . $ticket->ID . '</td>';
					
						echo '<td><span class="nodesktop"><strong>' . __('Title', 'cqpim') . '</strong>: </span> <a class="cqpim-link" href="' . get_the_permalink($ticket->ID) . '">' . $ticket->post_title . '</a></td>';
						
						echo '<td><span class="nodesktop"><strong>' . __('Priority', 'cqpim') . '</strong>: </span> ' . $priority . '</td>';
						
						echo '<td><span class="nodesktop"><strong>' . __('Created', 'cqpim') . '</strong>: </span> ' . get_the_date(get_option('cqpim_date_format') . ' H:i', $ticket->ID) . '</td>';
						
						echo '<td><span class="nodesktop"><strong>' . __('Updated', 'cqpim') . '</strong>: </span> ' . $ticket_updated . '</td>';
						
						echo '<td><span class="nodesktop"><strong>' . __('Status', 'cqpim') . '</strong>: </span> ' . $tstatus . '</td>';
						
						echo '</tr>';
					
					}
					
					echo '</tbody>';
					
					echo '</table>';
				
				} else {
				
					if(is_array($status)) {
				
						echo '<p style="padding:20px">' . __('No open support tickets found...', 'cqpim') . '</p>';
						
					} else if($status == 'resolved') {
					
						echo '<p style="padding:20px">' . __('No resolved support tickets found...', 'cqpim') . '</p>';
						
					}
				
				}
				
				if($status == 'resolved') { ?>
				
				<button id="switch_to_resolved" class="metabox-add-button left"><?php _e('View Open Tickets', 'cqpim'); ?> <div id="support_loader_2" class="ajax_loader" style="display:none"></div></button>
			
				<?php } else { ?>
				
				<button id="switch_to_resolved" class="metabox-add-button left"><?php _e('View Resolved Tickets', 'cqpim'); ?> <div id="support_loader_2" class="ajax_loader" style="display:none"></div></button>
				
				<?php } ?>
				
				<a href="<?php echo get_the_permalink($client_dash) . '?page=add-support-ticket'; ?>" class="metabox-add-button"><?php _e('Add Support Ticket', 'cqpim'); ?></a>
				
				<div class="clear"></div>
			
			</div>
				
						</div>
						
					</div>

				<?php } if(empty($_GET['page'])) { if(get_option('disable_invoices') != 1) { ?>
				
					<div style="width:100%; background:0" class="cqpim-dash-item">
					
						<h3><?php _e('Invoices', 'cqpim'); ?></h3>
						
						<div class="cqpim-dash-item-inside">
						

				<?php
				
			$args = array(
			
				'post_type' => 'cqpim_invoice',
				
				'posts_per_page' => -1,
				
				'post_status' => 'publish',
				
				'orderby' => 'date',
				
				'order' => 'DESC'
			
			);
			
			$invoices = get_posts($args);
			
			if($invoices) {
			
				$currency = get_option('currency_symbol');
			
				echo '<table class="milestones dataTable-CI">';
				
				echo '<thead>';
				
				echo '<tr><th>' . __('Invoice ID', 'cqpim') . '</th><th>' . __('Owner', 'cqpim') . '</th><th>' . __('Invoice Date', 'cqpim') . '</th><th>' . __('Due Date', 'cqpim') . '</th><th>' . __('Amount', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr>';
				
				echo '</thead>';
				
				echo '<tbody>';
				
				$i = 0;
				
				foreach($invoices as $invoice) {
				
					$invoice_id = get_post_meta($invoice->ID, 'invoice_id', true);
					
					$client_contact = get_post_meta($invoice->ID, 'client_contact', true);
					
					$owner = get_user_by('id', $client_contact);
				
					$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
					
					$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
					
					$client_details = get_post_meta($client_id, 'client_details', true);
					
					$client_ids = get_post_meta($client_id, 'client_ids', true);
		
					$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
					
					$invoice_totals = get_post_meta($invoice->ID, 'invoice_totals', true);
					
					$tax_rate = get_option('sales_tax_rate');
					
					if(!empty($tax_rate)) {
					
						$total = isset($invoice_totals['total']) ? $invoice_totals['total'] : '';
						
					} else {
					
						$total = isset($invoice_totals['sub']) ? $invoice_totals['sub'] : '';
						
					}					
					
					$invoice_date = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
					
					if(is_numeric($invoice_date)) { $invoice_date = date(get_option('cqpim_date_format'), $invoice_date); } else { $invoice_date = $invoice_date; }
									
					$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
						
					$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
						
					$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
					
					$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';
					
					$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
					
					if(empty($on_receipt)) {
					
						$due_readable = date(get_option('cqpim_date_format'), $due);
						
					} else {
					
						$due_readable = __('Due on Receipt', 'cqpim');
						
					}
						
					$current_date = time();
						
					$link = get_the_permalink($invoice->ID);
					
					$password = md5($invoice->post_password);
					
					$url = $link;
						
					if(!$paid) {
						
						if($current_date > $due) {
						
							if(empty($on_receipt)) {
							
								$status = '<span class="task_over"><strong>' . __('OVERDUE', 'cqpim') . '</strong></span>';
								
							} else {
							
								$status = '<span class="task_over"><strong>' . __('Due on Receipt', 'cqpim') . '</strong></span>';
							
							}
								
						} else {
							
							if(!$sent) {
									
								$status = '<span class="task_over">' . __('New', 'cqpim') . '</span>';
									
							} else {
								
								$status = '<span class="task_pending">' . __('Outstanding', 'cqpim') . '</span>';
									
							}
								
						}
							
					} else {
							
						$status = '<span class="task_complete">' . __('PAID', 'cqpim') . '</span>';
							
					}		

					if($client_user_id == $user->ID && !empty($sent) || in_array($user->ID, $client_ids)) {
					
						echo '<tr>';
						
						echo '<td><span class="nodesktop"><strong>' . __('ID', 'cqpim') . '</strong>: </span> <a class="cqpim-link" href="' . $url . '" >' . $invoice_id . '</a></td>';

						echo '<td><span class="nodesktop"><strong>' . __('Owner', 'cqpim') . '</strong>: </span> ' . $owner->display_name . '</td>';

						echo '<td><span class="nodesktop"><strong>' . __('Date', 'cqpim') . '</strong>: </span> ' . $invoice_date . '</td>';

						echo '<td><span class="nodesktop"><strong>' . __('Due', 'cqpim') . '</strong>: </span> ' . $due_readable . '</td>';

						echo '<td><span class="nodesktop"><strong>' . __('Amount', 'cqpim') . '</strong>: </span> ' . $currency . '' . $total . '</td>';
							
						echo '<td><span class="nodesktop"><strong>' . __('Status', 'cqpim') . '</strong>: </span> ' . $status . '</td>';
						
						echo '</tr>';
							
						$i++;

					}
				
				}
				
				echo '</tbody>';
				
				echo '</table>';
			
			}
			
			if($i == 0) {
			
				echo '<p style="padding:30px">' . __('You do not have any invoices to show.', 'cqpim') . '</p>';
			
			}
			
			?>
			
					</div>
					
				</div>
			
			<?php } } if(!empty($quote_form) && isset( $_GET['page'] ) && $_GET['page'] == 'quote_form' ) { ?>
			
				<div style="width:100%; background:0" class="cqpim-dash-item">
				
					<h3><?php _e('Request a Quote', 'cqpim'); ?></h3>
					
					<div class="cqpim-dash-item-inside">
					
			<?php
			
			$form = get_option('cqpim_backend_form');
			
			$form_data = get_post_meta($form, 'builder_data', true);
			
			$form_data = json_decode($form_data);
			
			$fields = $form_data->fields;
			
			echo '<form id="cqpim_backend_form">';
			
			if(!empty($fields)) {
			
				echo '<div id="cqpim_backend_quote">';
			
				foreach($fields as $field) {
				
					$id = strtolower($field->label);
					
					$id = str_replace(' ', '_', $id);
					
					$id = str_replace('-', '_', $id);
					
					$id = str_replace(':', '', $id);
					
					$id = str_replace('(', '', $id);
					
					$id = str_replace(')', '', $id);
					
					if($field->required == 1) {
					
						$required = 'required';
						
						$ast = '<span style="color:#F00">*</span>';
						
					} else {
					
						$required = '';
						
						$ast = '';
						
					}
					
					echo '<div style="padding-bottom:12px" class="cqpim_form_item">';
					
					echo '<label style="display:block; padding-bottom:5px" for="' . $id . '">' . $field->label . ' ' . $ast . '</label>';
				
					if($field->field_type == 'text') {
					
						echo '<input style="width:100%" type="text" id="' . $id . '" ' . $required . ' />';
					
					} elseif($field->field_type == 'website') {
					
						echo '<input style="width:100%" type="url" id="' . $id . '" ' . $required . ' />';
					
					} elseif($field->field_type == 'number') {
					
						echo '<input style="width:100%" type="number" id="' . $id . '" ' . $required . ' />';
					
					} elseif($field->field_type == 'paragraph') {
					
						echo '<textarea style="width:100%; height:140px" id="' . $id . '" ' . $required . '></textarea>';
					
					} elseif($field->field_type == 'date') {
					
						echo '<input style="width:100%" type="date" id="' . $id . '" ' . $required . ' />';
					
					} elseif($field->field_type == 'email') {
					
						echo '<input style="width:100%" type="email" id="' . $id . '" ' . $required . ' />';
					
					} elseif($field->field_type == 'checkboxes') {
					
						$options = $field->field_options;
						
						$options = $options->options;
						
						foreach($options as $option) {
						
							$value = strtolower($option->label);
							
							$value = str_replace(' ', '_', $value);
					
							echo '<input type="checkbox" value="' . $value . '" name="' . $id . '" /> ' . $option->label . '<br />';
							
						}
					
					} elseif($field->field_type == 'radio') {
					
						$options = $field->field_options;
						
						$options = $options->options;
						
						foreach($options as $option) {
						
							$value = strtolower($option->label);
							
							$value = str_replace(' ', '_', $value);
					
							echo '<input type="radio" value="' . $value . '" name="' . $id . '" ' . $required . ' /> ' . $option->label . '<br />';
							
						}
					
					} elseif($field->field_type == 'dropdown') {
					
						$options = $field->field_options;
						
						$options = $options->options;
						
						echo '<select id="' . $id . '" ' . $required . '>';
						
							foreach($options as $option) {
							
								$value = strtolower($option->label);
								
								$value = str_replace(' ', '_', $value);
						
								echo '<option value="' . $value . '">' . $option->label . '</option>';
								
							}
						
						echo '</select>';
					
					}
					
					echo '</div>';
				
				}
				
				echo '<br />';
				
				echo '<input type="submit" id="cqpim_submit_backend" value="' . __('Submit Quote Request', 'cqpim') . '" /><br /><div id="form_spinner" style="clear:both; display:none; background:url(' . plugins_url() . '/cqpim/css/img/ajax-loader.gif) center center no-repeat; width:16px; height:16px; padding:10px 0 0 5px; margin-top:15px"></div>';

				echo '<div style="margin-top:20px" id="cqpim_submit_backend_messages"></div>';
				
				echo '</div>';
				
			} else {
			
				echo '<p>' . __('You have not added any fields to the selected form', 'cqpim') . '</p>';
				
			}
			
			echo '</form>';
			
			?>
			
					</div>
					
				</div>			
			
			<?php } ?>
			
			<?php if(!empty($quote_form)) {
				
				echo '<input type="hidden" id="client" value="' . $assigned . '" />';
				
				?>
			
				<script type="text/javascript">
				
					jQuery(document).ready(function() {
									
						jQuery('#cqpim_backend_form').on('submit', function(e) {
						
							e.preventDefault();
							
							var spinner = jQuery('#form_spinner');
							
							var client = jQuery('#client').val();
							
							<?php
							
							if(empty($fields)) {
							
								$fields = array();
								
							}
							
							foreach($fields as $field) {
							
								$id = strtolower($field->label);
								
								$id = str_replace(' ', '_', $id);
								
								$id = str_replace('-', '_', $id);
								
								$id = str_replace(':', '', $id);
								
								$id = str_replace('(', '', $id);
								
								$id = str_replace(')', '', $id);	

								if($field->field_type == 'text' || 
								
									$field->field_type == 'number' || 
									
									$field->field_type == 'email' || 
									
									$field->field_type == 'paragraph' ||
									
									$field->field_type == 'website' || 
									
									$field->field_type == 'dropdown' || 
									
									$field->field_type == 'date' || 
									
									$field->field_type == 'number') {
								
									echo 'var ' . $id . ' = jQuery("#' . $id . '").val();';
									
									echo 'if(!' . $id . ') { ' . $id . ' = ""; };';
								
								} elseif($field->field_type == 'checkboxes') {

									echo 'var ' . $id . ' = jQuery("input[name=' . $id . ']:checked").map(function() { return jQuery(this).val(); }).get();';
									
									echo 'if(!' . $id . ') { ' . $id . ' = ""; };';

								} elseif($field->field_type == 'radio') {

									echo 'var ' . $id . ' = jQuery("input[name=' . $id . ']:checked").val();';
									
									echo 'if(!' . $id . ') { ' . $id . ' = ""; };';

								}
							
							}
							
							?>
							
							var data = {
							
								'action' : 'cqpim_backend_quote_submission',
								
								'client' : client,
							
								<?php
								
								foreach($fields as $field) {
								
									$id = strtolower($field->label);
									
									$id = str_replace(' ', '_', $id);
									
									$id = str_replace('-', '_', $id);
									
									$id = str_replace(':', '', $id);
									
									$id = str_replace('(', '', $id);
									
									$id = str_replace(')', '', $id);

									echo "'" . $id . "' : " . $id . ",";
								
								}
								
								?>
							
							};
							
							jQuery.ajax({

								url: '<?php echo admin_url() . 'admin-ajax.php'; ?>',

								data: data,

								type: 'POST',

								dataType: 'json',

								beforeSend: function(){

									// show spinner

									spinner.show();

									// disable form elements while awaiting data

									jQuery('#cqpim_submit_backend').prop('disabled', true);

								},

							}).done(function(response){
							
								if(response.error == true) {
								
									spinner.hide();

									// re-enable form elements so that new enquiry can be posted

									jQuery('#cqpim_submit_backend').prop('disabled', false);
								
									jQuery('#cqpim_submit_backend_messages').html(response.message);
									
								} else {

									spinner.hide();

									// re-enable form elements so that new enquiry can be posted

									jQuery('#cqpim_submit_backend').prop('disabled', false);
									
									jQuery('#cqpim_submit_backend_messages').html(response.message);
								
								}

							});
						
						});
					
					});
				
				</script>			
			
			<?php } ?>
			
			<?php if(isset( $_GET['page'] ) && $_GET['page'] == 'add-envato-purchase'  ) { ?>
			
				<?php

					$user = wp_get_current_user();
					
					$args = array(
					
						'post_type' => 'cqpim_client',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private',
						
					);
					
					$clients = get_posts($args);
					
					foreach($clients as $client) {
					
						$client_details = get_post_meta($client->ID, 'client_details', true);
						
						$client_user_id = $client_details['user_id'];
						
						if($user->ID === $client_user_id) {
						
							$client_object_id = $client->ID;
						
						}
					
					}
					
					if(empty($client_object_id)) {
					
						foreach($clients as $client) {
						
							$client_ids = get_post_meta($client->ID, 'client_ids', true);
							
							if(in_array($user->ID, $client_ids)) {
							
								$client_object_id = $client->ID;
								
								$client_type = 'contact';
							
							}
						
						} 			
					
					}
					
					$envato_details = get_post_meta($client_object_id, 'envato_details', true);	
					
				?>
						
					<?php if(empty($envato_details)) { ?>
					
						<p><?php _e('You do not have a valid licence for any of our items, or you haven\'t registered them', 'cqpim'); ?></p>
						
					<?php } else {
					
						echo '<table class="milestones dash">';
						
							echo '<thead>';
							
								echo '<tr><th style="border-left:1px solid #ececec">' . __('Item ID', 'cqpim') . '</th><th>' . __('Item Name', 'cqpim') . '</th><th>' . __('Purchase Date', 'cqpim') . '</th><th>' . __('Licence', 'cqpim') . '</th><th>' . __('Support Expiry', 'cqpim') . '</th><th>' . __('Purchase Code', 'cqpim') . '</th></tr>';
							
							echo '</thead>';
							
							echo '<tbody>';
							
								foreach($envato_details as $purchase) {
								
									echo '<tr>';
									
									echo '<td style="border-left:1px solid #ececec">' . $purchase['item_id'] . '</td>';
									
									echo '<td>' . $purchase['item_name'] . '</td>';
									
									echo '<td>' . $purchase['created_at'] . '</td>';
									
									echo '<td>' . $purchase['licence'] . '</td>';
									
									if(!empty($purchase['supported_until'])) {
									
										echo '<td>' . $purchase['supported_until'] . '</td>';
									
									} else {
									
										echo '<td>' . __('EXPIRED', 'cqpim-envato') . '</td>';
									
									}
									
									echo '<td>' . $purchase['purchase_code'] . '</td>';
									
									echo '</tr>';
								
								}
							
							echo '</tbody>';
						
						echo '</table>';	
					
					} ?>
					
					<br /><br />
					
					<a href="#" id="add-envato-code-trigger" class="cqpim-dash-button medium"><?php _e('Add Purchase Code', 'cqpim'); ?></a>
					
					<div id="add-envato-code-container" style="display:none">
					
						<div id="add-envato-code-div">
						
							<div style="padding:12px">
						
								<h3><?php _e('Add Envato Purchase Code', 'cqpim'); ?></h3>
								
								<p><?php _e('Enter the purchase code of the item that you would like to add to your account.', 'cqpim'); ?></p>
								
								<input style="width:92%; padding:2.5%" type="text" id="purchase_code" />
								
								<br /><br />
								
								<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
								
								<button id="add-envato-code" class="metabox-add-button"><?php _e('Add Purchase Code', 'cqpim'); ?></button>
								
								<div class="clear"></div>
								
								<div style="margin-top:20px; display:none" id="login_messages"></div>
							
							</div>
						
						</div>
					
					</div>			
			
			<?php } ?>
			
			<?php if(isset( $_GET['page'] ) && $_GET['page'] == 'add-support-ticket'  ) { 
				
				$string = RandomString(10);
			
				?>

				<div id="cqpim_backend_quote">
					
						<input type="hidden" name="action" value="new_ticket" />
						
						<?php
						
						include_once(ABSPATH.'wp-admin/includes/plugin.php');
					
						if(is_plugin_active('cqpim-envato/cqpim-envato.php')) {	
						
							$messages = get_option('raise_support_messages');
							
							$messages = str_replace('%%TIME%%', current_time('l dS F, g:iA'), $messages);
							
							echo $messages;

							$items = get_option('cqpim_envato_items'); ?>
							
							<h4><?php _e('Which product do you need help with?', 'cqpim'); ?></h4>
							
							<select name="ticket_item" id="ticket_item" required >
							
								<option value=""><?php _e('Choose a product...', 'cqpim'); ?></option>
								
								<?php
								
								foreach($items as $item) {
								
									echo '<option value="' . $item['id'] . '">' . $item['name'] . '</option>';
								
								}
								
								?>
							
							</select>
							
							<div style="margin-top:20px" id="login_messages"></div>
							
							<input type="hidden" id="reject_reason" value="" />
							
							<?php

						}
						
						?>
					
						<h4><?php _e('Ticket Title:', 'cqpim'); ?></h4>
				
						<input style="width:100%" type="text" id="ticket_title" required />

						<h4><?php _e('Ticket Priority:', 'cqpim'); ?></h4>
							
						<select style="width:100%" id="ticket_priority_new" name="ticket_priority_new">
						
							<option value="low" <?php if($ticket_priority == 'low') { echo 'selected="selected"'; } ?>><?php _e('Low', 'cqpim'); ?></option>
							
							<option value="normal" <?php if($ticket_priority == 'normal') { echo 'selected="selected"'; } ?>><?php _e('Normal', 'cqpim'); ?></option>
							
							<option value="high" <?php if($ticket_priority == 'high') { echo 'selected="selected"'; } ?>><?php _e('High', 'cqpim'); ?></option>
							
							<option value="immediate" <?php if($ticket_priority == 'immediate') { echo 'selected="selected"'; } ?>><?php _e('Immediate', 'cqpim'); ?></option>
						
						</select>	
						
						<?php
						
							$_SESSION['upload_ids'] = array();
							
							$_SESSION['ticket_changes'] = array();
						
						?>

						<h4><?php _e('Upload Files', 'cqpim'); ?></h4>
						
						<form id="upload" method="post" enctype="multipart/form-data">
						
							<div id="drop">
								
								<?php _e('Drop Here', 'cqpim'); ?>

								<a><?php _e('Browse', 'cqpim'); ?></a>
								
								<input type="file" name="upl" multiple />
								
							</div>
							
							<ul>
								
							</ul>
						
						</form>

						<h4><?php _e('Details', 'cqpim'); ?></h4>				

						<textarea style="width:97.7%; height:300px; padding:1%" id="ticket_update_new" name="ticket_update_new" required ></textarea>
					
						<div class="clear"></div>
					
						<input id="support-submit" type="submit" class="metabox-add-button" style="margin-right:0" value="<?php _e('Create Ticket', 'cqpim'); ?>" />
					
					<br />
				
				</div>
			
			<?php } ?>
			
			<?php if(isset( $_GET['page'] ) && $_GET['page'] == 'settings') { ?>
			
			<?php 
			
			$client_settings = get_option('allow_client_settings');
			
			if($client_settings == 1) { ?>
				
					<div <?php if($dash_type != 'inc') { echo 'style="width:100%; background:0"'; } ?> class="cqpim-dash-item">
					
						<h3><?php _e('Settings', 'cqpim'); ?></h3>
						
						<div class="cqpim-dash-item-inside">

					<div id="cqpim_backend_quote">
					
						<?php
						
							if($client_type == 'admin') {
													
								$client_details = get_post_meta($assigned, 'client_details', true);
								
							} else {
							
								$client_details = get_post_meta($assigned, 'client_details', true);
							
								$client_contacts = get_post_meta($assigned, 'client_contacts', true);
								
								foreach($client_contacts as $key => $contact) {
								
									if($key == $user_id) {
									
										$client_details['client_telephone'] = $contact['telephone'];
										
										$client_details['client_contact'] = $contact['name'];
										
										$client_details['client_email'] = $contact['email'];
									
									}
								
								}
							
							}
						
						?>
				
						<form id="client_settings">
						
							<h4><?php _e('My Details', 'cqpim'); ?></h3>
							
							<label for="client_email"><?php _e('Email Address', 'cqpim'); ?></label>
							
							<input style="width:98%; padding:1%" type="text" id="client_email" name="client_email" value="<?php echo $user->user_email; ?>" required />
							
							<label for="client_phone"><?php _e('Telephone', 'cqpim'); ?></label>
							
							<input style="width:98%; padding:1%" type="text" id="client_phone" name="client_phone" value="<?php echo isset($client_details['client_telephone']) ? $client_details['client_telephone'] : ''; ?>" required />
							
							<label for="client_email"><?php _e('Display Name', 'cqpim'); ?></label>
							
							<input style="width:98%; padding:1%" type="text" id="client_name" name="client_name" value="<?php echo $user->display_name; ?>" required />
							
							<h4 style="margin-top:20px"><?php _e('Company Details', 'cqpim'); ?></h3>
							
							<label for="company_name"><?php _e('Company Name', 'cqpim'); ?></label>
							
							<input style="width:98%; padding:1%" type="text" id="company_name" name="company_name" value="<?php echo isset($client_details['client_company']) ? $client_details['client_company'] : ''; ?>" required />
							
							<label for="company_address"><?php _e('Company Address', 'cqpim'); ?></label>
							
							<textarea style="width:98%; padding:1%; height:100px" id="company_address" name="company_address" required ><?php echo isset($client_details['client_address']) ? $client_details['client_address'] : ''; ?></textarea>

							<label for="company_postcode"><?php _e('Company Postcode', 'cqpim'); ?></label>
							
							<input style="width:98%; padding:1%" type="text" id="company_postcode" name="company_postcode" value="<?php echo isset($client_details['client_postcode']) ? $client_details['client_postcode'] : ''; ?>" required />							
							
							<h4 style="margin-top:20px"><?php _e('Change Password', 'cqpim'); ?></h3>
							
							<label for="client_pass"><?php _e('New Password', 'cqpim'); ?></label>
							
							<input style="width:98%; padding:1%" type="password" id="client_pass" name="client_pass" value="" />
							
							<label for="client_pass_rep"><?php _e('Repeat New Password', 'cqpim'); ?></label>
							
							<input style="width:98%; padding:1%" type="password" id="client_pass_rep" name="client_pass_rep" value=""  />
							
							<br />
							
							<input style="width:100%" type="hidden" id="client_type" name="client_type" value="<?php echo $client_type; ?>" />
							
							<input style="width:100%" type="hidden" id="client_object" name="client_object" value="<?php echo $assigned; ?>" />
							
							<input style="width:100%" type="hidden" id="client_user_id" name="client_user_id" value="<?php echo $user->ID; ?>" />
							
							<br />
							
							<input style="float:left; margin-left:0" type="submit" id="client_settings_submit" class="metabox-add-button" value="<?php _e('Update Settings', 'cqpim'); ?>" />
						
							<div class="clear"></div>
							
							<div id="settings_spinner" style="clear:both; display:none; background:url(<?php echo plugins_url(); ?>/cqpim/css/img/ajax-loader.gif) center center no-repeat; width:16px; height:16px; padding:10px 0 0 5px; margin-top:15px"></div>
							
							<div class="clear"></div>
							
							<br />
							
							<div id="settings_messages"></div>
							
						</form>
					
					</div>
				
						</div>
						
					</div>
				
				<?php } ?>	
			
			<?php } ?>	
			
			<?php if(isset( $_GET['page'] ) && $_GET['page'] == 'contacts') { ?>
			
			<?php 
			
			$client_settings = get_option('allow_client_users');
			
			if($client_settings == 1) { ?>
				
					<div <?php if($dash_type != 'inc') { echo 'style="width:100%; background:0"'; } ?> class="cqpim-dash-item">
					
						<h3><?php _e('Contacts', 'cqpim'); ?></h3>
						
						<div class="cqpim-dash-item-inside">
					
				<p><?php _e('If you would like to give multiple users at your organisation access to your client dashboard, you can do so here.', 'cqpim'); ?></p>
				
				<?php 
				
				$client_contacts = get_post_meta($assigned, 'client_contacts', true);
				
				if(empty($client_contacts)) {
				
					echo '<p>' . __('You have not added any additional contacts', 'cqpim') . '</p>';
				
				} else {
				
					foreach($client_contacts as $key => $contact) {
					
						$size = 100;
			
						$grav_url = "http://www.gravatar.com/avatar/" . md5( strtolower( trim( $contact['email'] ) ) ) . "&s=" . $size;
						
						echo '<div class="team_member">';
						
						echo '<div class="team_delete"><button style="margin-right:5px" class="edit-milestone" value="'. $key . '"><img title="Edit Contact" src="' . plugin_dir_url( __FILE__ ) . 'img/edit.png"></button><button class="delete_team" value="' . $key . '"><img title="Remove Client Contact" src="' . plugin_dir_url( __FILE__ ) . 'img/delete.png"></button><div id="ajax_spinner_team_' . $key . '" class="ajax_spinner" style="display:none"></div></div>';
						
						echo '<img style="float:left" src="' . $grav_url . '" />';
						
						echo '<div class="team_details">';
						
						echo '<strong>' . __('Name:', 'cqpim') . ' </strong>' . $contact['name'] . '<br />';
						
						echo '<strong>' . __('User ID:', 'cqpim') . ' </strong>' . $contact['user_id'] . '<br />';
						
						echo '<strong>' . __('Email:', 'cqpim') . ' </strong>' . $contact['email'] . '<br />';
						
						echo '<strong>' . __('Telephone:', 'cqpim') . ' </strong>' . $contact['telephone'] . '<br />';
						
						echo '</div>';
						
						echo '<div class="clear"></div>';
						
						echo '</div>';			
					
					}
					
					echo '<div class="clear"></div>';
					
					foreach($client_contacts as $key => $contact) { ?>
					
						<div id="contact_edit_container_<?php echo $key; ?>" style="display:none">
						
							<div id="contact_edit_<?php echo $key; ?>" class="contact_edit">
							
								<div style="padding:12px">
							
									<h3><?php _e('Edit Contact', 'cqpim'); ?> - <?php echo $contact['name']; ?></h3>
									
									<label for="contact_name_<?php echo $key; ?>"><?php _e('Contact Name', 'cqpim'); ?></label>
									
									<input type="text" id="contact_name_<?php echo $key; ?>" name="contact_name_<?php echo $key; ?>" value="<?php echo $contact['name']; ?>" />
									
									<br /><br />
									
									<label for="contact_email_<?php echo $key; ?>"><?php _e('Contact Email', 'cqpim'); ?></label>
									
									<input type="text" id="contact_email_<?php echo $key; ?>" name="contact_email_<?php echo $key; ?>" value="<?php echo $contact['email']; ?>" />
									
									<br /><br />
									
									<label for="contact_telephone_<?php echo $key; ?>"><?php _e('Contact Telephone', 'cqpim'); ?></label>
									
									<input type="text" id="contact_telephone_<?php echo $key; ?>" name="contact_telephone_<?php echo $key; ?>" value="<?php echo $contact['telephone']; ?>" />
									
									<br /><br />
									
									<h3><?php _e('Reset Password', 'cqpim'); ?></h3>
									
									<input class="pass" type="password" id="new_password_<?php echo $key; ?>" name="new_password_<?php echo $key; ?>" placeholder="<?php _e('Enter new password', 'cqpim'); ?>" />
									
									<br /><br />
									
									<input class="pass" type="password" id="confirm_password_<?php echo $key; ?>" name="confirm_password_<?php echo $key; ?>" placeholder="<?php _e('Confirm new password', 'cqpim'); ?>" />
									
									<br /><br />
									
									<input type="checkbox" id="send_new_password_<?php echo $key; ?>" name="send_new_password_<?php echo $key; ?>" value="1" /> <?php _e('Send the contact\'s new password by email', 'cqpim'); ?>
									
									<br /><br />
									
									<input class="pass" type="hidden" id="pass_type_<?php echo $key; ?>" name="pass_type_<?php echo $key; ?>" value="contact" />
									
									<div id="client_team_messages_<?php echo $key; ?>"></div>							
									
									<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
												
									<button id="contact_edit_submit_<?php echo $key; ?>" class="metabox-add-button contact_edit_submit" value="<?php echo $key; ?>"><?php _e('Edit Contact', 'cqpim'); ?><span id="ajax_spinner_contact_<?php echo $key; ?>" class="ajax_loader" style="display:none"></span></button>
							
								</div>
							
							</div>
						
						</div>
					
					<?php
					
					}
					
				} 
			
			} if($client_settings == 1) { ?>
			
				<button style="float:left; margin-left:0" id="add_client_team" class="metabox-add-button" value="<?php echo $client_user; ?>"><?php _e('Add Contact', 'cqpim'); ?></button>

			<?php } ?>
			
			<div class="clear"></div>
			
			<div id="add_client_team_ajax_container" style="display:none">
			
				<div id="add_client_team_ajax">
				
					<div style="padding:12px">
				
						<h3><?php _e('Add Contact', 'cqpim'); ?></h3>
						
						<p><?php _e('Adding a contact will create a new login and give the user access to the client dashboard.', 'cqpim'); ?></p>
						
						<label for="contact_name"><?php _e('Contact Name', 'cqpim'); ?></label>
						
						<input type="text" id="contact_name" name="contact_name" />
						
						<br /><br />
						
						<label for="contact_email"><?php _e('Contact Email', 'cqpim'); ?></label>
						
						<input type="text" id="contact_email" name="contact_email" />
						
						<br /><br />
						
						<label for="contact_telephone"><?php _e('Contact Telephone', 'cqpim'); ?></label>
						
						<input type="text" id="contact_telephone" name="contact_telephone" />
						
						<br /><br />
						
						<input type="checkbox" id="send_contact_details" name="send_contact_details" value="1" /> <?php _e('Send the contact login details by email', 'cqpim'); ?>
						
						<br /><br />
						
						<input type="hidden" id="post_ID" name="post_id" value="<?php echo $assigned; ?>" />
						
						<div id="client_team_messages"></div>
						
						<button class="cancel-colorbox"><?php _e('Cancel', 'cqpim'); ?></button>
									
						<button id="add_client_team_submit" class="metabox-add-button"><?php _e('Add Client Contact', 'cqpim'); ?><span id="ajax_spinner_add_contact" class="ajax_loader" style="display:none"></span></button>

					</div>
				
				</div>
			
			</div>
			
					</div>
					
				</div>
			
			<?php } ?>
			
		
		</div>
		
	</div>
	
<?php

	get_footer();
	
 ?>
	


