<?php 

if (!current_user_can( 'cqpim_client' )) {

	$login_page = get_option('cqpim_login_page');
	
	$url = get_the_permalink($login_page);
	
	wp_redirect($url, 302);

} else {

	$user = wp_get_current_user(); 
	
	$login_page_id = get_option('cqpim_login_page');
	
	$login_url = get_the_permalink($login_page_id);
	
	$user_id = $user->ID;
	
	// Gravatar
	
	$email = $user->user_email;
	
	$size = 60;
	
	$grav_url = "https://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "&s=" . $size;
	
	$dash_type = get_option('client_dashboard_type');
	
	$quote_form = get_option('cqpim_backend_form');
	
	// Assignment
	
	$args = array(
	
		'post_type' => 'cqpim_client',
		
		'posts_per_page' => -1,
		
		'post_status' => 'private'
	
	);
	
	$members = get_posts($args);
	
	foreach($members as $member) {
	
		$team_details = get_post_meta($member->ID, 'client_details', true);
		
		if($team_details['user_id'] == $user->ID) {
		
			$assigned = $member->ID;
			
			$client_type = 'admin';
		
		}
	
	} 
	
	if(empty($assigned)) {
	
		foreach($members as $member) {
		
			$team_ids = get_post_meta($member->ID, 'client_ids', true);
			
			if(in_array($user->ID, $team_ids)) {
			
				$assigned = $member->ID;
				
				$client_type = 'contact';
			
			}
		
		} 			
	
	}
	
	$client_details = get_post_meta($assigned, 'client_details', true);
	
	$client_ids = get_post_meta($assigned, 'client_ids', true);
	
	$login_url = get_option('cqpim_logout_url');
	
	if(empty($login_url)) {
	
		$login_url = get_the_permalink($login_page_id);
		
	}
	
} 

	get_header();
	
 ?>

	<div style="padding-left:0; margin:0 auto; max-width:1100px; padding:20px; background:#fff" class="cqpim-client-dash" role="main">	
	
		<div style="background:0; padding:0 0 30px 0" class="cqpim-dash-header">
		
			<img style="float:left; margin-right:10px" src="<?php echo $grav_url; ?>" />

			<h1><?php printf(__('Welcome back, %1$s', 'cqpim'), $user->display_name); ?><br /><span style="font-weight:700; font-size:12px; line-height:14px; padding:4px 8px" class="task_complete"><?php echo $email; ?></span> <span style="margin-left:10px;font-weight:700; font-size:12px; line-height:14px; padding:4px 8px" class="task_complete"><?php echo $client_details['client_company']; ?> <?php if($client_type == 'admin') { echo '&nbsp;&nbsp;(Main Contact)'; } ?></span></h1>
		
			<div class="clear"></div>
			
				<?php $client_dash = get_option('cqpim_client_page'); ?>
			
				<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash); ?>"><?php _e('Dashboard', 'cqpim'); ?></a>
		
				<?php if(!empty($quote_form)) { ?>
				
					<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash) . '?page=quote_form'; ?>"><?php _e('Request a Quote', 'cqpim'); ?></a>
				
				<?php } 
			
				$client_settings = get_option('allow_client_settings');
				
				if($client_settings == 1) { ?>				
					
					<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash) . '?page=settings'; ?>"><?php _e('Settings', 'cqpim'); ?></a>

				<?php } 
				
				$client_settings = get_option('allow_client_users');
				
				if($client_settings == 1) { ?>	

					<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo get_the_permalink($client_dash) . '?page=contacts'; ?>"><?php _e('Users', 'cqpim'); ?></a>

				<?php } ?>
				
				<a style="width:auto; margin-right:12px" class="btn-printable" href="<?php echo wp_logout_url($login_url); ?>"><?php _e('Log Out', 'cqpim'); ?></a>
				
				<div class="clear"></div>

		</div>
		
		<div style="padding:0" class="cqpim-dash-quote">
				
				<?php if(current_user_can( 'cqpim_send_quotes' ) OR $client_user_id == $user_id OR in_array($user->ID, $client_ids)) { ?>
				
				<div class="quote_logo">
				
					<img src="<?php echo $logo['company_logo']; ?>" />
				
				</div>
				
				<div class="quote_contacts">
				
					<?php echo get_option('company_name'); ?><br />
					
					<?php _e('Tel:', 'cqpim'); ?> <?php echo get_option('company_telephone'); ?><br />
					
					<?php _e('Email:', 'cqpim'); ?> <a href="<?php echo get_option('company_sales_email'); ?>"><?php echo get_option('company_sales_email'); ?></a>
				
				</div>
				
				<div class="clear"></div>
				
				<a class="btn-printable" href="<?php echo get_the_permalink(); ?>?page=print" target="_blank"><?php _e('VIEW PRINTABLE VERSION', 'cqpim'); ?></a>
				
				<div class="clear"></div>
				
				<br /><br />
				
				<?php echo wpautop($quote_header); ?>
				
				
				<?php
				
				if($quote_summary) {
				
					echo '<h2> ' . __('Summary', 'cqpim') . '</h2>';
					
					echo wpautop($quote_summary);
				
				}
				
				?>
				
		<?php 
				
		if($start_date || $finish_date) {
				
			echo '<h2>' . __('Project Dates', 'cqpim') . '</h2>';
				
		}
				
		if($start_date) {
		
			if(is_numeric($start_date)) { $start_date = date(get_option('cqpim_date_format'), $start_date); } else { $start_date = $start_date; }
				
			echo '<p>' . __('Start Date', 'cqpim') . ' - ' . $start_date . '</p>';
					
		}
				
		if($finish_date) {
		
			if(is_numeric($finish_date)) { $finish_date = date(get_option('cqpim_date_format'), $finish_date); } else { $finish_date = $finish_date; }
				
			echo '<p>' . __('Completion/Launch Date', 'cqpim') . ' - ' . $finish_date . '</p>';
					
		}
				
		?>

		<h2><?php _e('Milestones', 'cqpim'); ?></h2>
				
				<?php
				
				if(!empty($quote_elements)) {
				
					$msordered = array();
				
					$i = 0;
					
					$mi = 0;
					
					foreach($quote_elements as $key => $element) {
					
						$weight = isset($element['weight']) ? $element['weight'] : $mi;
					
						$msordered[$weight] = $element;
						
						$mi++;
					
					}
					
					ksort($msordered);					
				
					foreach($msordered as $element) {  ?>
					
						<div class="quote_milestone">
					
							<h3><?php echo $element['title']; ?></h3>
							
							<div class="quote_milestone_content">
							
								<?php
								
								$args = array(
								
									'post_type' => 'cqpim_tasks',
									
									'posts_per_page' => -1,
									
									'meta_key' => 'milestone_id',
									
									'meta_value' => $element['id'],
									
									'orderby' => 'date',
									
									'order' => 'ASC'
									
								);
								
								$tasks = get_posts($args);
								
								if($tasks) {
								
									$ti = 0;
									
									$ordered = array();
									
									$wi = 0;
									
									foreach($tasks as $task) {
									
										$task_details = get_post_meta($task->ID, 'task_details', true);
										
										$weight = isset($task_details['weight']) ? $task_details['weight'] : $wi;
										
										$ordered[$weight] = $task;
										
										$wi++;
									
									}
									
									ksort($ordered);
								
									echo '<ul>';
								
									foreach($ordered as $task) {
									
										echo '<li>' . $task->post_title . '</li>';
										
										$ti++;
									
									}
									
									echo '</ul>';
								
								}
								
								?>
							
							</div>
							
							<ul class="quote_milestone_additional">
							
								<?php
								
								if($element['start']) {
								
									if(is_numeric($element['start'])) { $element['start'] = date(get_option('cqpim_date_format'), $element['start']); } else { $element['start'] = $element['start']; }
								
									echo '<li><strong>' . __('Start Date', 'cqpim') . ': </strong> ' . $element['start'] . '</li>';
									
								} 
								
								if($element['deadline']) {
								
									if(is_numeric($element['deadline'])) { $element['deadline'] = date(get_option('cqpim_date_format'), $element['deadline']); } else { $element['deadline'] = $element['deadline']; }
									
									echo '<li><strong>' . __('Deadline', 'cqpim') . ': </strong> ' . $element['deadline'] . '</li>';											
									
								}
								
								
								if($element['cost']) {
								
									if($type == 'estimate') {
									
										$cost = preg_replace("/[^\\d.]+/","", $element['cost']);
									
										echo '<li><strong>' . __('Estimated Cost', 'cqpim') . ': </strong> ' . $currency . '' . $cost . '' . $vat_string . '</li>';											
									
									} else {
									
										$cost = preg_replace("/[^\\d.]+/","", $element['cost']);
									
										echo '<li><strong>' . __('Cost', 'cqpim') . ':</strong> ' . $currency . '' . $cost . '' . $vat_string . '</li>';																				
									
									}
								
								}
								
								?>
							
							</ul>
						
						</div>
					
					<?php $i++; }
					
					}
				
				?>
				
				<h2><?php _e('Cost Breakdown', 'cqpim'); ?></h2>
				
				<?php
				
				if(!empty($quote_elements)) {
					
					echo '<table class="quote_summary"><thead><tr>';
					
					echo '<th>' . __('Milestone', 'cqpim') . '</th>';
					
					if($type == 'estimate') {
						
						echo '<th>' . __('Estimated Cost', 'cqpim') . '</th>';
					
					} else {
					
						echo '<th>' . __('Cost', 'cqpim') . '</th>';
						
					}
					
					echo '</tr></thead>';
					
					echo '<tbody>';
					
					$subtotal = 0;
					
					foreach($msordered as $key => $element) {
					
						$cost = preg_replace("/[^\\d.]+/","", $element['cost']);
					
						$subtotal = $subtotal + $cost;
					
						echo '<tr><td class="qtitle">' . $element['title'] . '</td>';
						
						echo '<td class="qcost">' . $currency . '' . $cost . '</td></tr>';
					
					}
					
					if(!empty($vat)) {
					
						$total_vat = $subtotal / 100 * $vat;
						
						$total = $subtotal + $total_vat;
						
						$tax_name = get_option('sales_tax_name');
						
						$span = '';
						
						echo '<tr><td '.$span.' align="right" class="align-right">' . __('Subtotal', 'cqpim') . ': </td><td class="subtotal">' . $currency . '' . number_format((float)$subtotal, 2, '.', '') . '</td></tr>';
						
						echo '<tr><td '.$span.' align="right" class="align-right">' . $tax_name . ': </td><td class="subtotal">' . $currency . '' . number_format((float)$total_vat, 2, '.', '') . '</td></tr>';

						echo '<tr><td '.$span.' align="right" class="align-right">' . __('TOTAL', 'cqpim') . ': </td><td class="subtotal">' . $currency . '' . number_format((float)$total, 2, '.', '') . '</td></tr>';
						
					} else {
					
						$span = '';
					
						echo '<tr><td '.$span.' align="right" class="align-right">' . __('TOTAL', 'cqpim') . ': </td><td class="subtotal">' . $currency . '' . number_format((float)$subtotal, 2, '.', '') . '</td></tr>';	
					
					}
					
					echo '</tbody></table>'; 
					
				}
				
				if($type == 'estimate') { ?>
				
				<br /><br />
				
				<h4 style="text-align:right"><strong><?php _e('NOTE:', 'cqpim'); ?> </strong><?php _e('THIS IS AN ESTIMATE, SO THESE PRICES MAY NOT REFLECT THE FINAL PROJECT COST.', 'cqpim'); ?></h4>
				
				<?php } ?>
				
				<h2><?php _e('Payment Plan', 'cqpim'); ?></h2>
				
				<p><strong><?php _e('Deposit', 'cqpim'); ?></strong></p>
				
				<?php
				
				if($deposit == 'none') {
				
					echo '<p>' . __('We do not require an up-front deposit payment on this project.', 'cqpim') . '</p>';
					
				} else {
				
					if(empty($subtotal)) {
					
						$subtotal = 0;
						
					}
				
					$deposit_amount = $subtotal / 100 * $deposit;
					
					echo '<p>';
					
					printf(__('We require an initial deposit payment of %1$s percent on this project.', 'cqpim'), $deposit);

					echo '</p>';
					
					echo '<p><strong>';
					
					_e('Deposit Amount:', 'cqpim');
					
					echo '</strong>';
					
					echo ' ' . $currency . '' . number_format((float)$deposit_amount, 2, '.', '') . '' . $vat_string;
					
					echo '</p>';
				}	
					
				?>
						
				<br /><br />
				
				<?php 
				
				$terms = get_option('enable_quote_terms'); 
				
				$contract_text = get_option('default_contract_text');

				$contract_text = cqpim_replacement_patterns($contract_text, $post->ID, 'quote');
				
				if($terms == 1) { 
				
					echo '<h1>' . __('TERMS &amp; CONDITIONS', 'cqpim') . '</h1>';
				
					$contract = isset($quote_details['default_contract_text']) ? $quote_details['default_contract_text'] : '';
					
					if(empty($contract)) {
					
						$text = get_post_meta($contract_text, 'terms', true);
						
						$text = cqpim_replacement_patterns($text, $post->ID, 'quote');
						
						echo wpautop($text);
						
					} else {
					
						$text = get_post_meta($contract, 'terms', true);
						
						$text = cqpim_replacement_patterns($text, $post->ID, 'quote');
						
						echo wpautop($text);			
					
					}				
				
				} ?>
				
				<?php echo wpautop($quote_footer); ?>
				
				<div id="acceptance">
				
					<?php
					
					$is_confirmed = isset( $quote_details['confirmed'] ) ? $quote_details['confirmed'] : '';
					
					if(!$is_confirmed) { ?>
					
					<h2><?php _e('Acceptance', 'cqpim'); ?></h2>
					
					<?php 
					
						$acceptance = get_option('quote_acceptance_text');
						
						$acceptance = cqpim_replacement_patterns($acceptance, $post->ID, 'quote');
					
						echo wpautop($acceptance); 
						
					?>
									
					<div style="padding:40px" class="quote_acceptance">
					
						<form id="submit-quote-conf">
						
							<input type="hidden" id="quote_id" value="<?php the_ID(); ?>" />
						
							<input type="hidden" id="pm_name" value="<?php echo get_the_author_meta( 'display_name' ); ?>" />
						
							<input type="text" id="conf_name" name="conf_name" placeholder="<?php _e('Enter your name', 'cqpim'); ?>" required />
						
							<input type="submit" id="accept_quote" value="<?php _e('Accept', 'cqpim'); ?>" />
						
							<div class="ajax_spinner" style="display: none;"></div>
						
							<div id="messages"></div>
						
						</form>	

					</div>
					
					<?php } else { 
					
						$conf_by = isset($quote_details['confirmed_details']['by']) ? $quote_details['confirmed_details']['by'] : '';
						
						$conf_date = isset($quote_details['confirmed_details']['date']) ? $quote_details['confirmed_details']['date'] : '';
						
						if(is_numeric($conf_date)) { $conf_date = date(get_option('cqpim_date_format') . ' H:i', $conf_date); } else { $conf_date = $conf_date; }
						
						$conf_ip = isset($quote_details['confirmed_details']['ip']) ? $quote_details['confirmed_details']['ip'] : '';				
					
						?>
						
						<div class="contract-confirmed">
						
							<h5 style="text-transform:uppercase"><?php printf(__('THIS %1$s HAS BEEN ACCEPTED', 'cqpim'), $upper_type); ?></h5>
						
							<br />
						
							<p><?php printf(__('Accepted by %1$s @ %2$s from IP Address %3$s', 'cqpim'), $conf_by, $conf_date, $conf_ip); ?></p>
						
						</div>
					
					
					<?php } ?>
				
				</div>
				
				<br /><br />
				
				<a class="btn-printable" href="<?php echo get_the_permalink(); ?>?page=print" target="_blank"><?php _e('VIEW PRINTABLE VERSION', 'cqpim'); ?></a>
				
				<div class="clear"></div>
				
			<?php } else { ?>
			
				<h1><?php _e('Access Denied', 'cqpim'); ?></h1>
			
			<?php } ?>
			
		</div>
			
		</div><!-- #content -->

<?php

	get_footer();
	
 ?>
 
 <?php exit; ?>
