<?php 

$user = wp_get_current_user();

if (!in_array('cqpim_client', $user->roles)) {

	$login_page = get_option('cqpim_login_page');
	
	$url = get_the_permalink($login_page);
	
	wp_redirect($url, 302);
	
	exit();

} else {
	
	include_once( realpath(dirname(__FILE__)) . '/upload.php' );

	$user = wp_get_current_user(); 	
	
	$login_page_id = get_option('cqpim_login_page');
	
	$login_url = get_the_permalink($login_page_id);
	
	$user_id = $user->ID;
	
	// Gravatar
	
	$email = $user->user_email;
	
	$size = 60;
	
	$grav_url = "https://www.gravatar.com/avatar/" . md5( strtolower( trim( $email ) ) ) . "&s=" . $size;
	
	$dash_type = get_option('client_dashboard_type');
	
	$theme = wp_get_theme();
	
	$quote_form = get_option('cqpim_backend_form');
	
	// Assignment
	
	$args = array(
	
		'post_type' => 'cqpim_client',
		
		'posts_per_page' => -1,
		
		'post_status' => 'private'
	
	);
	
	$members = get_posts($args);
	
	foreach($members as $member) {
	
		$team_details = get_post_meta($member->ID, 'client_details', true);
		
		if($team_details['user_id'] == $user->ID) {
		
			$assigned = $member->ID;
			
			$client_type = 'admin';
		
		}
	
	} 
	
	if(empty($assigned)) {
	
		foreach($members as $member) {
		
			$team_ids = get_post_meta($member->ID, 'client_ids', true);
			
			if(in_array($user->ID, $team_ids)) {
			
				$assigned = $member->ID;
				
				$client_type = 'contact';
			
			}
		
		} 			
	
	}
	
	$client_details = get_post_meta($assigned, 'client_details', true);
	
	$client_ids = get_post_meta($assigned, 'client_ids', true);
	
	$client_ids_untouched = $client_ids;
	
	if(empty($client_ids_untouched)) {
		
		$client_ids_untouched = array();
		
	}
	
	$login_url = get_option('cqpim_logout_url');
	
	if(empty($login_url)) {
	
		$login_url = get_the_permalink($login_page_id);
		
	}
	
}

?>

	<?php include('header.php'); ?>

	<div class="cqpim-dash-title">
	
		<?php

			if( isset( $_GET['page'] ) && $_GET['page'] == 'quotes'  ) {

				_e('Quotes / Estimates', 'cqpim');

			} elseif( isset( $_GET['page'] ) && $_GET['page'] == 'projects'  ) {

				_e('Projects', 'cqpim');

			} elseif( isset( $_GET['page'] ) && $_GET['page'] == 'support'  ) {

				_e('Support Tickets', 'cqpim');

			} elseif( isset( $_GET['page'] ) && $_GET['page'] == 'invoices'  ) {

				_e('Invoices', 'cqpim');

			} elseif( isset( $_GET['page'] ) && $_GET['page'] == 'quote_form'  ) {

				_e('Request a Quote', 'cqpim');

			} elseif( isset( $_GET['page'] ) && $_GET['page'] == 'settings'  ) {

				_e('Settings', 'cqpim');

			} elseif( isset( $_GET['page'] ) && $_GET['page'] == 'messages'  ) {

				_e('Messages', 'cqpim');

			} elseif( isset( $_GET['page'] ) && $_GET['page'] == 'contacts'  ) {

				_e('Contacts', 'cqpim');

			}  elseif( isset( $_GET['page'] ) && $_GET['page'] == 'add-support-ticket'  ) {

				_e('Add Support Ticket', 'cqpim');

			}  elseif( isset( $_GET['page'] ) && $_GET['page'] == 'add-envato-purchase'  ) {

				_e('My Envato Items', 'cqpim');

			} elseif(empty($_GET['page'])) {
			
				_e('Dashboard', 'cqpim');
			
			}
			
		?>										
	
	</div>
		
	<div class="cqpim-dash-content">
	
		<?php

		if(isset( $_GET['page'] ) && $_GET['page'] == 'quotes' && get_option('enable_quotes') == 1 ) {
		
			include('client-dashboard/quotes-page.php');

		} if(isset( $_GET['page'] ) && $_GET['page'] == 'projects'  ) {

			include('client-dashboard/projects-page.php');

		} if(isset( $_GET['page'] ) && $_GET['page'] == 'support'  ) {

			include('client-dashboard/ticket-page.php');

		} if(isset( $_GET['page'] ) && $_GET['page'] == 'invoices'  ) {
		
			include('client-dashboard/invoice-page.php');
	
		} if(isset( $_GET['page'] ) && $_GET['page'] == 'quote_form' && !empty($quote_form)  ) {
	
			include('client-dashboard/quote-form.php');
	
		} if(isset( $_GET['page'] ) && $_GET['page'] == 'add-envato-purchase'  ) { 
		
			include('client-dashboard/add-envato-purchase.php');
	
		} if(isset( $_GET['page'] ) && $_GET['page'] == 'add-support-ticket'  ) { 
		
			include('client-dashboard/add-ticket.php');
	
		} if(isset( $_GET['page'] ) && $_GET['page'] == 'settings'  ) {
	
			include('client-dashboard/client-settings.php');
	
		} if(isset( $_GET['page'] ) && $_GET['page'] == 'contacts'  ) {
	
			include('client-dashboard/client-contacts.php');
				
		} if(empty($_GET['page'])) {
	
			include('client-dashboard/dashboard.php');
		
		} ?>			
	
	</div>
		
	<?php include('footer.php'); ?>
	
	


