	<div class="masonry-grid">
	
		<div class="cqpim-dash-item grid-item">
		
			<h3><?php _e('Alerts', 'cqpim'); ?></h3>
			
			<div class="cqpim-dash-item-inside">
			
			<?php 
			
				$alerts = array();
				
				if(get_option('disable_invoices') != 1) {
			
				// Check Invoices
				
				$args = array(
				
					'post_type' => 'cqpim_invoice',
					
					'posts_per_page' => -1,
					
					'post_status' => 'publish',
				
				);
				
				$invoices = get_posts($args);
				
				$outstanding_invoices = 0;
				
				$overdue_invoices = 0;
				
				foreach($invoices as $invoice) {
				
					$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
					
					$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
					
					$client_details = get_post_meta($client_id, 'client_details', true);

					$client_ids = get_post_meta($client_id, 'client_ids', true);	

					if(empty($client_ids)) {
					
						$client_ids = array();
						
					}
		
					$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';

					$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
					
					$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';

					$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
					
					$now = time();
							
					$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';							

					if($client_user_id == $user->ID && empty($paid) && !empty($sent) || in_array($user->ID, $client_ids) && empty($paid) && !empty($sent)) {
					
						$outstanding_invoices++;
						
						if($due < $now) {
						
							$overdue_invoices++;
						
						}
					
					}							
				
				}
				
				if($overdue_invoices != 0) {
				
					$alerts[] = array(
					
						'type' => 'oinvoice',
						
						'data' => sprintf(_n('You have %s overdue invoice', 'You have %s overdue invoices', $overdue_invoices, 'cqpim'), $overdue_invoices),
						
					);
						
				}
				
				if($outstanding_invoices != 0) {
				
					$alerts[] = array(
					
						'type' => 'invoice',
						
						'data' => sprintf(_n('You have %s outstanding invoice', 'You have %s outstanding invoices', $outstanding_invoices, 'cqpim'), $outstanding_invoices),
						
					);
						
				}
				
				}
				
				if (get_option('enable_quotes') == 1) {
					
				// Check Quotes
				
				$args = array(
				
					'post_type' => 'cqpim_quote',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private',
				
				);
				
				$quotes = get_posts($args);
				
				$open_quotes = 0;
				
				foreach($quotes as $quote) {
				
					$quote_details = get_post_meta($quote->ID, 'quote_details', true); 
					
					$client_id = isset($quote_details['client_id']) ? $quote_details['client_id'] : '';
					
					$client_details = get_post_meta($client_id, 'client_details', true);

					$client_ids = get_post_meta($client_id, 'client_ids', true);

					if(empty($client_ids)) {
					
						$client_ids = array();
						
					}
					
					$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
					
					$sent = isset($quote_details['sent']) ? $quote_details['sent'] : ''; 
					
					$confirmed = isset($quote_details['confirmed']) ? $quote_details['confirmed'] : ''; 
					
					if($client_user_id == $user->ID && empty($confirmed) && !empty($sent) || in_array($user->ID, $client_ids) && empty($confirmed) && !empty($sent) ) {
					
						$open_quotes++;
					
					}
				
				}
				
				if($open_quotes != 0) {
				
					$alerts[] = array(
					
						'type' => 'quote',
						
						'data' => sprintf(_n('You have %s new quote/estimate that requires your attention', 'You have %s new quotes/estimates that require your attention', $open_quotes, 'cqpim'), $open_quotes),
						
					);
					
				}
				
				}
				
				// Check Projects
				
				$args = array(
				
					'post_type' => 'cqpim_project',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private',
				
				);
				
				$projects = get_posts($args);
				
				$unsigned_contracts = 0;
				
				foreach($projects as $project) {
				
					$project_details = get_post_meta($project->ID, 'project_details', true); 
					
					$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';
					
					$client_details = get_post_meta($client_id, 'client_details', true);

					$client_ids = get_post_meta($client_id, 'client_ids', true);
					
					$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
					
					$sent = isset($project_details['sent']) ? $project_details['sent'] : ''; 
					
					$confirmed = isset($project_details['confirmed']) ? $project_details['confirmed'] : '';
					
					if(empty($client_ids)) { $client_ids = array(); } 

					if($client_user_id == $user->ID && empty($confirmed) && !empty($sent) || in_array($user->ID, $client_ids) && empty($confirmed) && !empty($sent)) {

						$unsigned_contracts++;
					
					}
				
				}
				
				if($unsigned_contracts != 0) {
				
					$alerts[] = array(
					
						'type' => 'contract',
						
						'data' => sprintf(_n('You have %s contract that requires your attention', 'You have %s contracts that require your attention', $unsigned_contracts, 'cqpim'), $unsigned_contracts),
						
					);
					
				}
				
				// Check Tickets
				
				$user = wp_get_current_user();
				
				$args = array(
				
					'post_type' => 'cqpim_support',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private',
					
					'author__in' => $client_ids_untouched
				
				); 
				
				$tickets = get_posts($args);
				
				$unread_tickets = 0;

				foreach($tickets as $ticket) {
				
					$ticket_updated = get_post_meta($ticket->ID, 'unread', true);
					
					$ticket_status = get_post_meta($ticket->ID, 'ticket_status', true);
					
					if($ticket_updated == 1 && $ticket_status != 'resolved') {
					
						$unread_tickets++;
						
					}
				
				}
				
				if($unread_tickets != 0) {
				
					$alerts[] = array(
					
						'type' => 'support',
						
						'data' => sprintf(_n('You have %s open support ticket that requires your attention', 'You have %s open support tickets that require your attention', $unread_tickets, 'cqpim'), $unread_tickets),
						
					);
					
				}
				
				// Show the Alerts
				
				if(!empty($alerts)) {
				
					echo '<ul class="cqpim_alerts">';
				
					foreach($alerts as $alert) {
					
						echo '<li class="' . $alert['type'] . '">' . $alert['data'] . '</li>';
					
					}
					
					echo '</ul>';
				
				} else {
				
					echo '<p>' . __('You have no active alerts.', 'cqpim') . '</p>';
				
				}
						
				
			?>
			
		</div>
		
		</div>
		
		<?php  if(get_option('disable_invoices') != 1) { ?>
		
		<div class="cqpim-dash-item grid-item">
		
			<h3><?php _e('Outstanding Invoices', 'cqpim'); ?></h3>
			
			<div class="cqpim-dash-item-inside">
			
				<?php
				
					$args = array(
					
						'post_type' => 'cqpim_invoice',
						
						'posts_per_page' => -1,
						
						'post_status' => 'publish',
						
						'orderby' => 'date',
						
						'order' => 'DESC'
					
					);
					
					$invoices = get_posts($args);
					
					$currency = get_option('currency_symbol');
				
					echo '<table class="milestones dash">';
					
					echo '<thead>';
					
					echo '<tr><th>' . __('Invoice ID', 'cqpim') . '</th><th>' . __('Due Date', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr>';
					
					echo '</thead>';
					
					echo '<tbody>';
					
					$i = 0;
					
					foreach($invoices as $invoice) {
					
						$invoice_id = get_post_meta($invoice->ID, 'invoice_id', true);
					
						$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
						
						$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
						
						$client_details = get_post_meta($client_id, 'client_details', true);

						$client_ids = get_post_meta($client_id, 'client_ids', true);

						if(empty($client_ids)) {
						
							$client_ids = array();
							
						}									
			
						$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
						
						$invoice_totals = get_post_meta($invoice->ID, 'invoice_totals', true);
						
						$tax_rate = get_option('sales_tax_rate');
						
						if(!empty($tax_rate)) {
						
							$total = isset($invoice_totals['total']) ? $invoice_totals['total'] : '';
							
						} else {
						
							$total = isset($invoice_totals['sub']) ? $invoice_totals['sub'] : '';
							
						}					
						
						$invoice_date = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
										
						$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
							
						$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
							
						$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
						
						$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';
						
						$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
						
						if(empty($on_receipt)) {
						
							$due_readable = date('d/m/Y', $due);
							
						} else {
						
							$due_readable = __('Due on Receipt', 'cqpim');
							
						}
							
						$current_date = time();
							
						$link = get_the_permalink($invoice->ID);
						
						$password = md5($invoice->post_password);
						
						$url = $link;
							
						if(!$paid) {
							
							if($current_date > $due) {
							
								if(empty($on_receipt)) {
								
									$status = '<span class="task_over"><strong>' . __('Overdue', 'cqpim') . '</strong></span>';
									
								} else {
								
									$status = '<span class="task_over"><strong>' . __('On Receipt', 'cqpim') . '</strong></span>';
								
								}
									
							} else {
								
								if(!$sent) {
										
									$status = '<span class="task_over">' . __('New', 'cqpim') . '</span>';
										
								} else {
									
									$status = '<span class="task_pending">' . __('Outstanding', 'cqpim') . '</span>';
										
								}
									
							}
								
						} else {
								
							$status = '<span class="task_complete">' . __('Paid', 'cqpim') . '</span>';
								
						}		

						if($client_user_id == $user->ID && empty($paid) && !empty($sent) || in_array($user->ID, $client_ids) && empty($paid) && !empty($sent)) {
						
							echo '<tr>';
							
							echo '<td><span class="nodesktop"><strong>' . __('ID', 'cqpim') . '</strong>: </span> <a class="cqpim-link" href="' . $url . '" >' . $invoice_id . '</a></td>';

							echo '<td><span class="nodesktop"><strong>' . __('Due', 'cqpim') . '</strong>: </span> ' . $due_readable . '</td>';
								
							echo '<td><span class="nodesktop"><strong>' . __('Status', 'cqpim') . '</strong>: </span> ' . $status . '</td>';
							
							echo '</tr>';
								
							$i++;

						}
					
					}
					
					if($i == 0) {
					
						echo '<tr>';
						
						echo '<td colspan="3">' . __('You do not have any outstanding invoices', 'cqpim') . '</td>';
						
						echo '</tr>';
					
					}
					
					echo '</tbody>';
					
					echo '</table>';
					
				?>
				
			</div>
		
		</div>
		
		<?php } ?>
		
		<!--<div class="cqpim-dash-item-double grid-item">
		
			<h3>New Messages</h3>
			
			<p>Messages</p>
		
		</div>-->
		
		<?php if(get_option('enable_quotes') == 1) { ?>
		
		<div class="cqpim-dash-item grid-item">
		
			<h3><?php _e('Open Quotes / Estimates', 'cqpim'); ?></h3>
			
			<div class="cqpim-dash-item-inside">
			
			<table class="milestones dash">

				<thead>
				
					<tr>
					
						<th><?php _e('Title', 'cqpim'); ?></th>
						
						<th><?php _e('Status', 'cqpim'); ?></th>
					
					</tr>
					
				</thead>

				<tbody>
	
					<?php 
					
					$args = array(
					
						'post_type' => 'cqpim_quote',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private',
					
					);
					
					$quotes = get_posts($args);
					
					$i = 0;
					
					foreach($quotes as $quote) { 
					
						$url = get_the_permalink($quote->ID); 
						
						$quote_details = get_post_meta($quote->ID, 'quote_details', true); 
						
						$client_id = isset($quote_details['client_id']) ? $quote_details['client_id'] : '';
						
						$client_details = get_post_meta($client_id, 'client_details', true);

						$client_ids = get_post_meta($client_id, 'client_ids', true);

						if(empty($client_ids)) {
						
							$client_ids = array();
							
						}								
						
						$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
						
						$sent = isset($quote_details['sent']) ? $quote_details['sent'] : ''; 
						
						$confirmed = isset($quote_details['confirmed']) ? $quote_details['confirmed'] : ''; 
						
						if(!$confirmed) {
						
							if(!$sent) {
							
								$status = '<span class="task_over">' . __('Not Sent', 'cqpim') . '</span>';
							
							} else {
							
								$status = '<span class="task_pending">' . __('New', 'cqpim') . '</span>';
							
							}
						
						} else {
						
							$status = '<span class="task_complete">' . __('Accepted', 'cqpim') . '</span>';
							
						}
						
						if($client_user_id == $user->ID && empty($confirmed) && !empty($sent) || in_array($user->ID, $client_ids) && empty($confirmed) && !empty($sent)) {
						
						?>						

							<tr>	
							
								<td><span class="nodesktop"><strong><?php _e('Title', 'cqpim'); ?></strong>: </span> <a class="cqpim-link" href="<?php echo $url; ?>?page=quote"><?php echo $quote->post_title; ?></a></td>
																		
								<td><span class="nodesktop"><strong><?php _e('Status', 'cqpim'); ?></strong>: </span> <?php echo $status; ?></td>
							
							</tr>
						
						<?php 
						
							$i++;
						
						}
					
					} 
					
					if($i == 0) {
					
						echo '<tr><td>' . __('You do not have any open quotes', 'cqpim') . '</td><td></td></tr>';
					
					}
												
					?>
										
				</tbody>
			
			</table>					
			
			</div>
		
		</div>
		
		<?php } ?>
		
		<div class="cqpim-dash-item-double grid-item">
		
			<h3><?php _e('Open Projects', 'cqpim'); ?></h3>
			
			<div class="cqpim-dash-item-inside">
			
			<table class="milestones dash">

				<thead>
				
					<tr>
					
						<th><?php _e('Owner', 'cqpim'); ?></th>
					
						<th><?php _e('Title', 'cqpim'); ?></th>
						
						<th><?php _e('Progress', 'cqpim'); ?></th>
						
						<?php $checked = get_option('enable_project_contracts'); 
								
						if(!empty($checked)) { ?>
						
							<th><?php _e('Contract', 'cqpim'); ?></th>
						
						<?php } ?>
						
						<th><?php _e('Status', 'cqpim'); ?></th>
					
					</tr>
					
				</thead>

				<tbody>
	
					<?php 
					
					$args = array(
					
						'post_type' => 'cqpim_project',
						
						'posts_per_page' => -1,
						
						'post_status' => 'private',
					
					);
					
					$projects = get_posts($args);
					
					$i = 0;
					
					foreach($projects as $project) { 
					
						$url = get_the_permalink($project->ID); 
						
						$summary = $url . '?page=summary&sub=updates';
						
						$contract = $url . '?page=contract';
						
						$project_details = get_post_meta($project->ID, 'project_details', true); 
						
						$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';
						
						$client_contact = isset($project_details['client_contact']) ? $project_details['client_contact'] : '';
						
						$owner = get_user_by('id', $client_contact);
						
						$client_details = get_post_meta($client_id, 'client_details', true);

						$client_ids = get_post_meta($client_id, 'client_ids', true);								
						
						$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
						
						$sent = isset($project_details['sent']) ? $project_details['sent'] : ''; 
						
						$confirmed = isset($project_details['confirmed']) ? $project_details['confirmed'] : ''; 
						
						$signoff = isset($project_details['signoff']) ? $project_details['signoff'] : ''; 
						
						$closed = isset($project_details['closed']) ? $project_details['closed'] : ''; 
						
						$finish_date = isset($project_details['finish_date']) ? $project_details['finish_date'] : '';
												
						$str_finish_date = str_replace('/','-', $finish_date);
						
						$unix_finish_date = strtotime($str_finish_date);
						
						$current_date = time();
						
						$days_to_due = round(abs($current_date - $unix_finish_date) / 86400);
						
						$project_elements = get_post_meta($project->ID, 'project_elements', true); 
						
						if(empty($project_elements)) {
						
							$project_elements = array();
							
						}
						
						$task_count = 0;
						
						$task_total_count = 0;
						
						$task_complete_count = 0;
						
						foreach ($project_elements as $element) {
						
							$args = array(
							
								'post_type' => 'cqpim_tasks',
								
								'posts_per_page' => -1,
								
								'meta_key' => 'milestone_id',
								
								'meta_value' => $element['id'],
								
								'orderby' => 'date',
								
								'order' => 'ASC'
								
							);
							
							$tasks = get_posts($args);	
							
							foreach($tasks as $task) {
							
								$task_total_count++;
							
								$task_details = get_post_meta($task->ID, 'task_details', true);
								
								if($task_details['status'] != 'complete') {
								
									$task_count++;
								
								}
								
								if($task_details['status'] == 'complete') {
								
									$task_complete_count++;
								
								}
							
							}
						
						}
						
						if($task_total_count != 0) {
						
							$pc_per_task = 100 / $task_total_count;
						
							$pc_complete = $pc_per_task * $task_complete_count;
						
						} else {
						
							$pc_complete = 0;
						
						}
						
						if(!$closed) {
						
							if(!$signoff) {
							
								if(!$confirmed) {
								
									if(!$sent) {
									
										$status = '<span class="task_over">' . __('New', 'cqpim') . '</span>';
									
									} else {
									
										$checked = get_option('enable_project_contracts'); 
										
										if(!empty($checked)) {
									
											$status = '<span class="task_pending">' . __('Awaiting Contracts', 'cqpim') . '</span>';
											
										} else {
										
											$status = '<span class="task_complete">' . __('In Progress', 'cqpim') . '</span>';
										
										}
									
									}
								
								} else {
								
									$status = '<span class="task_complete">' . __('In Progress', 'cqpim') . '</span>';
									
								}
								
							} else {
							
								$status = '<span class="task_complete">' . __('Signed Off', 'cqpim') . '</span>';
							
							}
						
						} else {
						
							$status = '<span style="background:#333" class="task_complete">' . __('Closed', 'cqpim') . '</span>';
						
						}
						
						if(empty($client_ids)) { $client_ids = array(); }
						
						if($client_user_id == $user->ID && empty($closed) || in_array($user->ID, $client_ids) && empty($closed)) {
						
						?>						

							<tr>
						
								<td><span class="nodesktop"><strong><?php _e('Owner', 'cqpim'); ?></strong>: </span> <?php echo isset($owner->display_name) ? $owner->display_name : ''; ?></td>
							
								<td><span class="nodesktop"><strong><?php _e('Title', 'cqpim'); ?></strong>: </span> <a class="cqpim-link" href="<?php echo $summary; ?>"><?php echo $project->post_title; ?></a></td>
											
								<td><span class="nodesktop"><strong><?php _e('Progress', 'cqpim'); ?></strong>: </span> <?php echo number_format((float)$pc_complete, 2, '.', ''); ?>%</td>

								<?php $checked = get_option('enable_project_contracts'); 
								
								if(!empty($checked)) { ?>
								
									<td><span class="nodesktop"><strong><?php _e('Contract', 'cqpim'); ?></strong>: </span> <a class="cqpim-link" href="<?php echo $contract; ?>"><?php _e('View', 'cqpim'); ?></a></td>
								
								<?php } ?>
								
								<td><span class="nodesktop"><strong><?php _e('Status', 'cqpim'); ?></strong>: </span> <?php echo $status; ?></td>
							
							</tr>
						
						<?php 
						
							$i++;
						
						}
					
					} 
					
					if($i == 0) {
					
						echo '<tr><td>' . __('You do not have any open projects', 'cqpim') . '</td><td></td><td></td><td></td><td></td></tr>';
					
					}
												
					?>
										
				</tbody>
			
			</table>
			
			</div>
		
		</div>
		
		<div class="cqpim-dash-item grid-item">
		
			<h3><?php _e('Project Updates', 'cqpim'); ?></h3>
			
			<div class="cqpim-dash-item-inside" style="max-height:500px; overflow:auto">
			
			<?php 
			
				$args = array(
				
					'post_type' => 'cqpim_project',
					
					'post_status' => 'private',
					
					'posts_per_page' => -1
				
				);
				
				$projects = get_posts($args);
				
				$updates = array();
				
				foreach($projects as $project) {
				
					$project_details = get_post_meta($project->ID, 'project_details', true);
					
					$client_id = isset($project_details['client_id']) ? $project_details['client_id'] : '';
					
					$client_details = get_post_meta($client_id, 'client_details', true);

					$client_ids = get_post_meta($client_id, 'client_ids', true);							
					
					$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
					
					if(empty($client_ids)) { $client_ids = array(); }
					
					if($client_user_id == $user->ID || in_array($user->ID, $client_ids)) {
					
						$project_updates = get_post_meta($project->ID, 'project_progress', true);
						
						if(empty($project_updates)) {
						
							$project_updates = array();
							
						}
						
						$i = 0;
						
						foreach($project_updates as $update) {
						
							if(!is_numeric($update['date'])) {
							
								$str_deadline = str_replace('/','-', $update['date']);
							
								$date_stamp = strtotime($str_deadline);
							
							} else {
							
								$date_stamp = $update['date'];
								
							}								
						
							$updates[$date_stamp . $i] = array(
							
								'pid' => $project->ID,
							
								'by' => $update['by'],
								
								'date' => $update['date'],
								
								'update' => $update['update'],
							
							);
							
							$i++;
						
						}
					
					}
				
				}
				
				ksort($updates);
				
				$updates = array_reverse($updates);
				
				echo '<ul class="project_summary_progress">';
			
				foreach($updates as $pupdate) {
				
					$project_details = get_post_meta($pupdate['pid'], 'project_details', true);
					
					$url = get_the_permalink($pupdate['pid']);
					
					$project_ref = isset($project_details['quote_ref']) ? $project_details['quote_ref'] : '';
					
					if(is_numeric($pupdate['date'])) { $pupdate['date'] = date(get_option('cqpim_date_format') . ' H:i', $pupdate['date']); } else { $pupdate['date'] = $pupdate['date']; }
				
					echo '<li>';
					
					echo '<div class="timeline-entry">';
					
					echo '<span class="timeline-by">' . $pupdate['by'] . '</span>';
					
					echo '<span class="timeline-date">' . $pupdate['date'] . '</span>';
					
					echo '<span class="timeline-update"><a class="cqpim-link" href="' . $url . '?page=summary&sub=updates">Project ' . $project_ref . '</a> - ' . $pupdate['update'] . '</span>';
					
					echo '</div>';
					
					echo '</li>';
				
				}
				
				echo '</ul>';
				
				if(empty($updates)) {
				
					echo '<p>' . __('There are no project updates to show.', 'cqpim') . '</p>';
				
				}
			
			?>
			
			</div>
		
		</div>
		
		<div class="cqpim-dash-item-double grid-item">
		
			<h3><?php _e('Open Support Tickets', 'cqpim'); ?> <a href="<?php echo get_the_permalink($client_dash) . '?page=add-support-ticket'; ?>" class="cqpim-dash-button right"><?php _e('Add Support Ticket', 'cqpim'); ?></a></h3>
			
			<div class="cqpim-dash-item-inside">
		
				<?php 
				
				$user = wp_get_current_user();
				
				$args = array(
				
					'post_type' => 'cqpim_support',
					
					'posts_per_page' => -1,
					
					'post_status' => 'private',
					
					'author__in' => $client_ids_untouched
				
				); 
				
				$tickets = get_posts($args);
				
				$total_tickets = count($tickets);
				
				if($tickets) {
				
					$i = 0;
				
					echo '<table class="milestones files dash">';
					
					echo '<thead><tr><th>' . __('Ticket Title', 'cqpim') . '</th><th>' . __('Owner', 'cqpim') . '</th><th>' . __('Priority', 'cqpim') . '</th><th>' . __('Last Updated', 'cqpim') . '</th></tr></thead>';
					
					echo '<tbody>';
				
					foreach($tickets as $ticket) {
					
						$ticket_status = get_post_meta($ticket->ID, 'ticket_status', true);
						
						$owner = get_user_by('id', $ticket->post_author);
						
						if($ticket_status == 'open') {
						
							$tstatus = '<span class="low_priority">' . __('Open', 'cqpim') . '</span>';
						
						} else if($ticket_status == 'resolved') {
						
							$tstatus = '<span class="task_complete">' . __('Resolved', 'cqpim') . '</span>';
						
						} else if($ticket_status == 'hold') {
						
							$tstatus = '<span class="high_priority">' . __('On Hold', 'cqpim') . '</span>';
						
						}
						
						$ticket_priority = get_post_meta($ticket->ID, 'ticket_priority', true);
						
						$ticket_updated = get_post_meta($ticket->ID, 'last_updated', true);
						
						if(is_numeric($ticket_updated)) { $ticket_updated = date(get_option('cqpim_date_format') . ' H:i', $ticket_updated); } else { $ticket_updated = $ticket_updated; }
						
						if($ticket_priority == 'low') {
						
							$priority = '<span class="low_priority">' . __('Low', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'normal') {
						
							$priority = '<span class="normal_priority">' . __('Normal', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'high') {
						
							$priority = '<span class="high_priority">' . __('High', 'cqpim') . '</span>';
						
						} else if($ticket_priority == 'immediate') {
						
							$priority = '<span class="immediate_priority">' . __('Immediate', 'cqpim') . '</span>';
						
						}
						
						if($ticket_status == 'open') {
					
							echo '<tr>';
			
							echo '<td><span class="nodesktop"><strong>' . __('Title', 'cqpim') . '</strong>: </span> <a class="cqpim-link" href="' . get_the_permalink($ticket->ID) . '">' . $ticket->post_title . '</a></td>';
							
							echo '<td><span class="nodesktop"><strong>' . __('Owner', 'cqpim') . '</strong>: </span> ' . $owner->display_name . '</td>';
							
							echo '<td><span class="nodesktop"><strong>' . __('Priority', 'cqpim') . '</strong>: </span> ' . $priority . '</td>';
							
							echo '<td><span class="nodesktop"><strong>' . __('Updated', 'cqpim') . '</strong>: </span> ' . $ticket_updated . '</td>';
							
							echo '</tr>';
							
							$i++;
						
						}
					
					}
					
					if($i == 0) {
					
						echo '<tr>';
		
						echo '<td colspan="3">You do not have any open support tickets</td>';
														
						echo '</tr>';							
					
					}
					
					echo '</tbody>';
					
					echo '</table>';
					
				}
				
				?>
				
				<div class="clear"></div>
		
			</div>
		
		</div>
		
	</div>